<?php defined('SYSPATH') or die('No direct script access.'); 
  /**
 * Custom exception handler for typical 404/500 error
 */ 
class Kohana_Exception extends Kohana_Kohana_Exception 
{ 
    public static function handler(Exception $e) 
    { 
        // Throw errors when in development mode 
        if (Kohana::$environment === Kohana::DEVELOPMENT) 
        { 
            parent::handler($e); 
        } 
        else 
        { 
			Kohana::$log->add(Log::ERROR, Kohana_Exception::text($e)); 
            $attributes = array( 
                'errornumber' => 500, 
                'originaluri' => Arr::get($_SERVER, 'REQUEST_URI'), 
                'message' => $e->getMessage()
            ); 
 
            if ($e instanceof Http_Exception) 
            { 
                $attributes['errornumber'] = $e->getCode(); 
            }
			try {
				$session = session::instance();
				$session->set('exception',$attributes);
				$routeargs = array('controller'=>'error','id'=>$attributes['errornumber']);
				$route = Route::get('error')->uri($routeargs);
				echo Request::factory($route)
					->execute() 
					->send_headers() 
					->body(); 
			}
			catch (Exception $e)
			{
				var_dump($e->getMessage());
				var_dump($e->getTraceAsString());
			}
        } 
    } 
}