/*
Gargoyle components (dlwindows.js) copyright (c) 2007 - 2011 Henrik Bechmann, bechmann.ca, 
	Bechmann Software Services, Toronto Canada, all rights reserved.
website: www.dlml.org/gargoyle
licence: BSD
dl = "dynamic layout"
*/
/*
- animate status buttons
- synchronize panes
- synchronize windows
- ajax everywhere
- drag & drop
*/
//================[ WINDOWS ]=====================//

WindowsManager = new (DLPrototype({
$extends:DLModule,
$prototype:{
 name:"WindowsManager",
 metadata:{ATTRIBUTES:['dlprototype'],PARSERS:{dlprototype:DLParse.jsonproperty('dlprototypes')}},
 initialize: function () {
	var element = document.createElement('dl:object');
	if (this.dlprototypes) {
		var self = this;
		$.each(this.dlprototypes,function (slot,value) {
			var $dlobject = $('#' + slot);
			$dlobject.removeAttr('id');
			var dlprototype = self.dlprototypes[slot];
			if (dlprototype.action == 'clone') {
				dlprototype.dlml = $dlobject.clone().get(0);
			} else {
				dlprototype.dlml = $dlobject.detach().get(0);
			}
		});
	}
 },
 createobject: function (dlobjectid,dlplatformid) {
	var $context = $('#' + dlplatformid);
	var context = $context.get(0);
	var dlml = this.dlprototypes[dlobjectid].dlml;
	var $dlml = $(dlml).clone();
	$context.append($dlml);
	DLManager.setdatamodel(context);
	var platformid = $context.attr('dlobjectid');
	var platform = DLManager.objects[platformid];
	var length = platform.children.length;
	var object = platform.children[platform.children.length-1];
	$(object.elements.frame).css('z-index',length * 10);
}
}}))();

Windows = DLPrototype({
$extends:DLPlatform,
$prototype:{
	type:'Windows',
	html:'<div class="windows"></div>',
	focus: function(dlwindowobject) {
		var children = this.children, childindex, length;
		childindex = children.indexOf(dlwindowobject);
		length = children.length;
		if (childindex != (children.length - 1)) {
			children.removeItem(dlwindowobject);
			children.push(dlwindowobject);
			var length = children.length;
			for (var i=0;i<length;i++) {
				var object = children[i];
				object.elements && $(object.elements.frame).css('z-index',(i + 1)*10);
			};
		}
	}
}
});

Window = DLPrototype({
$constructor: function () {
	this.dlonclose = 'destroy';
},
$extends:DLContainer,
$prototype:{
	type:'Window',
	html:
'<div class="window">' + 
	'<div dlindex="box" class="window-box"><div dlindex="liner" class="window-liner"></div></div>\n' + 
	'<div dlindex="borderleft" class="window-border-left">\n' + 
		'<div class="window-border-left-box"></div></div>\n' + 
	'<div dlindex="cornertopleftvertical" class="window-corner-topleft-vertical">\n' + 
		'<div class="window-corner-topleft-vertical-box"></div></div>\n' + 
	'<div dlindex="cornertoplefthorizontal"  class="window-corner-topleft-horizontal">\n' + 
		'<div class="window-corner-topleft-horizontal-box"></div></div>\n' + 
	'<div dlindex="bordertop" class="window-border-top">\n' + 
		'<div class="window-border-top-box"></div></div>\n' + 
	'<div dlindex="cornertoprighthorizontal" class="window-corner-topright-horizontal">\n' + 
		'<div class="window-corner-topright-horizontal-box"></div></div>\n' + 
	'<div dlindex="cornertoprightvertical"  class="window-corner-topright-vertical">\n' + 
		'<div  class="window-corner-topright-vertical-box"></div></div>\n' + 
	'<div dlindex="borderright" class="window-border-right">\n' + 
		'<div class="window-border-right-box"></div></div>\n' + 
	'<div dlindex="cornerbottomrighthorizontal" class="window-corner-bottomright-horizontal">\n' + 
		'<div class="window-corner-bottomright-horizontal-box"></div></div>\n' + 
	'<div dlindex="cornerbottomrightvertical" class="window-corner-bottomright-vertical">\n' + 
		'<div class="window-corner-bottomright-vertical-box"></div></div>\n' + 
	'<div dlindex="borderbottom" class="window-border-bottom">\n' + 
		'<div class="window-border-bottom-box"></div></div>v' + 
	'<div dlindex="cornerbottomlefthorizontal" class="window-corner-bottomleft-horizontal">\n' + 
		'<div class="window-corner-bottomleft-horizontal-box"></div></div>\n' + 
	'<div dlindex="cornerbottomleftvertical" class="window-corner-bottomleft-vertical">\n' + 
		'<div class="window-corner-bottomleft-vertical-box"></div></div>\n' + 
'</div>\n',
	metadata:DLServices.extend(DLServices.clone(DLData.styleattributetree),
		{ATTRIBUTES:['dlonclose']}),
	initialize: function () {
		var elements = this.elements;
		$(elements.frame).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornertopleftvertical).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornertopleftvertical).bind('mousedown',this.resizetrigger('startresize','nw'));
		$(elements.cornertoplefthorizontal).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornertoplefthorizontal).bind('mousedown',this.resizetrigger('startresize','nw'));
		$(elements.bordertop).bind('mousedown',this.focustrigger('focus'));
		$(elements.bordertop).bind('mousedown',this.resizetrigger('startresize','n'));
		$(elements.cornertoprighthorizontal).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornertoprighthorizontal).bind('mousedown',this.resizetrigger('startresize','ne'));
		$(elements.cornertoprightvertical).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornertoprightvertical).bind('mousedown',this.resizetrigger('startresize','ne'));
		$(elements.borderright).bind('mousedown',this.focustrigger('focus'));
		$(elements.borderright).bind('mousedown',this.resizetrigger('startresize','e'));
		$(elements.cornerbottomrightvertical).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornerbottomrightvertical).bind('mousedown',this.resizetrigger('startresize','se'));
		$(elements.cornerbottomrighthorizontal).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornerbottomrighthorizontal).bind('mousedown',this.resizetrigger('startresize','se'));
		$(elements.borderbottom).bind('mousedown',this.focustrigger('focus'));
		$(elements.borderbottom).bind('mousedown',this.resizetrigger('startresize','s'));
		$(elements.cornerbottomlefthorizontal).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornerbottomlefthorizontal).bind('mousedown',this.resizetrigger('startresize','sw'));
		$(elements.cornerbottomleftvertical).bind('mousedown',this.focustrigger('focus'));
		$(elements.cornerbottomleftvertical).bind('mousedown',this.resizetrigger('startresize','sw'));
		$(elements.borderleft).bind('mousedown',this.focustrigger('focus'));
		$(elements.borderleft).bind('mousedown',this.resizetrigger('startresize','w'));
	},
	focustrigger: DLCallTrigger,
	focus: function (data) {
		var event = data.event;
		this.platform.focus(this);
	},
	resizetrigger: function(action,sector) {
		var self = this;
		return function (event) {
				event.preventDefault();
				event.stopPropagation();
				event.stopImmediatePropagation();
				self[action]({event:event,sector:sector});
				return false;
			}
	},
	startresize: function (data) {
		var event = data.event, $frame = $(this.elements.frame), offset = $frame.offset();
		this.resizedata = 
			{
				starttop:parseInt($frame.css("top")),
				startleft:parseInt($frame.css("left")),
				startheight:$frame.height(),
				startwidth:$frame.width(),
				startx:event.pageX,
				starty:event.pageY,
				offsettop:offset.top,
				offsetleft:offset.left,
				sector:data.sector
			};
		$(document).bind("mousemove.resize",DLActionTrigger.call(this,'resize'));
		$(document).bind("mouseup.resize",DLActionTrigger.call(this,'stopresize'));
		this.notify('startresize');
	},
	resize: function (data) {
		var event = data.event;
		if (!this.resizedata) return;
		var diffx, diffy, newtop, newleft, newheight, newwidth, 
			resizedata = this.resizedata, sector = resizedata.sector, 
			frame = this.elements.frame, $frame = $(frame);
		diffx = event.pageX - resizedata.startx;
		diffy = event.pageY - resizedata.starty;
		// process n or s
		switch (sector) {
			case 'n':
			case 'nw':
			case 'ne':
				// process north
				if ((resizedata.offsettop + diffy) < 0) diffy = -resizedata.offsettop;
				newtop = resizedata.starttop + diffy;
				newheight = resizedata.startheight + (-diffy);
				frame.style.top = (newtop + 'px'); // direct assignment to improve performance
				$frame.height(newheight);
				break;
			case 's':
			case 'sw':
			case 'se':
				// process south
				newheight = resizedata.startheight + diffy;
				$frame.height(newheight);
				break;
		}
		// process e or w
		switch (sector) {
			case 'e':
			case 'se':
			case 'ne':
				// precess east
				newwidth = resizedata.startwidth + (diffx);
				$frame.width(newwidth);
				break;
			case 'w':
			case 'sw':
			case 'nw':
				// process west
				if ((resizedata.offsetleft + diffx) < 0) diffx = -resizedata.offsetleft;
				newleft = resizedata.startleft + diffx;
				newwidth = resizedata.startwidth + (-diffx);
				frame.style.left = (newleft + 'px');
				$frame.width(newwidth);
				break;
		}
		this.notify('resize');
	},
	stopresize: function (data) {
		$(document).unbind("mousemove.resize");
		$(document).unbind("mouseup.resize");
		delete this.resizedata;
		this.notify('stopresize');
	},
	startdrag: function(data) {
		var event = data.event;
		var frame = this.elements.frame, $frame = $(frame), offset = $frame.offset();
		this.dragdata = 
			{
				starttop:parseInt($frame.css("top")),
				startleft:parseInt($frame.css("left")),
				startx:event.pageX,
				starty:event.pageY,
				offsettop:offset.top,
				offsetleft:offset.left
			};
		$(document).bind("mousemove.drag",DLActionTrigger.call(this,'drag'));
		$(document).bind("mouseup.drag",DLActionTrigger.call(this,'stopdrag'));
	},
	drag: function(data) {
		var event = data.event;
		if (!this.dragdata) return;
		var diffx,diffy,newtop,newleft, offset,
			dragdata = this.dragdata, frame = this.elements.frame, $frame = $(frame);
		diffx = event.pageX - dragdata.startx;
		diffy = event.pageY - dragdata.starty;
		newtop = dragdata.starttop + diffy;
		newleft = dragdata.startleft + diffx;
		frame.style.top = (newtop + 'px'); // direct assignment to improve performance
		frame.style.left = (newleft + 'px');
		offset = $frame.offset();
		if (offset.top < 0) $frame.css("top",(dragdata.starttop - dragdata.offsettop)+'px');
		if (offset.left < 0) $frame.css("left",(dragdata.startleft - dragdata.offsetleft)+'px');
	},
	stopdrag: function(data) {
		$(document).unbind("mousemove.drag");
		$(document).unbind("mouseup.drag");
		delete this.dragdata;
	},
	close: function (data) {
		if (this.dlonclose == 'hide') {
			$(this.elements.frame).fadeOut('fast');
		} else {
			DLManager.destroyobject(this);
		}
	}
}
});

ExplorerWindow = DLPrototype({
$extends:Window,
$prototype:{
	type:'ExplorerWindow'
}
});

WindowTitle = DLPrototype({
$extends:DLObject,
$prototype:{
	type:'WindowTitle',
	html:
'<div class="windowtitle"><div dlindex="box" class="windowtitle-box">\n' + 
	'<div dlindex="liner" class="windowtitle-liner"></div>\n' +
'</div></div>\n',
	initialize:function() {
		$(this.elements.frame).bind('mousedown',this.container.focustrigger('focus'));
		$(this.elements.frame).bind("mousedown",DLActionTrigger.call(this.container,'startdrag'));
	}
}
});

WindowSubtitle = DLPrototype({
$extends:DLObject,
$prototype:{
	type:'WindowSubtitle',
	html:'<div class="windowsubtitle"></div>\n',
	initialize: function () {
		this.container.registercomponent('subtitle',this);
	}
}
});

WindowControl = DLPrototype({
$extends:DLObject,
$prototype:{
	type:'WindowControl',
	html:'<div class="windowcontrol"></div>\n',
	metadata: {ATTRIBUTES:['dlaction','dlattribute'],PARSERS:{dlattribute:DLParse.dlattribute}},
	initialize: function () {
		this.dlaction && $(this.elements.frame).addClass(this.dlaction);
		var self = this;
		if (this.dlaction == 'close') {
			$(this.elements.frame).bind("click",function(event) {
				event.preventDefault();
				event.stopPropagation();
				event.stopImmediatePropagation();
				self.container.close(event);
			});
		}
	}
}
});

WindowStatus = DLPrototype({
$extends:DLObject,
$prototype:{
	type:'WindowStatus',
	html:
'<div class="windowstatus">' + 
	'<div class="windowstatus-box" dlindex="box">' + 
		'<div class="windowstatus-liner">' + 
'</div></div></div>'
}
});

WindowContent = DLPrototype({
$extends:DLObject,
$prototype:{
	type:'WindowContent',
	html:'<div class="windowcontent"></div>'
}
});

WindowSectionPair = DLPrototype({
$extends:DLObject,
$constructor: function () {
	this.dlorientation = 'horizontal';
},
$prototype:{
	type:'WindowSectionPair',
	html:'<div class="windowsectionpair"></div>',
	metadata:{ATTRIBUTES:['dlorientation','dlsplitteroffset'],PARSERS:{dlsplitteroffset:DLParse.number}},
	initialize:function () {
		var children = this.children, 
			leftside, $leftside, splitter, $splitter, rightside, $rightside,
			$frame, orientation, width, height, splitterthickness, splitteroffset;
		if (children.length != 3) return;
		leftside = children[0];
		splitter = children[1];
		rightside = children[2];
		if (!((leftside instanceof WindowSection) && 
			(splitter instanceof WindowSplitter) && 
			(rightside instanceof WindowSection))) return;
		this.leftside = leftside;
		this.rightside = rightside;
		this.splitter = splitter;
		orientation = this.dlorientation;
		orientation == 'horizontal' || orientation == 'vertical' || (orientation = 'horizontal');
		(this.dlorientation == orientation) || (this.dlorientation = orientation);
		$frame = $(this.elements.frame).addClass(orientation);
		$leftside = $(leftside.elements.frame).addClass('left');
		$rightside = $(rightside.elements.frame).addClass('right');
		$splitter = $(splitter.elements.frame);
		if (orientation == 'horizontal') {
			splitteroffset = this.dlsplitteroffset;
			splitterthickness = $splitter.width();
			width = $frame.width();
			splitteroffset || (splitteroffset = (Math.round(width/2) - Math.round(splitterthickness/2)));
			$leftside.width(splitteroffset);
			$rightside.width(width - $leftside.width() - splitterthickness);
			$splitter.css("left",$leftside.width()+'px');
		} else { // vertical
			splitterthickness = $splitter.height();
			height = $frame.height();
			splitteroffset || (splitteroffset = (Math.round(height/2) - Math.round(splitterthickness/2)));
			$leftside.height(splitteroffset);
			$rightside.height(height - $leftside.height() - splitterthickness);
			$splitter.css("top",$leftside.height()+'px');
		}
		var container = this.parent; // window
		while (!((container instanceof WindowSectionPair) || (container instanceof Window)))
			container = container.parent;
		container.subscribe('startresize', this);
		container.subscribe('resize', this);
		container.subscribe('stopresize', this);
	},
	act: function (action, data) {
		this[action](data);
	},
	startsplit: function (data) {
		var event = data.event;
		var $frame = $(this.elements.frame), $splitter = $(this.splitter.elements.frame);
		this.splitdata = {
			orientation:this.dlorientation,
			framesize:(this.dlorientation == "horizontal")? $frame.width(): $frame.height(),
			splittersize:(this.dlorientation == "horizontal")? $splitter.width(): $splitter.height(),
			splitteroffset:(this.dlorientation == "horizontal")? parseInt($splitter.css("left")):parseInt($splitter.css("top")),
			startx:event.pageX,
			starty:event.pageY
		}
		$(document).bind('mousemove.split',DLActionTrigger.call(this,'split'));
		$(document).bind('mouseup.split',DLActionTrigger.call(this,'stopsplit'));
		this.notify('startresize');
	},
	split: function (data) {
		var event = data.event;
		var diffx, diffy, newoffset, orientation, splitdata = this.splitdata;
		var limit = 20; // ** parameterize this!
		diffx = event.pageX - splitdata.startx;
		diffy = event.pageY - splitdata.starty;
		orientation = this.splitdata.orientation;
		if (orientation == "horizontal") {
			newoffset = splitdata.splitteroffset + diffx;
			if (newoffset > (splitdata.framesize - limit)) newoffset = (splitdata.framesize - limit);
			if (newoffset < (limit)) newoffset = limit;
			this.splitter.elements.frame.style.left = (newoffset + "px");
			$(this.leftside.elements.frame).width(newoffset);
			$(this.rightside.elements.frame).width(splitdata.framesize - (newoffset + splitdata.splittersize));
		} else { // vertical
			newoffset = splitdata.splitteroffset + diffy;
			if (newoffset > (splitdata.framesize - limit)) newoffset = (splitdata.framesize - limit);
			if (newoffset < (limit)) newoffset = limit;
			this.splitter.elements.frame.style.top = (newoffset + "px");
			$(this.leftside.elements.frame).height(newoffset);
			$(this.rightside.elements.frame).height(splitdata.framesize - (newoffset + splitdata.splittersize));
		}
		this.notify('resize');
	},
	stopsplit: function (event) {
		$(document).unbind('mousemove.split');
		$(document).unbind('mouseup.split');
		delete this.splitdata;
		this.notify('stopresize');
	},
	startresize: function (data) {
		var $frame = $(this.elements.frame), 
			$leftside = $(this.leftside.elements.frame),
			$splitter = $(this.splitter.elements.frame);
		this.resizedata = {
			orientation:this.dlorientation,
			framesize:(this.dlorientation == "horizontal")? $frame.width(): $frame.height(),
			leftsize:(this.dlorientation == "horizontal")? $leftside.width(): $leftside.height(),
			splittersize:(this.dlorientation == "horizontal")? $splitter.width(): $splitter.height()
		}
		this.notify('startresize');
	},
	resize: function (data) {
		var resizedata = this.resizedata,
			framesize, newleftsize;
		if (resizedata.orientation == "horizontal") {
			framesize = $(this.elements.frame).width();
			newleftsize = Math.round(resizedata.leftsize * (framesize/resizedata.framesize));
			this.leftside.elements.frame.style.width = newleftsize + "px";
			this.splitter.elements.frame.style.left = newleftsize + "px";
			this.rightside.elements.frame.style.width = (framesize - (newleftsize + resizedata.splittersize)) + "px";
		} else { // vertical
			framesize = $(this.elements.frame).height();
			newleftsize = Math.round(resizedata.leftsize * (framesize/resizedata.framesize));
			this.leftside.elements.frame.style.height = newleftsize + "px";
			this.splitter.elements.frame.style.top = newleftsize + "px";
			this.rightside.elements.frame.style.height = (framesize - (newleftsize + resizedata.splittersize)) + "px";
		}
		this.notify('resize');
	},
	stopresize: function (data) {
		delete this.resizedata;
		this.notify('stopresize');
	},
	destroy: function () {
		delete this.leftside;
		delete this.rightside;
		delete this.splitter;
	}
}
});

WindowSection = DLPrototype({
$extends:DLObject,
$prototype:{
	type:'WindowSection',
	html:'<div class="windowsection"></div>'
}
});

WindowSplitter = DLPrototype({
$extends:DLObject,
$prototype:{
	type:'WindowSplitter',
	html:
	'<div class="windowsplitter">\n' + 
		'<div class="windowsplitter-box" dlindex="box">\n' + 
			'<div class="windowsplitter-liner"></div>\n' + 
	'</div></div>\n',
	initialize: function () {
		$(this.elements.frame).bind('mousedown',this.container.focustrigger('focus'));
		$(this.elements.frame).bind('mousedown',DLActionTrigger.call(this.parent,'startsplit')); // parent = WindowSectionPair (always)
	}
}
});

WindowPane = DLPrototype({
$extends:DLObject,
$constructor: function () {
	this.dldock=false;
},
$prototype:{
	type:'WindowPane',
	html:'<div class="windowpane"><div class="windowpane-box" dlindex="box"><div class="windowpane-liner"></div></div></div>\n',
	metadata:{ATTRIBUTES:['dldock'],PARSERS:{dldock:DLParse['boolean']}},
	initialize: function () {
		if (this.dldock)
			$(this.elements.frame).addClass('dock');
	}
}
});
// link to parent container; set parent to call frame onresize; resize iframe to fit container.
WindowFrame = DLPrototype({
$extends:DLObject,
$prototype:{
	type:'WindowFrame',
	metadata:DLData.commonattributetree,
	html:'<iframe class="iframe"></iframe>\n'
}
});
WindowsManager.register(
[
Windows,
Window,
ExplorerWindow,
WindowTitle,
WindowSubtitle,
WindowControl,
WindowContent,
WindowStatus,
WindowSectionPair,
WindowSection,
WindowSplitter,
WindowPane,
WindowFrame
]
);
