<?php 
namespace Muster\Access;

defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

class Token {
	public $create = FALSE;
	public $read = FALSE;
	public $edit = FALSE;
	public $delete = FALSE;
	public $deny = FALSE;

	// $token_record is object with the required properties
	public function __construct($token_record = NULL)
	{
		if (!$token_record) return;
		$this->create = (boolean) $token_record->Create;
		$this->read = (boolean) $token_record->Read;
		$this->edit = (boolean) $token_record->Edit;
		$this->delete = (boolean) $token_record->Delete;
		$this->deny = (boolean) $token_record->Deny;
	}
	
	public function get_string()
	{
		$string = '';
		($this->create) and ($string .= 'C');
		($this->read) and ($string .= 'R');
		($this->edit) and ($string .= 'E');
		($this->delete) and ($string .= 'D');
		// never deny comparison
		return $string;
	}
	
	public function __toString()
	{
		return $this->get_string();
	}
}
