<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
/**
 * Database result wrapper for update, delete, insert.
 *
 * based loosely on Kohana result class
 * copyright (c) Henrik Bechmann, Toronto, Canada, 2010. bechmann.ca
 * New BSD licence
 */
abstract class Muster_Database_Operation implements Countable{ // countable to be consistent with Result

	protected $_statement;
	protected $_sql;
	protected $_db;
	protected $_config;

	protected $_total_rows  = 0;

	public function __construct($statement, $sql,$config)
	{
		$this->_config = $config;
		$this->_db = $config['db'];
		$this->_statement = $statement;
		$this->_sql = $sql;
	}

	public function __destruct()
	{
		$this->_statement = NULL;
		$this->_db = NULL;
	}

	public function count() // for Countable interface
	{
		return $this->_total_rows;
	}
	public function statement()
	{
		return $this->_statement;
	}
	public function sql()
	{
		return $this->_statement->queryString;
	}
	public function db()
	{
		return $this->_db;
	}
	public function row_count()
	{
		return $this->_total_rows;
	}
}
