<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
class Muster_Database_Operation_PDO extends Database_Operation 
{
	protected $_total_rows;
//	protected $_parameters;
	protected $_success = TRUE;
	
	public function __construct($statement, $sql, $config)
	{
	
		parent::__construct($statement, $sql, $config);
		
		$this->_total_rows = $statement->rowCount();
	}
	public function execute($parameters = NULL)
	{
		$this->_total_rows = 0;
		try
		{
			$statement = $this->_statement;
			if (empty($parameters))
				$retval = $statement->execute();
			else
				$retval = $statement->execute($parameters);
			$this->_db->statement_error($statement->errorInfo());
		}
		catch (Exception $e)
		{
			$this->_success = FALSE;
			$this->_db->statement_error($statement->errorInfo());
			// Rethrow the exception
			$dberror = (isset($statement) and (!empty($statement)))? $statement->errorCode():0;
			throw new Database_Exception($dberror,':error (:code)',
				array(':error' => $e->getMessage(),	':code' => $e->getCode()));
		}
		$this->_total_rows = $statement->rowCount();
		$this->_success = $retval;
		return $this;
	}
	public function success()
	{
		return $this->_success;
	}
	public function error_code()
	{
		return $this->_statement->errorCode(); // SQLSTATE
	}
	public function error_info()
	{
		return $this->_statement->errorInfo(); // array(0=>SQLSTATE,1=>drivererrorcode,2=>errormessage)
	}
	public function insert_id($name = NULL)
	{
		return $this->_db->insert_id($name);
	}
}
