<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
class Muster_Node_Feed extends Node {

	public function generate($context)
	{
		$system = System::instance();
		$binder = DB::select('ID','LeftEdge','RightEdge','RootID')
			->from('Binders_View')
			->where('Code','=',$context->binderscope)
			->as_object()
			->prepare(Database::instance())
			->execute()->current();
		if (!$binder) return; // trigger error message
		$cursor = DB::select('ID','Title','Description','ArticleDate')
			->from('Articles_View')
			->where('LeftEdge','BETWEEN',DB::expr($binder->LeftEdge . ' AND ' . $binder->RightEdge))
			->where('RootID','=',$binder->RootID)
			->where('Approval','=','A')
			->where('Hide','IS',DB::expr('FALSE'))
			->order_by('ArticleDate','DESC')
			->order_by('Title')
			->as_object()
			->limit($context->limit)
			->prepare(Database::instance())
			->execute();
		$info = array(
			'title' => htmlspecialchars('Feed for ' . $system->Website . $this->_controller->_base . ': ' . $context->objectcategory),
			'description' => htmlspecialchars($system->Description),
			'link' => 'http://' . $system->Website . $this->_controller->_base . $context->sourcebranch,
		);
		$items = array();
		while ($record = $cursor->fetch()) {
			$item = array(
				'description' => htmlspecialchars($record->Description?$record->Description:$record->Title),
				'title' => htmlspecialchars($record->Title),
				'pubDate' => $record->ArticleDate,
				'link' => 'http://' . $system->Website . $this->_controller->_base . $context->articlebranch . $record->ID,
			);
			$items[] = $item;
		}
		$feed = Feed::create($info,$items);
		echo $feed;
	}
}