<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
namespace Muster;

use Kohana;
use Services;

defined('SYSPATH') or die('No direct script access.');

class Notification {
	static function email($recipients,$date,$selector,$data = NULL)
	{
		is_array($recipients) or ($recipients = array($recipients));
		$successes = 0;
		$failures = 0;
		$config = Kohana::$config->load('notifyemails')->as_array();
		$subject = isset($config[$selector]['subject'])? $config[$selector]['subject']:NULL;
		$headers = $config['headers'];
		$website = System::instance()->Website;
		$querymail = System::instance()->ReturnEmailAddress;
		$template = isset($config[$selector]['template'])?$config[$selector]['template']:NULL;
		foreach ($recipients as $recipientid) {
			if (is_numeric($recipientid)) {
				$record = Services::dbrecordlookup(
					'Access_Users',
					array('Name','Email','Code'),
					'ID',$recipientid);
				if (!empty($record)) {
					$to      = $record->Name . ' <' . $record->Email . '>';
					$dictionary = array(
						'username' => $record->Name,
						'usercode' => $record->Code,
					);
				} else {
					$to = NULL;
				}
			} else {
				$to = $recipientid; // assume it's the email address
				$dictionary = array();
			}
			if (empty($to)) {
				$result = FALSE;
			} else {
				$dictionary['website'] = $website;
				$dictionary['queryemail'] = $querymail;
				echo 'data';
				if (!empty($data))
					$dictionary = array_merge($dictionary,$data); // 'recordtype', 'recordurl'
				$emailview = Template::view($template,$dictionary);
				$result = mail($to, $subject, $emailview, $headers);
			}
			if ($result) $successes++;
			else $failures++;
		}
		return array($successes,$failures);
	}
}
