<?php 
namespace Muster\Point;

use Point;

use 
	Muster\Point\Data,
	Muster\Point\Blockselect,
	Muster\Point\Control,
	Muster\Parameter;

defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
class Block extends Point {
	public $metadata;
	public $source; // metadata for block source
	public $pointlist; // internal dictionary representation; arrays = sets
	public $datapool; // for indirection ** not used
	public $metapoint; // metadata for the data instance
	
	public $parent; // reference to containing parent
	public $errorstate = 0;
	
	public function reset()
	{
		$this->pointlist = NULL;
	}
	public function properties($properties = NULL)
	{
		if ($properties) {
			foreach ($properties as $index => $value) {
				$this->$index = $value;
			}
		}
		return $this;
	}
	public function metadata($metadata = NULL)
	{
		if ($metadata) {
			$this->metadata = (object) $metadata;
			return $this;
		} else {
			return $this->metadata;
		}
	}
	// alias for metadata()
	public function variables($metadata = NULL)
	{
		return $this->metadata($metadata);
	}
	// alias for metadata()
	public function commands($metadata = NULL)
	{
		return $this->metadata($metadata);
	}
	public function as_array()
	{
		$data = $this->pointlist;
		$array = array();
		if ($data){
			foreach ($data as $key => $item) {
				if (($item instanceof Data) or 
					($item instanceof Blockselect) or 
					($item instanceof Control) or
					($item instanceof Parameter))
					$array[$key] = $item->value;
			}
		}
		return $array;
	}
}