<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Muster;

use DB, Database;
use User, Services;

defined('SYSPATH') or die('No direct script access.');

class System {
	protected $_properties; // system properties
	protected $_db;
	protected static $_instance;
	
	public function __construct()
	{
		$properties = &$this->_properties;
		$user = User::instance();
		$this->_db = $user->db();
		$properties =
			DB::select('Code','Value')
				->from('System_Properties')
				->execute($this->_db)
				->as_array('Code','Value');
		$group = $properties['PublicGroup'];
		$role = $properties['PublicRole'];
		list($roleid,$groupid) = $this->_get_roledata($group,$role);
		$properties['PublicRoleID'] = $roleid;
		$properties['PublicGroupID'] = $groupid;
		
		$group = $properties['DefaultGroup'];
		$role = $properties['DefaultRole'];
		list($roleid,$groupid) = $this->_get_roledata($group,$role);
		$properties['DefaultRoleID'] = $roleid;
		$properties['DefaultGroupID'] = $groupid;

		$properties['MaxRank'] = (integer) DB::select(DB::expr('max(`Rank`) as `Rank`'))
				->from('Access_Group_Roles')
				->as_object()
				->execute($this->_db)
				->current()->Rank;
				
		$json = $properties['PictureSizes'] = json_decode($properties['PictureSizes']);
		if (is_null($json)) 
			die('picturesizes error loading in system.php: '.json_last_error());
		self::$_instance = $this;
	}
	protected function _get_roledata($group,$role)
	{
		$properties = $this->_properties;
		$db = Database::instance(); // ** should be specific selector, but from where??
		$groupid = (integer) Services::dblookup('Access_Groups','ID','Code',$group,$db);
		
		$record = DB::select('ID')
			->from('Access_Group_Roles')
			->where('GroupID','=',$groupid)
			->and_where('Code','=',$role)
			->as_object()
			->execute($db)
			->current();
		if ($record) {
			$roleid = $record->ID;
		} else {
			$roleid = NULL;
		}
		return array ((int)$roleid,(int)$groupid);
	}
	public static function instance()
	{
		if (!self::$_instance) {
			return new System();
		}
		return self::$_instance;
	}
	public function __get($index)
	{
		$properties = $this->_properties;
		if (isset($properties[$index]))
			return $properties[$index];
		else
			return NULL;
	}
	public function __set($index,$value)
	{
		$this->_properties[$index] = $value;
	}
}
