<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Muster\Tablemodel;

defined('SYSPATH') or die('No direct script access.');
/**
 file: foreignkey.php
 package: Tablemodel
 category: ORM (Object Relational Manager)
 date: August 2010
* class: Foreignkey
* observes Recordrelation
* observed by table
* instance of TableIndex
* contains index column values
API:
*/
class Foreignkey extends AbstractIndex
{
	//references
	protected $_recordrelation;
	protected $_table;

	public function __construct($parameters)
	{
		parent::__construct($parameters);
		$table = $this->_table = $parameters->table;
		$this->attach_observer($table); // table observes this Foreignkey
		$table->set_foreignkey($this);
	}
	
	public function destroy()
	{
		$this->_recordrelation = NULL;
		$this->_table = NULL;
		parent::destroy();
	}
	public function attach_observer(Observer $table) // Observed method
	{
		parent::attach_observer($table);
	}
	public function detach_observer(Observer $table) // Tablemodel_Observed method
	{
		parent::detach_observer($table);
	}
	// update Foreignkey
	public function update_observer(Observed $recordrelation) // Observer method
	{
		// foreignkey column values already updated by recordrelation
		$this->notify_observers();
	}
	public function recordrelation()
	{
		return $this->_recordrelation;
	}
	public function set_relation($relation)
	{
		$this->_recordrelation = $relation;
	}
	public function table()
	{
		return $this->_table;
	}
}
