<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Muster\Tablemodel;

defined('SYSPATH') or die('No direct script access.');
/**
 file: index.php
 package: Tablemodel
 category: ORM (Object Relational Manager)
 date: August 2010
* class: Recordindex
* observes Activerecord
* observed by Recordrelation
* instance of indexdef
* contains index column values
 API:
*/
class Index extends AbstractIndex // observes the Activerecord, notifies Relations
{
	//references
	protected $_activerecord; // source

	public function __construct($parameters)
	{
		parent::__construct($parameters);
		$activerecord = $this->_activerecord = $parameters->activerecord;
		$activerecord->attach_observer($this); // Recordindex observes Activerecord
	}
	public function destroy()
	{
		$this->_activerecord = NULL;
		parent::destroy();
	}
	// update Recordindex
	public function update_observer(Observed $activerecord) // Tablemodel_Observer method
	{
		$change = FALSE;
//		echo 'UPDATING INDEX OBSERVER ' . $this->indexdef()->name() . '<br />';
		if ($activerecord->has_record()) 
		{
			foreach ($this->_indexdef->column_names() as $columnname)
			{
				if (($this->_column_values[$columnname] !== $activerecord->$columnname) or 
					(is_null($this->_column_values[$columnname]) and is_null($activerecord->$columnname))) // for indexes that allow NULL
				{
					$this->_column_values[$columnname] = $activerecord->$columnname;
					$change = TRUE;
				}
			}
		}
		else
		{
			foreach ($this->_indexdef->column_names() as $columnname)
			{
				if ($this->_column_values[$columnname] !== NULL)
				{
					$this->_column_values[$columnname] = NULL;
					$change = TRUE;
				}
			}
		}
		if ($change) $this->notify_observers();
	}
	// property accessors
	public function activerecord()
	{
		return $this->_activerecord;
	}
}