<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Base;

use Base\NodeType as Type;
use Muster as Core;
	
defined('SYSPATH') or die('No direct script access.');

/*
The mandate of this module is to take node parameters as input as
return dictionary data as output.
A node can be:
	- folder
	- document
	- blog
	- blogentry
	- cluster
	- page
	
Notes:
	- authorid => Ownerid in url query
	
	object types:
	document
	entry
	page
	blog
	folder
	picture
	docfile
	link
	contact
*/
abstract class Node extends Core\Node {

	# factory methods...
	public static function blog_record($controller,$selector = NULL)
	{
		$node = new Type\BlogRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function comment_record($controller,$selector = NULL)
	{
		$node = new Type\CommentRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function widget_record($controller,$selector = NULL)
	{
		$node = new Type\WidgetRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function document_record($controller,$selector = NULL)
	{
		$node = new Type\DocumentRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function entry_record($controller,$selector = NULL)
	{
		$node = new Type\EntryRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function folder_record($controller,$selector = NULL)
	{
		$node = new Type\FolderRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function picture_record($controller,$selector = NULL)
	{
		$node = new Type\PictureRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function link_record($controller,$selector = NULL)
	{
		$node = new Type\LinkRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function page_record($controller,$selector = NULL)
	{
		$node = new Type\PageRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function docfile_record($controller,$selector = NULL)
	{
		$node = new Type\DocFileRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function docextract_record($controller,$selector = NULL)
	{
		$node = new Type\DocExtractRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	/*
	public static function workgroup_record($controller,$selector = NULL)
	{
		$node = new Type\WorkgroupRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function message_record($controller,$selector = NULL)
	{
		$node = new Type\MessageRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	*/
	public static function file_record($controller,$selector = NULL)
	{
		$node = new Type\FileRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function directory_record($controller,$selector = NULL)
	{
		$node = new Type\DirectoryRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function inbox_record($controller,$selector = NULL)
	{
		$node = new Type\InboxRecord($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function subitem($controller,$selector = NULL)
	{
		$node = new Type\Subitem($controller,$selector);
		self::register_node($node);
		return $node;
	}
	
	# lists
	public static function database_list($controller,$selector = NULL)
	{
		$node = new Type\DatabaseList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function library_list($controller,$selector = NULL)
	{
		$node = new Type\LibraryList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function collaborator_list($controller,$selector = NULL)
	{
		$node = new Type\CollaboratorList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function blog_list($controller,$selector = NULL)
	{
		$node = new Type\BlogList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function comment_list($controller,$selector = NULL)
	{
		$node = new Type\CommentList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function widget_list($controller,$selector = NULL)
	{
		$node = new Type\WidgetList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function document_list($controller,$selector = NULL)
	{
		$node = new Type\DocumentList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function entry_list($controller,$selector = NULL)
	{
		$node = new Type\EntryList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function folder_list($controller,$selector = NULL)
	{
		$node = new Type\FolderList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function picture_list($controller,$selector = NULL)
	{
		$node = new Type\PictureList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function link_list($controller,$selector = NULL)
	{
		$node = new Type\LinkList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function page_list($controller,$selector = NULL)
	{
		$node = new Type\PageList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function docfile_list($controller,$selector = NULL)
	{
		$node = new Type\DocFileList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function docextract_list($controller,$selector = NULL)
	{
		$node = new Type\DocExtractList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	/*
	public static function workgroup_list($controller,$selector = NULL)
	{
		$node = new Type\WorkgroupList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function message_list($controller,$selector = NULL)
	{
		$node = new Type\MessageList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	*/
	public static function file_list($controller,$selector = NULL)
	{
		$node = new Type\FileList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function directory_list($controller,$selector = NULL)
	{
		$node = new Type\DirectoryList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function inbox_list($controller,$selector = NULL)
	{
		$node = new Type\InboxList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function sublist($controller,$selector = NULL)
	{
		$node = new Type\Node_List_Sublist($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function container_list($controller,$selector = NULL)
	{
		$node = new Type\ContainerList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function content_list($controller,$selector = NULL)
	{
		$node = new Type\ContentList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function contentsadmin_list($controller,$selector = NULL)
	{
		$node = new Type\ContentAdminList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function items_list($controller,$selector = NULL,$subcontext = NULL)
	{
		$node = new Type\ItemsList($controller,$selector,$subcontext);
		self::register_node($node);
		return $node;
	}
	public static function attachmentadmin_list($controller,$selector = NULL)
	{
		$node = new Type\AttachmentAdminList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function attachment_list($controller,$selector = NULL)
	{
		$node = new Type\AttachmentList($controller,$selector);
		self::register_node($node);
		return $node;
	}
	public static function favourites($controller,$selector = NULL)
	{
		$node = new Type\Favourites($controller,$selector);
		self::register_node($node);
		return $node;
	}
	# contents
	public static function feednode($controller)
	{
		$node = new StdClass; // Type\Node_Feed($controller);
//		self::register_node($node);
		return $node;
	}
}