<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Base\NodeType;

use StdClass;
use Services;
use Kohana, DB;
use Muster\Node\ListNode;

defined('SYSPATH') or die('No direct script access.');

class AttachmentList extends ListNode {
	public function __construct($controller)
	{
		$this->_extensionflag = TRUE;
		$this->_context = $this->_get_context();
		parent::__construct($controller);
	}
	protected function _get_context()
	{
		$context = new StdClass();
		# resources
		$context->tablemodel = 'attachmentschema';
		$context->controlframe = 'nodecontrols';
		$context->dataframe = 'nodedata';
		$context->messagefile = 'attachments'; // not used
		# tablemodel
		$context->mastertablename = 'master';
		$context->parenttablename = 'containers';
		$context->blogtablename = 'blog';
		# recordset
		$context->selectarray = array('ArticleID','ObjectType','AttachmentID','NodeID','EmptyBody','isTreeTop','BlogCode','ParentID','FolderCode','Approval','Order','OrderText','DividerAbove','DividerBelow','InstanceDescription');
		$context->binderscope = NULL;
		$context->foreignkeyname = 'ParentArticleID';
		$context->default_orderby = 'Order';
		# gateway
		$context->mastertableindex = 'mastertable';
		$context->masterrecordindex = 'masterrecord';
		$context->parenttableindex = 'containerstable';
		$context->parentrecordindex = 'containersrecord';
		$context->blogtableindex = 'blogtable';
		$context->blogrecordindex = 'blogrecord';
		$context->datapoolarrays = Kohana::$config->load('recordpartials')->getArrayCopy();
		$context->constraints = array(
			array(
				'index' => 'showblogparent',
				'value' => TRUE,
			),
			array(
				'index' => 'showpageparent',
				'value' => TRUE,
			),
		);
		# node
		$context->redirect = 'sublists/attachments';
		# permissions
		
		$context->tokens = Services::get_token_set('mixed');
		return $context;
	}
	protected function _on_set_datapool($datapool) 
	{
		$context = $this->_context;
		$tablemodel = $this->_tablemodel;
		$datapool->tables[$context->parenttableindex] = 
			$tablemodel->model->table($context->parenttablename);
		$datapool->activerecords[$context->parentrecordindex] = 
			$tablemodel->model->activerecord($context->parenttablename);
		$datapool->activerecords[$context->blogrecordindex] = 
			$tablemodel->model->activerecord($context->blogtablename);
	}
}