<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Base\NodeType;

use StdClass;
use Services;
use Kohana;
use Muster\Node\ListNode;

defined('SYSPATH') or die('No direct script access.');

class BlogList extends ListNode {
	public function __construct($controller)
	{
		$this->_extensionflag = TRUE;
		$this->_context = $this->_get_context();
		parent::__construct($controller);
	}
	protected function _get_context()
	{
		$context = new StdClass();

		// model properties
		$context->tablemodel = 'nodeschema';
		$context->mastertablename = 'master';
		$context->parenttablename = 'containers';

		// recordset properties
		$context->objecttype = 'blog';
		$context->selectarray = array('ObjectType','BlogCode','EmptyBody');
		$context->default_orderby = 'Title';
		$context->default_orderdirection = 'ASC';
		$context->binderscope = 'Blogs';

		// gateway properties
		$context->controlframe = 'nodecontrols';
		$context->dataframe = 'nodedata';
		$context->mastertableindex = 'mastertable';
		$context->masterrecordindex = 'masterrecord';
		$context->parenttableindex = 'containerstable';
		$context->parentrecordindex = 'containersrecord';
		$context->messagefile = 'blog';
		$context->datapoolarrays = Kohana::$config->load('recordpartials')->getArrayCopy();
		// session properties
		$context->redirect = 'blogs';

		// security properties
		$context->tokens = Services::get_objecttype_tokenset($context->objecttype);
		return $context;
	}
	protected function _on_set_datapool($datapool) 
	{
		$context = $this->_context;
		$tablemodel = $this->_tablemodel;
		$datapool->tables[$context->parenttableindex] = 
			$tablemodel->model->table($context->parenttablename);
		$datapool->activerecords[$context->parentrecordindex] = 
			$tablemodel->model->activerecord($context->parenttablename);
	}
}