<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Base\NodeType;

use StdClass;
use Services;
use Kohana;
use Muster\Node\ListNode;

defined('SYSPATH') or die('No direct script access.');

class DocumentList extends ListNode {
	public function __construct($controller,$selector = NULL)
	{
		$this->_extensionflag = TRUE;
		$this->_context = $this->_get_context($selector);
		parent::__construct($controller);
	}
	protected function _get_context()
	{
		$context = new StdClass;
		# resources
		$context->tablemodel = 'nodeschema';
		$context->controlframe = 'nodecontrols';
		$context->dataframe = 'nodedata';
		$context->messagefile = 'article';
		# tablemodel
		$context->mastertablename = 'master';
		$context->containertablename = 'containers';
		# recordset
		$context->objecttype = 'document';
		$context->selectarray = array('ObjectType','EditDate','EditUserID','Locked','URL');
		$context->binderscope = 'Documents';
		# gateway
		$context->containertableindex = 'containerstable';
		$context->containerrecordindex = 'containersrecord';
		$context->mastertableindex = 'mastertable';
		$context->masterrecordindex = 'masterrecord';
		$context->datapoolarrays = Kohana::$config->load('recordpartials')->getArrayCopy();
		# node
		$context->redirect = 'documents/list';
		# permissions
		$context->tokens = Services::get_objecttype_tokenset($context->objecttype);
		return $context;
	}
	protected function _on_set_datapool($datapool) 
	{
		$context = $this->_context;
		$tablemodel = $this->_tablemodel;
		$datapool->tables[$context->containertableindex] = 
			$tablemodel->model->table($context->containertablename);
		$datapool->activerecords[$context->containerrecordindex] = 
			$tablemodel->model->activerecord($context->containertablename);
	}
}