<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Base\NodeType;

use StdClass;
use Services;
use Kohana;
use Muster\Node\ListNode;

defined('SYSPATH') or die('No direct script access.');

class EntryList extends ListNode {
	public function __construct($controller,$selector = NULL)
	{
		$this->_extensionflag = TRUE;
		$this->_context = $this->_get_context($selector);
		parent::__construct($controller);
	}
	protected function _get_context($selector)
	{
		$context = new StdClass;
		// model properties
		$context->tablemodel = 'nodeschema';
		$context->mastertablename = 'master';
		$context->parenttablename = 'containers';
		$context->blogtablename = 'blog';
		
		// recordset properties
		$context->objecttype = 'entry';
		$context->selectarray = array('ObjectType','ParentID','EditDate','EditUserID','Locked','URL','BlogCode');
		$context->binderscope = 'BlogItems';
		$context->foreignkeyname = 'ParentID';
		// gateway propertiies
		$context->dataframe = 'nodedata';
		$context->controlframe = 'nodecontrols';
		$context->parenttableindex = 'containerstable';
		$context->parentrecordindex = 'containersrecord';
		$context->mastertableindex = 'mastertable';
		$context->masterrecordindex = 'masterrecord';
		$context->blogtableindex = 'blogtable';
		$context->blogrecordindex = 'blogrecord';
		$context->messagefile = 'blog';
		$context->datapoolarrays = Kohana::$config->load('recordpartials')->getArrayCopy();
		$context->constraints = array(
			array(
				'index' => 'showblogparent',
				'value' => TRUE,
			)
		);
		
		// node properties
		$context->redirect = 'blogs/allentries';
		if ($selector == 'contents')
			$context->get_admindictionary = FALSE;

		// security properties
		$context->tokens = Services::get_objecttype_tokenset($context->objecttype);
		return $context;
	}
	protected function _on_set_datapool($datapool) 
	{
		$context = $this->_context;
		$tablemodel = $this->_tablemodel;
		$datapool->tables[$context->parenttableindex] = 
			$tablemodel->model->table($context->parenttablename);
		$datapool->activerecords[$context->parentrecordindex] = 
			$tablemodel->model->activerecord($context->parenttablename);
		$datapool->activerecords[$context->blogrecordindex] = 
			$tablemodel->model->activerecord($context->blogtablename);
			
	}
}