<?php 
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net

namespace Base\NodeType;

use StdClass;
use Services;
use Kohana;
use Muster\Node\ListNode;

defined('SYSPATH') or die('No direct script access.');

class LibraryList extends ListNode {
	public function __construct($controller)
	{
		$this->_extensionflag = TRUE;
		$this->_context = $this->_get_context();
		parent::__construct($controller);
	}

	protected function _get_context()
	{
		$context = new StdClass();
		# resources
		$context->tablemodel = 'nodeschema';
		$context->controlframe = 'nodecontrols';
		$context->dataframe = 'nodedata';
		$context->messagefile = 'library'; // not used
		# table model
		$context->mastertablename = 'master';
		$context->parenttablename = 'containers';
		# recordset
		$context->selectarray = array('ObjectType','EmptyBody','isTreeTop','DefaultFolio','EditDate','EditUserID','Source','URL','FileName','Directory');
		$context->binderscope = 'Library';
		# gateway
		$context->mastertableindex = 'mastertable';
		$context->masterrecordindex = 'masterrecord';
		$context->parenttableindex = 'containerstable';
		$context->parentrecordindex = 'containersrecord';
		$context->datapoolarrays = Kohana::$config->load('recordpartials')->getArrayCopy();
		# node
		$context->redirect = 'library';
		# permissions
		$context->tokens = Services::get_token_set('mixed');
		return $context;
	}
	
	protected function _on_set_datapool($datapool) 
	{
		// master table set in parent class
		$context = $this->_context;
		$tablemodel = $this->_tablemodel;
		$datapool->tables[$context->parenttableindex] = 
			$tablemodel->model->table($context->parenttablename);
		$datapool->activerecords[$context->parentrecordindex] = 
			$tablemodel->model->activerecord($context->parenttablename);
	}
}