<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
/*
dispatcher looks for blogs/<code>(/<selector>(/<id>)))
code = NULL, 'record','allentries','entry','feed' or a blog name

code = NULL means list blogs

code = 'record', means go to blog master record

code = 'allentries' means list all blog entries

code = 'entry' means selector is entryid or empty selector means new entry

code = 'feed' pending

otherwise code is a blogname

if code is a blogname, then 
	selector is 'feed' (for the blog), or 
	selector is empty (list blog contents), or
	selector is 'entry', assumes id is entryid, or blank = new entry
	or selector is numeric, means

Views of the data
blog list
blog record

blog entries list
blog entries record

all entries
about
feed
*/
class Controller_Blogs extends Controller_Site {

	public function action_index()
	{
		$blogcode = $this->request->param('code');
		$selector = $this->request->param('selector');
		$id = $this->request->param('id');
		switch ($blogcode) {
			case NULL:
				$this->_list();
				break;
			case 'list':
				$this->_list();
				break;
			case 'record':
				$this->_record();
				break;
			case 'allentries':
				$this->_allentries();
				break;
			case 'entry':
				$this->_entry_record();
				break;
			case 'feed':
				$this->_feed();
				break;
			default: // code == blog name
				if ($selector == 'feed') { // feed for a blog
					$this->_blogentries_feed();
				} elseif (empty($selector)) { // the blog contents
					$this->_blog_contents();
				} elseif ($selector == 'entry') { // and entry for the blog (assumes id set, or new entry
					$this->_entry_record();
				} elseif (is_numeric($selector)) {
					$this->_entry_record();
				} else {
					$this->_list(); // nothing else works
				}
		}
	}
	// list of blogs
	protected function _list()
	{
		# get data
		$node = Base\Node::blog_list($this);
		$data = $node->generate();
		extract($data);
		# create templates
		$recordview = Template::view(array('blog_list'),$dictionary);
		$wrapperview = Template::view(array('blog_list_wrapper'));
		$sideview = Template::view(array('blog_list_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		#finish
		$pageview->title = 'Blogs - List';
		$this->show_resources();
		$this->response->body($pageview);
	}
/*
		$pageview->headerelements = array(array('headerelement'=>
'<link rel="alternate" type="application/rss+xml" 
	title="RSS Feed for publicrinks.ca blog entries" 
	href="'.$this->_base.'blogs/feed" />'));
*/
// ------------
/*
 here with blogs/record/<selector> where selector is numeric or alphabetic blog master record code
*/
	protected function _record()
	{
		# get articleid
		$articleid = $this->request->param('selector');
		if (!is_numeric($articleid))
			$articleid = Services::dblookup('Nodes_Blogs_View','ID','BlogCode',$articleid);
		# get data
		$node = Base\Node::blog_record($this);
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$recordview = Template::view(array('blog_record'),$dictionary);
		$wrapperview = Template::view(array('blog_record_wrapper'),$dictionary);
		$sideview = Template::view(array('blog_record_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$sideview->code = $recordview->code;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'blogs/record/' . $articleid;
		$pageview->title = 'Blogs - Record: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	protected function _allentries()
	{
		# get data
		$node = Base\Node::entry_list($this);
		$data = $node->generate();
		extract($data);
		# create templates
		$listview = Template::view(array('blogentry_all_list'),$dictionary);
		$wrapperview = Template::view(array('blogentry_all_list_wrapper'));
		$sideview = Template::view(array('blogentry_all_list_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->title = 'Blogs - List All Entries';
		$this->show_resources();
		$this->response->body($pageview);
	}
	protected function _blog_contents()
	{
		# get blogid
		$code = $this->request->param('code');
		$blogid = $code;
		if ((!empty($code)) and (!is_numeric($code))) {
			$blogid = Services::dblookup('Nodes_Blogs_View','ID','BlogCode',$code);
		}
		# get blog contents data
		$node = Base\Node::blog_record($this);
		$recordcontext = new StdClass;
		$recordcontext->articleid = $blogid;
		$recordcontext->redirect = 'blogs/' . $code;
		$node->extend_context($recordcontext);
		$recorddata = $node->generate();
		$node = Base\Node::entry_list($this,'contents');
		$subcontext = new StdClass;
		$subcontext->redirect = 'blogs/' . $code;
		$subcontext->foreignkeyvalue = $blogid;
		$node->extend_context($subcontext);
		$listdata = $node->generate();
		$listdictionary = $listdata['dictionary'];
		# get blog record data
		$recorddictionary = $recorddata['dictionary'];
		$admindictionary = $recorddata['admindictionary'];
		$bookmark = $recorddata['bookmark'];
		# create templates
		$recordview = Template::view(array('blogentry_list_wrapper'),$recorddictionary);
		$recordview->bookmark = $bookmark;
		$listview = Template::view(array('blogentry_list'),$listdictionary);
		$sideview = Template::view(array('blogentry_list_sidebar'),$admindictionary);
		# combine templates
		$recordview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $recordview;
		$pageview->leftcolumn = $sideview;
		# finish
		$sideview->code = $recordview->code; // for put
		$blogcode = $listview->blogcode = $recordview->code; // for pagination
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'blogs/' . $blogcode;
		$pageview->title = 'Blog: ' . htmlspecialchars($recordview->title);
		$this->show_resources();
		$this->response->body($pageview);
	}
/*
		$pageview->headerelements = array(array('headerelement'=>
'<link rel="alternate" type="application/rss+xml" 
	title="RSS Feed for publicrinks.ca blog entries" 
	href="'.$this->_base.'blogs/'. $code . '/feed" />'));
*/
	protected function _entry_record()
	{
		# parameters can mean a variety of things
		$code = $this->request->param('code');
		$selector = $this->request->param('selector');
		$id = $this->request->param('id');
		# get articleid (post id)
		$blogcode = NULL;
		$articleid = NULL;
		if ($code == 'entry') { // form 1. entry/PostID, must derive parentid
			$articleid = $selector;
		} elseif ($selector == 'entry') { // form 2. BlogCode/entry/PostID
			$blogcode = $code;
			$articleid = $id;
		} else { // form 3. BlogCode/PostID
			$blogcode = $code;
			$articleid = $selector;
		}
		# get blogcode 
		$parentid = NULL;
		if (empty($blogcode)) { // form 1. above
			if (is_numeric($articleid)) {
				$parentid = Services::dblookup('Nodes_Entry_View','ParentID','ID',$articleid);
				$blogcode = Services::dblookup('Nodes_Blogs_View','BlogCode','ID',$parentid);
			} else { // system error
				$blogcode = NULL;
			}
		}
		# get parentid, unless already set above
		if (!is_numeric($blogcode)) {
			if (is_null($parentid)) // otherwise was already found above
				$parentid = Services::dblookup('Nodes_Blogs_View','ID','BlogCode',$code);
		} else {
			$parentid = $blogcode; // assume blog number instead of code
		}
		if (!empty($blogcode)) { // also empty parentid
			$redirect =  'blogs/' . $blogcode;
		} else { // system error
			$this->request->redirect('node/'.$articleid . URL::query()); // pass to general redirect routine
//			die('system error: no blog code for blog entry');
		}
		# get data
		$node = Base\Node::entry_record($this);
		$subcontext = new StdClass;
		$subcontext->parentid = $parentid;
		$subcontext->redirect =  $redirect;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('blogentry_record_wrapper'),$dictionary);
		$wrapperview->bookmark = $bookmark;
		$recordview = Template::view(array('blogentry_record'),$dictionary);
		$adminview = Template::view(array('blogentry_record_sidebar'),$admindictionary);
		$recordview->blogcode = $blogcode;
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $adminview;
		# finish
		$adminview->blogcode = $recordview->blogcode;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'blogs/' . $blogcode . '/' . $articleid;
		$pageview->title = 'Blogpost: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _feed()
	{
		$context = $this->_feed_get_context();
		$feed = Base\Node::feednode($this);
		$feed->generate($context);
	}

	protected function _feed_get_context()
	{
		$context = new StdClass;
		
		// recordset properties
		$context->objecttype = 'blog';
		$context->objectname = 'Blog';
		$context->objectcategory = 'Blogs';
		$context->limit = 30;
		
		// feed properties
		$context->sourcebranch = 'blogs';
		$context->articlebranch = 'blogs/';
		$context->binderscope = 'Blogs';
		$context->messagefile = 'blog';
		
		return $context;
	}
	public function _blogentries_feed()
	{
		$context = $this->_blogentries_feed_get_context();
		$feed = Base\Node::feednode($this);
		$feed->generate($context);
	}

	protected function _blogentries_feed_get_context()
	{
		$code = $this->request->param('code');
		
		$context = new StdClass;
		
		// recordset properties
		$context->objecttype = 'blog';
		$context->objectname = 'Blog';
		$context->objectcategory = 'Blogs: ' . $code;
		$context->binderscope = 'BlogsEntries'; 
		$context->limit = 30;

		// feed properties
		$context->sourcebranch = 'blogs/' . $code;
		$context->articlebranch = 'blogs/' . $code . '/';
		$context->messagefile = 'blog';
		
		return $context;
	}
}
