<?php 

defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
class Controller_Documents extends Controller_Site {

	public function action_index()
	{
		$id = $this->request->param('id');
		if (is_numeric($id)) {
			$this->action_record();
		} else {
			$this->action_list();
		}
	}
	#----------------[ List ]----------------------
	public function action_list()
	{
		# get data
		$node = Base\Node::document_list($this);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('document_list_wrapper'));
		$listview = Template::view(array('document_list'),$dictionary);
		$sideview = Template::view(array('document_list_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->title = 'Documents - List';
		$this->show_resources();
		$this->response->body($pageview);
	}
/*		$pageview->headerelements = array(array('headerelement'=>
'<link rel="alternate" type="application/rss+xml" 
	title="RSS Feed for publicrinks.ca documents" 
	href="'.$this->_base.'documents/feed" />'));
*/
	#----------------------------[ Record ]---------------------------------
	public function action_record()
	{
		# get data
		$articleid = $this->request->param('id');
		$node = Base\Node::document_record($this);
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('document_record_wrapper'),$dictionary);
		$wrapperview->bookmark = $bookmark;
		$recordview = Template::view(array('document_record'),$dictionary);
		$sideview = Template::view(array('document_record_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'documents/' . $articleid;
		$pageview->title = 'Document: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
//		echo View::factory('profiler/stats');
	}
	// *** deferred...
	public function action_feed()
	{
		$context = $this->_feed_get_context();
		$feed = Base\Node::feednode($this);
		$feed->generate($context);
	}

	protected function _feed_get_context()
	{
		$context = new StdClass;
		$context->objecttype = 'document';
		$context->objectname = 'Document';
		$context->objectcategory = 'Documents';
		$context->sourcebranch = 'documents';
		$context->articlebranch = 'documents/record/';
		$context->binderscope = 'Documents';
		$context->limit = 30;
		
		return $context;
	}
}