<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
class Controller_Favourites Extends Controller_Site {
	public function action_index()
	{
		$this->_protect();
		$userid = $this->_user->userid();
		
		$node = Base\Node::favourites($this);
		$subcontext = new StdClass;
		$subcontext->foreignkeyvalue = $userid;
		$node->extend_context($subcontext);
		
		$data = $node->generate();
		$dictionary = $data['dictionary'];
//		var_dump($dictionary);
		
		$contentview = Generator::view(array('favourites_list'),$dictionary);

		$wrapperdictionary = array();
		$wrapperdictionary['listcontents'] = $contentview;
		$viewwrapper = Generator::view(array('favourites_list_wrapper'),$wrapperdictionary);
		
		$admindictionary = $data['admindictionary'];
		$sidebarview = Generator::view(array('favourites_list_sidebar'),$admindictionary);

		# combine templates
		$pageview = $this->_pageview;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;

		$pageview->title = 'Favourites';
		
		$this->show_resources();
		$this->response->body($pageview);
	}
	protected function _protect()
	{
		$user = $this->_user;
		$authenticated = $user->authenticated();
		if (!$authenticated) {
			die('must be logged in to access list service');
		}
		$authorized = Access::instance()->permission('article_content','R');
		if (!$authorized) {
			die('unauthorized use of embedded list service');
		}
	}
}
