<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
class Controller_Folders extends Controller_Site {

	public function action_index()
	{
		$selector = $this->request->param('selector');
		switch ($selector) {
			case NULL:
				$this->_list();
				break;
			case 'list':
				$this->_list();
				break;
			case 'setup':
				$this->_setup();
				break;
			case 'contents':
				$this->_contents();
				break;
			case 'treetops':
				$this->_treetops();
				break;
			default:
				$this->_contents();
		}
	}

	protected function _list()
	{
		# get data
		$node = Base\Node::folder_list($this,'list');
		$data = $node->generate();
		extract($data); // dictionary, admindictionary
		# create templates
		$wrapperview = Template::view(array('folders_list_wrapper')); // no dictionary
		$wrapperview->listcontents = Template::view(array('folders_list'),$dictionary);
		$sideview = Template::view(array('folders_list_sidebar'),$admindictionary);
		# combine templates
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'topics';
		$pageview->title = 'Topics - List';
		$this->show_resources();
		$this->response->body($pageview);
	}
	protected function _setup()
	{
		# get articleid
		$selector = $this->request->param('selector');
		$pageid = $this->request->param('id');
		$articleid = $pageid;
		if ((!empty($articleid)) and (!is_numeric($articleid))) {
			$pagecode = $articleid;
			$operation = DB::select('ID')
				->from('Nodes_View')
				->where('FolderCode','=',$articleid)
				->as_object()
				->prepare()
				->execute();
			if (!$operation->success()) {
				echo 'folder code conversion error';
				return;
			}
			$pagerecord = $operation->current();
			if (!$pagerecord) {
				echo 'topic not found';
				return;
			}
			$articleid = $pagerecord->ID;
		}
		# get data
		$node = Base\Node::folder_record($this,'setup');
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$recordview = Template::view(array('folders_record'),$dictionary);
		$wrapperview = Template::view(array('folders_record_wrapper'),$dictionary);
		$sideview = Template::view(array('folders_record_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$sideview->code = $recordview->code;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'topics/setup/' . $articleid;
		$pageview->title =  'Topic setup: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	protected function _contents()
	{
		# get identifier
		$selector = $this->request->param('selector');
		if ((!empty($selector)) and (!is_numeric($selector))) {
			$operation = DB::select('ArticleID')
				->from('Articles_Extensions')
				->where('FolderCode','=',$selector)
				->as_object()
				->prepare()
				->execute();
			if (!$operation->success()) {
				echo 'folder code conversion error';
				return;
			}
			$record = $operation->current();
			if (!$record) {
				echo 'folder not found';
				return;
			}
			$selector = $record->ArticleID;
		}
		# get record data
		$node = Base\Node::folder_record($this);
		$recordsubcontext = new StdClass;
		$recordsubcontext->articleid = $selector;
		$node->extend_context($recordsubcontext);
		$recorddata = $node->generate();
		$recorddictionary = $recorddata['dictionary'];
		$recordadmindictionary = $recorddata['admindictionary'];
		$bookmark = $recorddata['bookmark'];
		# get list data
		$node = Base\Node::folder_list($this,'contents');
		$listsubcontext = new StdClass;
		// pass implied control values
		$listsubcontext->foreignkeyvalue = $selector;
		$listsubcontext->redirect = 'topics/' . $selector;
		$listsubcontext->default_orderby = 'Order';
		// pass control values from master record
		$listsubcontext->secondary_orderby = $recorddictionary['default_order'];
		$listsubcontext->secondary_direction = $recorddictionary['default_direction'];
		$listsubcontext->list_layout = $recorddictionary['list_layout'];
		$node->extend_context($listsubcontext);
		$listdata = $node->generate();
		$listdictionary = $listdata['dictionary']; // ignore admindictionary
		# create templates
		$recordview = Template::view(array('contents_list_wrapper'),$recorddictionary);
		$listview = Template::view(array('contents_list'),$listdictionary);
		$sidebarview = Template::view(array('contents_list_sidebar'),$recordadmindictionary);
		# augment template data
		$recordview->bookmark = $bookmark;
		$listview->path = $recordview->path;
		$listview->pagepath = $recordview->pagepath;
		$listview->instanceid = $recordview->instanceid;
		# combine templates
		$recordview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $recordview;
		$pageview->leftcolumn = $sidebarview;
		# finish
		$listview->folderid = $recordview->id;
		$sidebarview->code = $recordview->code;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'topics/' . $selector;
		$pageview->title = 'Topic: ' . htmlspecialchars($recordview->title);
		$this->show_resources();
		$this->response->body($pageview);
	}
	protected function _treetops()
	{
		$selector = $this->request->param('id');
		if ($selector == 'admin')
			return $this->_treetops_admin();
		# get data
		$listsubcontext = new StdClass;
		$listsubcontext->default_orderby = 'Order';
		$node = Base\Node::folder_list($this,'treetops');
		$node->extend_context($listsubcontext);
		$context = $node->context();
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('folders_treetops_wrapper'),$admindictionary);
		$listview = Template::view(array('folders_treetops'),$dictionary);
		$path = 'treetops-';
		$listview->path = $path;
		$wrapperview->path = $path;
		$wrapperview->contentcount = $listview->recordcount;
		$sideview = Template::view(array('folders_treetops_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'topics/treetops';
		$pageview->title = 'Topics - Treetops';
		$this->show_resources();
		$this->response->body($pageview);
	}
	protected function _treetops_admin()
	{
		# get data
		$listsubcontext = new StdClass;
		$listsubcontext->default_orderby = 'Order';
		$node = Base\Node::folder_list($this,'treetopsadmin');
		$node->extend_context($listsubcontext);
		$context = $node->context();
		$data = $node->generate();
		extract($data);
//		var_dump($dictionary);
		# create templates
		$wrapperview = Template::view(array('folders_treetops_admin_wrapper'),$admindictionary);
		$listview = Template::view(array('folders_treetops_admin'),$dictionary);
		$path = 'treetops-';
		$listview->path = $path;
		$wrapperview->path = $path;
		$wrapperview->contentcount = $listview->recordcount;
		$sideview = Template::view(array('folders_treetops_admin_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		$pageview->title = 'Topics - Treetops admin';
		$this->show_resources();
		$this->response->body($pageview);
	}
}
