<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
/* 	base
	&homeheader
	hometabs
		hometabiconuri
		hometabtitle
		&hometabheader
		&hometabcontents
		&hometabfooter
	&homefooter
*/
class Controller_Home extends Controller_Site {

	public function action_index()
	{
		$system = System::instance();
		$homepagenode = $system->HomePageMasterNode;
		# get home data
		$base = $this->_base;
		$homedictionary = array('base' => $base);
		$operation = DB::select('Body','DefaultOrder','DefaultDirection')
			->from('Nodes_View')
			->where('ID','=',$homepagenode)
			->as_object()
			->prepare()
			->execute();
		if ($success = $operation->success()) {
			$homepagerecord = $operation->fetch();
		}
		if (!empty($homepagerecord)) {
			$markup = $homepagerecord->Body;
			if (!empty($markup)) {
				$wiki = $this->simplewiki_instance();
				$headerhtml = $wiki->get_html($markup);
				if (!empty($headerhtml)) {
					$homedictionary['homeheader'] = $headerhtml;
				}
			}
			$hometabs = array();
			$operation = DB::select('NodeID','Title','Description','ObjectType','Body','DefaultOrder','DefaultDirection','DefaultFolio')
				->from('Nodes_Instances_View')
				->where('FolderID','=',$homepagenode)
				->order_by('Order','ASC')
				->order_by($homepagerecord->DefaultOrder,$homepagerecord->DefaultDirection)
				->as_object()
				->prepare()
				->execute();
			if ($operation->success()) {
				$count = 0;
				$wiki = clone $this->simplewiki_instance();
				$objecttypes = array('folder','document');
				while($tabrecord = $operation->fetch()) {
					$objecttype = $tabrecord->ObjectType;
					if (!in_array($objecttype,$objecttypes))
						continue;
					$count++;
					$hometab = array('hometabtitle'=>$tabrecord->Title);
					$hometabiconuri = NULL;
					if ($count == 1) {
						$hometabiconuri = $this->_common.'images/door_open.png';
					} else {
						if ($objecttype == 'folder') {
							$hometabiconuri = $this->_common.'images/folder_sm.png';
						} elseif ($objecttype == 'document') {
							$hometabiconuri = $this->_common.'images/document_sm.png';
						}
					}
					if ($objecttype == 'folder') {
						$hometab['titleuri'] = 'topics/' . $tabrecord->NodeID;
						$this->_get_homepage_tabfolderlist($tabrecord,$hometab);
					} elseif ($objecttype == 'document') {
						$this->_get_homepage_tabrecord($tabrecord,$hometab);
					}
					$hometab['hometabiconuri'] = $hometabiconuri;
					$wiki->prepare($tabrecord->Body);
					$metadata = $wiki->get_metadata();
					if (isset($metadata->attributes['tabname'])) {
						$hometab['tabindex'] = $metadata->attributes['tabname'];
					} else {
						$hometab['tabindex'] = 'tab'.$count;
					}
					$hometabs[] = $hometab;
				}
			}
			$homedictionary['hometabs'] = $hometabs;
			# create templates
			$homeview = Template::view(array('home'),$homedictionary);
		}
		$leftview = Template::view(array('home_left_sidebar'),array('base' => $this->_base));
		$rightview = Template::view(array('home_right_sidebar'),array('base' => $this->_base));
		$pageview = $this->_pageview;
		$pageview->is_homepage = TRUE;
		$pageview->metadescription = System::instance()->Description;
		# combine templates
		$pageview->centercolumn = $homeview;
		$pageview->leftcolumn = $leftview;
		$pageview->rightcolumn = $rightview;
		# finish
		$pageview->title = 'Home';
		$this->show_resources();
		$this->response->body($pageview);
	}
	protected function _get_homepage_tabfolderlist($tabrecord,&$hometab)
	{
		$node = Base\Node::folder_list($this,'contents');
		$listsubcontext = new StdClass;
		$nodeid = $listsubcontext->foreignkeyvalue = $tabrecord->NodeID;
		$listsubcontext->redirect = 'topics/' . $nodeid;
		$listsubcontext->default_orderby = 'Order';
		$listsubcontext->secondary_orderby = $tabrecord->DefaultOrder;
		$listsubcontext->secondary_direction = $tabrecord->DefaultDirection;
		$listsubcontext->list_layout = $tabrecord->DefaultFolio;
		$listsubcontext->constraints = array(
			array('index' => 'contentdisplay','value'=>TRUE),
			array('index' => 'showblogparent','value'=>TRUE),
//			array('index' => 'homepage','value'=>TRUE),
		);
		$node->extend_context($listsubcontext);
		$listdata = $node->generate();
		$listdictionary = $listdata['dictionary'];
		# create templates
		$listview = Template::view(array('home_contents_list'),$listdictionary);
		$listview->path = $nodeid . '-';
		$hometab['hometabdescription'] = $tabrecord->Description;
		$hometab['hometabcontent'] = $listview;
	}
	protected function _get_homepage_tabrecord($tabrecord,&$hometab)
	{
		$nodeid = $tabrecord->NodeID;
		$operation = DB::select('Body','DefaultOrder','DefaultDirection')
			->from('Nodes_View')
			->where('ID','=',$nodeid)
			->as_object()
			->prepare()
			->execute();
		if ($operation->success()) {
			$tabrecord = $operation->fetch();
		} 
		if (empty($tabrecord)) {
			return; // failure
		}
		$markup = $tabrecord->Body;
		if (!empty($markup)) {
			$wiki = $this->simplewiki_instance();
			$html = $wiki->get_html($markup);
			if (!empty($html)) {
				$hometab['hometabcontent'] = $html;
			}
		}
	}
}
