<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
/*
	add actions for register, login, logout, account + profile, confirm, profiles
*/
class Controller_Library Extends Controller_Site {
	public function action_index()
	{
		$selector = $this->request->param('selector');
		switch ($selector) {
			case NULL:
				$this->_all();
				break;
			case 'treetops':
				$this->_treetops();
				break;
			case 'folders':
			case 'files':
				$this->_files();
				break;
			case 'pictures':
				$this->_pictures();
				break;
			case 'docfiles':
				$this->_docfiles();
				break;
			case 'docextracts':
				$this->_docextracts();
				break;
			case 'links':
				$this->_links();
				break;
			case 'widgets':
				$this->_widgets();
				break;
			case 'directories':
				$this->_directories();
				break;
			case 'inboxes':
				$this->_inboxes();
				break;
			case 'comments':
				$this->_comments();
				break;
			default:
				die('unknown selector (library controller)');
		}
	}
	
	public function before()
	{
		// first modify settings, notably _navigation_block and _navigation_item
		
		parent::before();
	}
	
	public function _all()
	{
		# get node data
		$node = Base\Node::library_list($this);
		$data = $node->generate();
		extract($data);
		# create views
		$contentview = Template::view(array('library_all'),$dictionary);
		$viewwrapper = Template::view(array('library_all_wrapper'));
		$sidebarview = Template::view(array('library_all_sidebar'),$admindictionary);
		# update views and combine templates
		$pageview = $this->_pageview;
		$viewwrapper->base = $this->_base;
		$viewwrapper->listcontents = $contentview;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/' . $articleid;
		$pageview->title = 'Library - All records';
		# finish
		$this->show_resources();
		$this->response->body($pageview);
	}

	public function _treetops()
	{
		# get node data
		$node = Base\Node::file_list($this,'treetops');
		$sub_context = new StdClass();
		$sub_context->treetopsflag = TRUE;
		$sub_context->redirect = 'library/treetops';
		$node->extend_context($sub_context);
		$data = $node->generate();
		extract($data);
		# create views
		$contentview = Template::view(array('library_treetops'),$dictionary);
		$viewwrapper = Template::view(array('library_treetops_wrapper'));
		$sidebarview = Template::view(array('library_treetops_sidebar'),$admindictionary);
		$path = 'ftreetops-';
		$contentview->path = $path;
		$viewwrapper->path = $path;
		$viewwrapper->contentcount = $contentview->recordcount;
		# update views and combine templates
		$pageview = $this->_pageview;
		$viewwrapper->base = $this->_base;
		$viewwrapper->common = $this->_common;
		$viewwrapper->listcontents = $contentview;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/treetops';
		$pageview->title = 'Library - Treetops';
		# finish
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _files()
	{
		# redirect for specific object
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_file_contents($objectid);
			
		# get node
		$node = Base\Node::file_list($this,'list');
		$data = $node->generate();
		extract($data);
		# create view
		$contentview = Template::view(array('library_files'),$dictionary);
		$viewwrapper = Template::view(array('library_files_wrapper'));
		$sidebarview = Template::view(array('library_files_sidebar'),$admindictionary);
		# combine templates
		$pageview = $this->_pageview;
		$viewwrapper->base = $this->_base;
		$viewwrapper->listcontents = $contentview;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'folders';
		$pageview->title = 'Library - Folders';
		# finish
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _file_contents($objectid)
	{
		if ((strtolower($objectid) === 'new') or (strtolower($objectid) === 'setup')) {
			return $this->_file_setup();
		} // else $objectid is the file number
		# get record data
		$node = Base\Node::file_record($this);
		$recordsubcontext = new StdClass;
		$recordsubcontext->articleid = $objectid;
		$node->extend_context($recordsubcontext);
		$recorddata = $node->generate();
		$recorddictionary = $recorddata['dictionary'];
		$recordadmindictionary = $recorddata['admindictionary'];
		$bookmark = $recorddata['bookmark'];
		# get list data
		$node = Base\Node::file_list($this,'contents');
		$listsubcontext = new StdClass;
		$listsubcontext->foreignkeyvalue = $objectid;
		$listsubcontext->redirect = 'library/files/' . $objectid;
		$listsubcontext->default_orderby = 'Order';
		$listsubcontext->secondary_orderby = $recorddictionary['default_order'];
		$listsubcontext->secondary_direction = $recorddictionary['default_direction'];
		$listsubcontext->list_layout = $recorddictionary['list_layout'];
		$node->extend_context($listsubcontext);
		$listdata = $node->generate();
		$listdictionary = $listdata['dictionary'];
		# create templates
		$recordview = Template::view(array('file_contents_list_wrapper'),$recorddictionary);
		$listview = Template::view(array('file_contents_list'),$listdictionary);
		$sidebarview = Template::view(array('file_contents_list_sidebar'),$recordadmindictionary);
		# augment template data
		$recordview->bookmark = $bookmark;
		$listview->path = $recordview->path;
		$listview->pagepath = $recordview->pagepath;
		$listview->instanceid = $recordview->instanceid;
		# combine templates
		$recordview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $recordview;
		$pageview->leftcolumn = $sidebarview;
		# finish
		$listview->fileid = $recordview->id;
		$sidebarview->code = $recordview->code;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/folders' . $objectid;
		$pageview->title = 'Folder: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _file_setup()
	{
		$selector = $this->request->param('selector'); // 'files'
		$operation = $this->request->param('id'); // 'setup'
		$objectid = $this->request->param('code'); // NULL or number

		$articleid = $objectid;
		if ((!empty($articleid)) and (!is_numeric($articleid))) {
			echo 'invalid file reference';
			return;
		}
		$node = Base\Node::file_record($this,'setup');
		$sub_context = new StdClass();
		$sub_context->articleid = $articleid;
		$node->extend_context($sub_context);
		$data = $node->generate();
		extract($data);
		$recordview = Template::view(array('files_record'),$dictionary);
		$viewwrapper = Template::view(array('files_record_wrapper'),$dictionary);
		$sidebarview = Template::view(array('files_record_sidebar'),$admindictionary);
		$viewwrapper->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'files/setup/' . $articleid;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;
		$title = 'File setup: ' . $recordview->title;
		$pageview->title =  $title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _pictures()
	{
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_picture_record();
			
		$node = Base\Node::picture_list($this);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('library_pictures_wrapper'));
		$listview = Template::view(array('library_pictures'),$dictionary);
		$sideview = Template::view(array('library_pictures_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/pictures';
		$pageview->title = 'Library - Pictures';
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _picture_record()
	{
		$articleid = $this->request->param('id');
		if ($articleid === 'new' or $articleid == 'setup') {
			$articleid = $this->request->param('code'); // NULL or number
		}
		# get data
		$node = Base\Node::picture_record($this);
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('picture_record_wrapper'),$dictionary);
		$wrapperview->bookmark = $bookmark;
		$recordview = Template::view(array('picture_record'),$dictionary);
		$sideview = Template::view(array('picture_record_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/pictures/' . $articleid;
		$pageview->title = 'Picture: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _docfiles()
	{
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_docfile_record();
			
		$node = Base\Node::docfile_list($this);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('library_docfiles_wrapper'));
		$listview = Template::view(array('library_docfiles'),$dictionary);
		$sideview = Template::view(array('library_docfiles_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->title = 'Library - Document Files';
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _docfile_record()
	{
		$articleid = $this->request->param('id');
		if ($articleid === 'new' or $articleid == 'setup') {
			$articleid = $this->request->param('code'); // NULL or number
		}
		# get data
		$node = Base\Node::docfile_record($this);
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('docfile_record_wrapper'),$dictionary);
		$wrapperview->bookmark = $bookmark;
		$recordview = Template::view(array('docfile_record'),$dictionary);
		$sideview = Template::view(array('docfile_record_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/docfiles/' . $articleid;
		$pageview->title = 'Document File: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _docextracts()
	{
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_docextract_record();
			
		$node = Base\Node::docextract_list($this);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('library_docextracts_wrapper'));
		$listview = Template::view(array('library_docextracts'),$dictionary);
		$sideview = Template::view(array('library_docextracts_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->title = 'Library - Document Extracts';
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _docextract_record()
	{
		$articleid = $this->request->param('id');
		if ($articleid === 'new' or $articleid == 'setup') {
			$articleid = $this->request->param('code'); // NULL or number
		}
		# get data
		$node = Base\Node::docextract_record($this);
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('docextract_record_wrapper'),$dictionary);
		$wrapperview->bookmark = $bookmark;
		$recordview = Template::view(array('docextract_record'),$dictionary);
		$sideview = Template::view(array('docextract_record_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/docextracts/' . $articleid;
		$pageview->title = 'Document Extract: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _links()
	{
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_link_record();

		$node = Base\Node::link_list($this);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('library_links_wrapper'));
		$listview = Template::view(array('library_links'),$dictionary);
		$sideview = Template::view(array('library_links_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->title = 'Library - Links';
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _link_record()
	{
		$articleid = $this->request->param('id');
		if ($articleid === 'new' or $articleid == 'setup') {
			$articleid = $this->request->param('code'); // NULL or number
		}
		# get data
		$node = Base\Node::link_record($this);
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('link_record_wrapper'),$dictionary);
		$wrapperview->bookmark = $bookmark;
		$recordview = Template::view(array('link_record'),$dictionary);
		$sideview = Template::view(array('link_record_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/links/' . $articleid;
		$pageview->title = 'Link: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _widgets()
	{
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_widget_record();
			
		$node = Base\Node::widget_list($this);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('library_widgets_wrapper'));
		$listview = Template::view(array('library_widgets'),$dictionary);
		$sideview = Template::view(array('library_widgets_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->title = 'Library - Widgets';
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _widget_record()
	{
		$articleid = $this->request->param('id');
		if ($articleid === 'new' or $articleid == 'setup') {
			$articleid = $this->request->param('code'); // NULL or number
		}
		# get data
		$node = Base\Node::widget_record($this);
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$wrapperview = Template::view(array('widget_record_wrapper'),$dictionary);
		$wrapperview->bookmark = $bookmark;
		$recordview = Template::view(array('widget_record'),$dictionary);
		$sideview = Template::view(array('widget_record_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/widgets/' . $articleid;
		$pageview->title = 'Widget: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _inboxes()
	{
		# redirect for specific object
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_inbox_contents($objectid);
			
		# get node
		$node = Base\Node::inbox_list($this,'list');
		$data = $node->generate();
		extract($data);
		# create view
		$contentview = Template::view(array('library_inboxes'),$dictionary);
		$viewwrapper = Template::view(array('library_inboxes_wrapper'));
		$sidebarview = Template::view(array('library_inboxes_sidebar'),$admindictionary);
		# combine templates
		$pageview = $this->_pageview;
		$viewwrapper->base = $this->_base;
		$viewwrapper->listcontents = $contentview;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;
		$pageview->title = 'Library - Inboxes';
		# finish
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _inbox_treetops()
	{
		# get node data
		$node = Base\Node::inbox_list($this,'treetops');
		$sub_context = new StdClass();
		$sub_context->treetopsflag = TRUE;
//		$sub_context->redirect = 'library/inboxes/treetops';
		$node->extend_context($sub_context);
		$data = $node->generate();
		extract($data);
		# create views
		$contentview = Template::view(array('library_inbox_treetops'),$dictionary);
		$viewwrapper = Template::view(array('library_inbox_treetops_wrapper'));
		$sidebarview = Template::view(array('library_inbox_treetops_sidebar'),$admindictionary);
		$path = 'itreetops-';
		$contentview->path = $path;
		$viewwrapper->path = $path;
		$viewwrapper->contentcount = $contentview->recordcount;
		# update views and combine templates
		$pageview = $this->_pageview;
		$viewwrapper->base = $this->_base;
		$viewwrapper->listcontents = $contentview;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;
		$pageview->title = 'Library - Inbox Treetops';
		# finish
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _inbox_contents($objectid)
	{
		if ((strtolower($objectid) === 'new') or (strtolower($objectid) === 'setup')) {
			return $this->_inbox_setup();
		} // else $objectid is the file number
		if (strtolower($objectid) === 'treetops') {
			return $this->_inbox_treetops();
		} // else $objectid is the file number
		# get record data
		$node = Base\Node::inbox_record($this);
		$recordsubcontext = new StdClass;
		$recordsubcontext->articleid = $objectid;
		$node->extend_context($recordsubcontext);
		$recorddata = $node->generate();
		$recorddictionary = $recorddata['dictionary'];
		$recordadmindictionary = $recorddata['admindictionary'];
		$bookmark = $recorddata['bookmark'];
		# get list data
		$node = Base\Node::inbox_list($this,'contents');
		$listsubcontext = new StdClass;
		$listsubcontext->foreignkeyvalue = $objectid;
		$listsubcontext->redirect = 'library/inboxes/' . $objectid;
		$listsubcontext->default_orderby = 'Order';
		$listsubcontext->secondary_orderby = $recorddictionary['default_order'];
		$listsubcontext->secondary_direction = $recorddictionary['default_direction'];
		$listsubcontext->list_layout = $recorddictionary['list_layout'];
		$node->extend_context($listsubcontext);
		$listdata = $node->generate();
		$listdictionary = $listdata['dictionary'];
		# create templates
		$recordview = Template::view(array('inbox_contents_list_wrapper'),$recorddictionary);
		$listview = Template::view(array('inbox_contents_list'),$listdictionary);
		$sidebarview = Template::view(array('inbox_contents_list_sidebar'),$recordadmindictionary);
		# augment template data
		$recordview->bookmark = $bookmark;
		$listview->path = $recordview->path;
		$listview->pagepath = $recordview->pagepath;
		$listview->instanceid = $recordview->instanceid;
		# combine templates
		$recordview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $recordview;
		$pageview->leftcolumn = $sidebarview;
		# finish
		$listview->inboxid = $recordview->id;
		$sidebarview->code = $recordview->code;
		$pageview->title = 'Inbox: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _inbox_setup()
	{
		$selector = $this->request->param('selector'); // 'inboxes'
		$operation = $this->request->param('id'); // 'setup'
		$objectid = $this->request->param('code'); // NULL or number

		$articleid = $objectid;
		if ((!empty($articleid)) and (!is_numeric($articleid))) {
			echo 'invalid inbox reference';
			return;
		}
		$node = Base\Node::inbox_record($this,'setup');
		$sub_context = new StdClass();
		$sub_context->articleid = $articleid;
		$node->extend_context($sub_context);
		$data = $node->generate();
		extract($data);
//		var_dump($dictionary);
		$recordview = Template::view(array('inboxes_record'),$dictionary);
		$viewwrapper = Template::view(array('inboxes_record_wrapper'),$dictionary);
		$sidebarview = Template::view(array('inboxes_record_sidebar'),$admindictionary);
		$viewwrapper->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'files/setup/' . $articleid;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;
		$title = 'Inbox setup: ' . $recordview->title;
		$pageview->title =  $title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _comments()
	{
		# redirect for specific object
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_comment($objectid);
			
		# get data
		$node = Base\Node::comment_list($this);
		$subcontext = new StdClass;
		$subcontext->articleid = NULL;
		$subcontext->get_admindictionary = TRUE;
		$subcontext->redirect = 'library/comments';
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		#create views
		$wrapperview = Template::view(array('library_comments_wrapper'),$dictionary);
		$contentview = Template::view(array('comment_list'),$dictionary);
		$sidebarview = Template::view(array('library_comments_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $contentview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sidebarview;
		# finish
		$pageview->title = 'Library - Comments';
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	public function _comment()
	{
		$commentid = $this->request->param('id');
		# get data
		$node = Base\Node::comment_record($this);
		$subcontext = new StdClass;
		$parentid = $subcontext->parentid = Services::dblookup('Nodes_View','CommentArticleID','ID',$commentid);
		$subcontext->redirect = 'library/comments';
		if (!is_numeric($parentid)) {
			$this->request->redirect($subcontext->redirect);
		}
		$subcontext->articleid = $commentid;
		$subcontext->get_admindictionary = TRUE;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		#create views
		$wrapperview = Template::view(array('library_comment_wrapper'));
		$contentview = Template::view(array('library_comment_record'),$dictionary);
		$sidebarview = Template::view(array('library_comment_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->recordcontents = $contentview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sidebarview;
		# finish
		$pageview->title = 'Library - Comment';
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _directories()
	{
		
		# redirect for specific object
		$objectid = $this->request->param('id');
		if (!empty($objectid))
			return $this->_directory_contents($objectid);
			
		# get node
		$node = Base\Node::directory_list($this,'list');
		$data = $node->generate();
		extract($data);
		# create view
		$listview = Template::view(array('library_directories'),$dictionary);
		$path = 'directories-';
		$listview->path = $path;
		$wrapperview = Template::view(array('library_directories_wrapper'));
		$wrapperview->path = $path;
		$sidebarview = Template::view(array('library_directories_sidebar'),$admindictionary);
		# combine templates
		$pageview = $this->_pageview;
		$wrapperview->base = $this->_base;
		$wrapperview->listcontents = $listview;
		$wrapperview->contentcount = $listview->recordcount;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sidebarview;
		$pageview->title = 'Library - Directories';
		# finish
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _directory_contents($objectid)
	{
		if ((strtolower($objectid) === 'new') or (strtolower($objectid) === 'setup')) {
			return $this->_directory_setup();
		} // else $objectid is the file number
		# get record data
		$node = Base\Node::directory_record($this);
		$recordsubcontext = new StdClass;
		$recordsubcontext->articleid = $objectid;
		$node->extend_context($recordsubcontext);
		$recorddata = $node->generate();
		$recorddictionary = $recorddata['dictionary'];
		$recordadmindictionary = $recorddata['admindictionary'];
		$bookmark = $recorddata['bookmark'];
		# get list data
		$node = Base\Node::directory_list($this,'contents');
		$listsubcontext = new StdClass;
		$listsubcontext->foreignkeyvalue = $objectid;
		$listsubcontext->redirect = 'library/directories/' . $objectid;
		$listsubcontext->default_orderby = $recorddictionary['default_order'];
		$listsubcontext->default_direction = $recorddictionary['default_direction'];
		$listsubcontext->list_layout = $recorddictionary['list_layout'];
		$node->extend_context($listsubcontext);
		$listdata = $node->generate();
		$listdictionary = $listdata['dictionary'];
		# create templates
		$recordview = Template::view(array('directory_contents_list_wrapper'),$recorddictionary);
		$listview = Template::view(array('directory_contents_list'),$listdictionary);
		$sidebarview = Template::view(array('directory_contents_list_sidebar'),$recordadmindictionary);
		# augment template data
		$recordview->bookmark = $bookmark;
		$listview->path = $recordview->path;
		$listview->max_file_uploads = ini_get('max_file_uploads');
		$listview->pagepath = $recordview->pagepath;
		$listview->instanceid = $recordview->instanceid;
		# combine templates
		$recordview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $recordview;
		$pageview->leftcolumn = $sidebarview;
		# finish
		$listview->fileid = $recordview->id;
		$sidebarview->code = $recordview->code;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'library/directories/' . $objectid;
		$pageview->title = 'Directory: ' . $recordview->title;
		$this->show_resources();
		$this->response->body($pageview);
	}
	public function _directory_setup()
	{
		$selector = $this->request->param('selector'); // 'files'
		$operation = $this->request->param('id'); // 'setup'
		$objectid = $this->request->param('code'); // NULL or number

		$articleid = $objectid;
		if ((!empty($articleid)) and (!is_numeric($articleid))) {
			echo 'invalid directory reference';
			return;
		}
		$node = Base\Node::directory_record($this,'setup');
		$sub_context = new StdClass();
		$sub_context->articleid = $articleid;
		$node->extend_context($sub_context);
		$data = $node->generate();
		extract($data);
		$recordview = Template::view(array('directory_record'),$dictionary);
		$viewwrapper = Template::view(array('directory_record_wrapper'),$dictionary);
		$sidebarview = Template::view(array('directory_record_sidebar'),$admindictionary);
		$viewwrapper->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'directories/setup/' . $articleid;
		$pageview->centercolumn = $viewwrapper;
		$pageview->leftcolumn = $sidebarview;
		$title = 'Directory setup: ' . $recordview->title;
		$pageview->title =  $title;
		$this->show_resources();
		$this->response->body($pageview);
	}
}
