<?php defined('SYSPATH') or die('No direct script access.');
// Muster Software Copyright (c) Henrik Bechmann, Toronto, Canada 2012. All rights reserved.
// See "musterlicence.txt" for licencing information.
// mustersoftware.net
class Controller_Pages extends Controller_Site {

	public function action_index()
	{
		$selector = $this->request->param('selector');
		$id = $this->request->param('id');
		if (empty($selector)) {
			$this->_branches();
		} elseif ($selector == 'list') {
			$this->_list();
		} else {
			$this->_record();
		}
	}

	protected function _list()
	{
		# get data
		$node = Base\Node::page_list($this);
		$data = $node->generate();
		extract($data);
		# create templages
		$wrapperview = Template::view(array('pages_list_wrapper'));
		$listview = Template::view(array('pages_list'),$dictionary);
		$sideview = Template::view(array('pages_list_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->title = 'Pages - List';
		$this->show_resources();
		$this->response->body($pageview);
	}

	protected function _branches()
	{
		# get data
		$node = Base\Node::page_list($this);
		$subcontext = new StdClass;
		$subcontext->branchflag = TRUE;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$listview = Template::view(array('pages_branches'),$dictionary);
		$wrapperview = Template::view(array('pages_branches_wrapper'));
		$sideview = Template::view(array('pages_branches_sidebar'),$admindictionary);
		# combine templates
		$wrapperview->listcontents = $listview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$pageview->title = 'Pages - Branches';
		$this->show_resources();
		$this->response->body($pageview);
	}
	
	protected function _record()
	{
		# get articleid
		$selector = $this->request->param('selector');
		$pageid = $this->request->param('id');
		$pagecode = NULL;
		if ($selector == 'record') {
			$articleid = $pageid;
		} else {
			if (!empty($pageid)) {
				$articleid = $pageid;
				$pagecode = $selector;
			} else {
				$articleid = $selector;
			}
		}
		if ((!empty($articleid)) and (!is_numeric($articleid))) { // this is a pagecode
			$pagecode = $articleid;
			$articleid = Services::dblookup('Nodes_View','ID','PageCode',$pagecode);
		}
		# get data
		$node = Base\Node::page_record($this);
		$subcontext = new StdClass;
		$subcontext->articleid = $articleid;
		$node->extend_context($subcontext);
		$data = $node->generate();
		extract($data);
		# create templates
		$recordview = Template::view(array('pages_record'),$dictionary);
		$wrapperview = Template::view(array('pages_record_wrapper'),$dictionary);
		$sideview = Template::view(array('pages_record_sidebar'),$admindictionary);
		if (isset($dictionary['narrativesection']->pagechildren))
			$sideview->pagechildren = $dictionary['narrativesection']->pagechildren;
		# combine templates
		$wrapperview->recordcontents = $recordview;
		$pageview = $this->_pageview;
		$pageview->centercolumn = $wrapperview;
		$pageview->leftcolumn = $sideview;
		# finish
		$sideview->pagecode = $pagecode;
		$sideview->pageid = $recordview->id;
		$sideview->pageparentid = $recordview->pageparentid;
		$pageview->canonical = 'http://' . System::instance()->Website . $this->_base . 'pages/' . $articleid;
		$pageview->title = 'Info Page: ' . htmlspecialchars($recordview->title);
		$this->show_resources();
		$this->response->body($pageview);
	}
}
