<?php defined('SYSPATH') or die('No direct access allowed.');

return array
(
	'default' => array(
		'type'       => 'pdo_mysql',
		'connection' => array(
			/**
			 * The following options are available for PDO:
			 *
			 * string   dsn
			 * string   username
			 * string   password
			 # obsolete: boolean	persistent property replaced by PDO::ATTR_PERSISTENT attribute
			 # new...
			 * array    attributes, consisting of PDO constants (constant=>value/constant)
			 */
			'dsn'        => 'mysql:host=localhost;dbname=<enter database name>',
			'username'   => '<enter user name>',
			'password'   => '<enter password>',
			'attributes'    => array( // pdo connection attributes
				PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION, // _EXCEPTION or _SILENT or _WARNING
				PDO::ATTR_PERSISTENT => FALSE,
			),
		),
		// array 	result statements, default settings for pdo statements
		'result' => array( // default settings for select statements
			/**
			* The following options are available for pdo result statements, as defaults:
			*
			* array 	attributes, consisting of PDO constants
			* string	class, result class Database_Result_<resultclass>
			* boolean 	emulatecursor, emulate cursor scroll, not recommended; uses extra resources and processing
			*/
			'attributes' => array( // pdo statement attributes
				PDO::MYSQL_ATTR_USE_BUFFERED_QUERY => TRUE, // unique to mysql pdo driver
				PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY, // or PDO::CURSOR_SCROLL, (not available for mysql) for special requirements
			),
			'type' => 'pdo', // Database_Result_<type>
			'emulatecursor' => FALSE, // for pdo result class
		),
		// array 	operation statements, default settings for pdo statements
		'operation' => array( // default settings for operation statements (update, delete, insert)
			/**
			* The following options are available for pdo operation statements, as defaults:
			*
			* array 	attributes, consisting of PDO constants
			* string	class, result class Database_Result_<resultclass>
			*/
			'attributes' => array( // pdo statement attributes
				PDO::MYSQL_ATTR_USE_BUFFERED_QUERY => TRUE, // unique to mysql pdo driver
			),
			'type' => 'pdo', // Database_Operation_<type>
		),
		// string   identifier, to quote table and column identifiers
		'identifier' => '`',
		'table_prefix' => '',
		'charset'      => 'utf8',
		'caching'      => FALSE,
		'profiling'    => TRUE,
	
	),
);