<?php defined('SYSPATH') or die('No direct script access.');
$include_config = (object) Kohana::$config->load('accountdata');
$include_array = Point::dictionary()
	->variables(array(
#==============[ COMMON ]===================
	'usercode' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_RECORD,
				'recordindex' => 'useraccount',
				'field' => 'Code',
			),
			'output' => array(
				'index' => 'usercode',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'userimage' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_RECORD,
				'recordindex' => 'useraccount',
				'field' => 'Image',
			),
			'output' => array(
				'index' => 'userimage',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
/*	'base' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'base',
			),
			'output' => array(
				'index' => 'base',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
*/
	'showcomments' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => TRUE,
			),
			'output' => array(
				'index' => 'showcomments',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => array(
				'name' => 'comments',
				'value' => TRUE,
			),
		)
	),
	'showarticles' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => TRUE,
			),
			'output' => array(
				'index' => 'showarticles',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => array(
				'name' => 'articles',
				'value' => TRUE,
			),
		)
	),
	'showblogs' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => TRUE,
			),
			'output' => array(
				'index' => 'showblogs',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'blogs',
				'value' => TRUE,
			),
		)
	),
	'showpassword' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => TRUE,
			),
			'output' => array(
				'index' => 'showpassword',
			),
			'datatype' => Point::DATATYPE_STRING,
			'access' => array(
				'token' => 'account_password',
				'requires' => 'RE',
			),
		)
	),
	'showadminnotes' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => TRUE,
			),
			'output' => array(
				'index' => 'showadminnotes',
			),
			'datatype' => Point::DATATYPE_STRING,
			'access' => array(
				'token' => 'account_adminnotes',
				'requires' => 'RE',
			),
		)
	),
	'showscratchpad' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => TRUE,
			),
			'output' => array(
				'index' => 'showscratchpad',
			),
			'datatype' => Point::DATATYPE_STRING,
			'access' => array(
				'token' => 'account_scratchpad',
				'requires' => 'RE',
			),
		)
	),
	#==============[ BASIC ]===================
	'basicupdatedisabled' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_NOT_PERMITTED,
				'access' => array(
					'token' => 'account_basics',
					'requires' => 'E',
				),
			),
			'output' => array(
				'index' => 'basicupdatedisabled',
				'filter' => array(
					'method'=>Point::FILTER_DISABLED,
				),
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)
	),
	# ============================================
	# basic section (basic information tab)
	# ============================================
	'basicsection' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'basicsection',
			),
			'input' => array(
				'constraint' => array(
					'name' => 'edit',
					'value' => 'basic',
				),
			),
		)
	)
	->variables(
		array(
			'basicerrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'basicerrors',
					),
					'output' => array(
						'index' => 'basicerrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'basicmessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'basicmessages',
					),
					'output' => array(
						'index' => 'basicmessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'profileprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'profileprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'PublicProfile',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
				)
			),
			'profilememberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'PublicProfile',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => '0',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'profileprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => '0',
							),
						),
					),
					'output' => array(
						'index' => 'profilememberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->profileprivacy,
				)
			),
			'profilepublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'PublicProfile',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => '1',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'profileprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => '1',
							),
						),
					),
					'output' => array(
						'index' => 'profilepublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->profileprivacy,
				)
			),
			'usercode' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Code',
					),
					'output' => array(
						'index' => 'usercode',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'name' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Name',
					),
					'output' => array(
						'index' => 'name',
					),
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'name',
					),
					'rules' => array(
						array('not_empty'),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Name',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'nameprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'nameprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'name',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'namememberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'name',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'nameprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'namememberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->nameprivacy,
				)
			),
			'namepublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'name',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'nameprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'namepublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->nameprivacy,
				)
			),
			'city' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'City',
					),
					'output' => array(
						'index' => 'city',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'city',
					),
					'rules' => array(
						array('not_empty'),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'City',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'cityprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'cityprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'city',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'citymemberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'city',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'cityprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'citymemberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->cityprivacy,
				)
			),
			'citypublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'city',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'cityprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'citypublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->cityprivacy,
				)
			),
			'email' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Email',
					),
					'output' => array(
						'index' => 'email',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'email',
					),
					'rules' => array(
						array('not_empty'),
						array('email'),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Email',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'emailprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'emailprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'email',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'emailprivatechecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'email',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'emailprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'output' => array(
						'index' => 'emailprivatechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->emailprivacy,
				)
			),
			'emailmemberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'email',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'emailprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'emailmemberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->emailprivacy,
				)
			),
			'emailpublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'email',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'emailprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'emailpublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->emailprivacy,
				)
			),
			'birthdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Birthdate',
					),
					'output' => array(
						'index' => 'birthdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'birthdate',
					),
					'rules' => array(
						array('date'),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'birthdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Birthdate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'birthdateprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'birthdateprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'birthdate',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'birthdateprivatechecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'birthdate',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'birthdateprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'output' => array(
						'index' => 'birthdateprivatechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->birthdateprivacy,
				)
			),
			'birthdatememberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'birthdate',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'birthdateprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'birthdatememberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->birthdateprivacy,
				)
			),
			'birthdatepublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'birthdate',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'birthdateprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'birthdatepublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->birthdateprivacy,
				)
			),
			'gender' => Point::optionsection()
			->properties(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Gender',
					),
					'output' => array(
						'index' => 'gender',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'gender',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Gender',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			)
			->driver(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'gender',
					),
					'datapoolarray' => array(
						'name' => 'gender',
						'index' => 'value',
						'value' => 'caption',
					),
					'selectionvariable' => 'gender',
				)
			)
			->variables(
				array(
					'value' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'gender',
								'index' => 'value',
							),
							'output' => array(
								'index' => 'value',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
					'selected' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_MATCH,
								'match' => array(
									'method' => Point::DATASOURCE_VARIABLE,
									'name' => 'gender',
									'blockindex' => 'value',
								),
							),
							'output' => array(
								'index' => 'selected',
								'filter' => array(
									'method' => Point::FILTER_CHECKED,
								),
							),
							'datatype' => Point::DATATYPE_BOOLEAN,
						)
					),
					'caption' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'gender',
								'index' => 'caption',
							),
							'output' => array(
								'index' => 'caption',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
				)
			),
			'genderprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'genderprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'gender',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'genderprivatechecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'gender',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'genderprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'output' => array(
						'index' => 'genderprivatechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->genderprivacy,
				)
			),
			'gendermemberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'gender',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'genderprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'gendermemberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->genderprivacy,
				)
			),
			'genderpublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'gender',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'genderprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'genderpublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->genderprivacy,
				)
			),
			'interestsprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'interestsprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'interests',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'interests' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Interests',
					),
					'output' => array(
						'index' => 'interests',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'interests',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Interests',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'interestsprivatechecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'interests',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'interestsprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'output' => array(
						'index' => 'interestsprivatechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->interestsprivacy,
				)
			),
			'interestsmemberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'interests',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'interestsprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'interestsmemberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->interestsprivacy,
				)
			),
			'interestspublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'interests',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'interestsprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'interestspublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->interestsprivacy,
				)
			),
			'createdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'output' => array(
						'index' => 'createdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'createuserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'output' => array(
						'index' => 'createuserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createuserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'editdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'output' => array(
						'index' => 'editdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'editdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'edituserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'output' => array(
						'index' => 'edituserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'edituserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'recordversion' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'output' => array(
						'index' => 'recordversion',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'recordversion',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
		)
	),
	#==============[ PICTURES ]===================
	'uploadimagedisabled' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_NOT_PERMITTED,
				'access' => array(
					'token' => 'account_image',
					'requires' => 'E',
				),
			),
			'output' => array(
				'index' => 'uploadimagedisabled',
				'filter' => array(
					'method' => Point::FILTER_DISABLED,
				),
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)
	),
	# ============================================
	# picture section: picture tab
	# ============================================
	'picturesection' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'picturesection',
			),
			'input' => array(
				'constraint' => array(
					'name' => 'edit',
					'value' => 'picture',
				),
			),
		)
	)
	->variables(
		array(
			'updateimagesettingsdisabled' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_NOT_PERMITTED,
						'access' => array(
							'token' => 'account_image',
							'requires' => 'E',
						),
					),
					'output' => array(
						'index' => 'updateimagesettingsdisabled',
						'filter' => array(
							'method' => Point::FILTER_DISABLED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
				)
			),
			'pictureerrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'pictureerrors',
					),
					'output' => array(
						'index' => 'pictureerrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'picturemessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'picturemessages',
					),
					'output' => array(
						'index' => 'picturemessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'imageprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => POINT::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'imageprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'image',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'imageprivatechecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'image',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'output' => array(
						'index' => 'imageprivatechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->imageprivacy,
				)
			),
			'imagememberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'image',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'imagememberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->imageprivacy,
				)
			),
			'imagepublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'image',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'imagepublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->imageprivacy,
				)
			),
			'createdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'output' => array(
						'index' => 'createdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createdate',
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'createuserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'output' => array(
						'index' => 'createuserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createuserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'editdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'output' => array(
						'index' => 'editdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'editdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'edituserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'output' => array(
						'index' => 'edituserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'edituserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'recordversion' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'output' => array(
						'index' => 'recordversion',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'recordversion',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'usercode' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Code',
					),
					'output' => array(
						'index' => 'usercode',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'userimage' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Image',
					),
					'output' => array(
						'index' => 'userimage',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
		)
	),
	# ============================================
	# password section: password tab
	# ============================================
	'passwordsection' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'passwordsection',
			),
			'input' => array(
				'constraint' => array(
					'name' => 'edit',
					'value' => 'password',
				),
			),
			'access' => array(
				'token' => 'account_password',
				'requires' => 'RE',
			),
		)
	)
	->variables(
		array(
			'passworderrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'passworderrors',
					),
					'output' => array(
						'index' => 'passworderrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'passwordmessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'passwordmessages',
					),
					'output' => array(
						'index' => 'passwordmessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'password' => Point::variable(
				array(
					'output' => array(
						'index' => 'password',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'password',
					),
					'rules' => array(
						array('not_empty'),
						array('User_Account::verify_password', array(':value')),
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'newpassword' => Point::variable(
				array(
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'newpassword',
					),
					'rules' => array(
						array('not_empty'),
						array('min_length', array(':value',5)),
						array('max_length', array(':value',20)),
						array('matches',array(':validation',':field','confirmpassword')),
					),
					'output' => array(
						'index' => 'newpassword',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Password',
						'filter' => array(
							'method' => Point::FILTER_HASHPASSWORD,
						),
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'confirmpassword' => Point::variable(
				array(
					'output' => array(
						'index' => 'confirmpassword',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'confirmpassword',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'createdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'output' => array(
						'index' => 'createdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'createuserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'output' => array(
						'index' => 'createuserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createuserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'editdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'output' => array(
						'index' => 'editdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'editdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'edituserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'output' => array(
						'index' => 'edituserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'edituserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'recordversion' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'output' => array(
						'index' => 'recordversion',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'recordversion',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
		)
	),
	#==============[ DETAILPROFILE ]===================
	'editdetailprofiledisabled' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_NOT_PERMITTED,
				'access' => array(
					'token' => 'account_profile',
					'requires' => 'E',
				),
			),
			'output' => array(
				'index' => 'editdetailprofiledisabled',
				'filter' => array(
					'method' => Point::FILTER_DISABLED,
				),
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)
	),
	'editdetailprofile' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => TRUE,
			),
			'output' => array(
				'index' => 'editdetailprofile',
			),
			'constraint' => array(
				'name' => 'edit',
				'value' => 'profile',
			),
			'access' => array(
				'token' => 'account_profile',
				'requires' => 'RE',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)
	),
	# ============================================
	# profile section (edit): Detailed profile tab
	# ============================================
	'profilesectionedit' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'profilesectionedit',
			),
			'input' => array(
				'constraint' => array(
					'name' => 'edit',
					'value' => 'profile',
				),
			),
		)
	)
	->variables(
		array(
			'profileerrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'profileerrors',
					),
					'output' => array(
						'index' => 'profileerrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'profilemessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'profilemessages',
					),
					'output' => array(
						'index' => 'profilemessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'detailprofilerelease' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'ReleaseDetailProfile',
					),
					'output' => array(
						'index' => 'detailprofilereleasechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'releasedetailprofile',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'ReleaseDetailProfile',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->detailprofilerelease,
				)
			),
			'detailprofileprivacy' => Point::variable(
				array(
					'input' => array (
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'detailprofileprivacy',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'detailprofile',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'detailprofileprivatechecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'detailprofile',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'detailprofileprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'output' => array(
						'index' => 'detailprofileprivatechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->detailprofileprivacy,
				)
			),
			'detailprofilememberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'detailprofile',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'detailprofileprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'detailprofilememberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->detailprofileprivacy,
				)
			),
			'detailprofilepublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'detailprofile',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'recover' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'detailprofileprivacy',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'detailprofilepublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->detailprofileprivacy,
				)
			),
			'detailprofile' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'DetailProfile',
					),
					'output' => array(
						'index' => 'detailprofile',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'detailprofile',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'DetailProfile',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'profilepreview' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_BLOCKVALUE,
						'name' => 'detailprofile',
						'filter' => array(
							'method' => Point::FILTER_MARKUP,
							'arguments' => array(
								'parser' => array(
									'method' => Point::DATASOURCE_RECORD,
									'recordindex' => 'useraccount',
									'field' => 'MarkupTypeID',
								),
							),
						),
					),
					'output' => array(
						'index' => 'profilepreview',
					),
					'constraint' => array(
						'name' => 'preview',
						'value' => TRUE,
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'createdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'output' => array(
						'index' => 'createdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'createuserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'output' => array(
						'index' => 'createuserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createuserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'editdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'output' => array(
						'index' => 'editdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'editdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'edituserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'output' => array(
						'index' => 'edituserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'edituserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'recordversion' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'output' => array(
						'index' => 'recordversion',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'recordversion',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
		)
	),
	# ============================================
	# profile section (display): detailed profile tab
	# ============================================
	'profilesectiondisplay' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'profilesectiondisplay',
			),
			'notconstraint' => array(
				'name' => 'edit',
				'value' => 'profile',
			),
		)
	)
	->variables(
		array(
			'profilemessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'profilemessages',
					),
					'output' => array(
						'index' => 'profilemessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'detailprofilerelease' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'ReleaseDetailProfile',
					),
					'output' => array(
						'index' => 'detailprofilereleasechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->detailprofilerelease,
				)
			),
			'detailprofileprivatechecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'detailprofile',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'private',
							),
						),
					),
					'output' => array(
						'index' => 'detailprofileprivatechecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->detailprofileprivacy,
				)
			),
			'detailprofilememberschecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'detailprofile',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'members',
							),
						),
					),
					'output' => array(
						'index' => 'detailprofilememberschecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->detailprofileprivacy,
				)
			),
			'detailprofilepublicchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'detailprofile',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => 'public',
							),
						),
					),
					'output' => array(
						'index' => 'detailprofilepublicchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->detailprofileprivacy,
				)
			),
			'detailprofile' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'DetailProfile',
						'filter' => array(
							'method' => Point::FILTER_MARKUP,
							'arguments' => array(
								'parser' => array(
									'method' => Point::DATASOURCE_RECORD,
									'recordindex' => 'useraccount',
									'field' => 'MarkupTypeID',
								),
							),
						),
					),
					'output' => array(
						'index' => 'detailprofile',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
		)
	),
	
	#==============[ ARTICLES ]===================
	// documents tab
	#==============[ COMMENTS ]===================
	// comments tab
	#==============[ BLOG ]===================
	// blogs tab
	
	# ============================================
	# scratchpad section: Personal scratchpad tab
	# ============================================
	'scratchpadsection' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'scratchpadsection',
			),
			'input' => array(
				'constraint' => array(
					'name' => 'edit',
					'value' => 'scratchpad',
				),
			),
			'access' => array(
				'token' => 'account_scratchpad',
				'requires' => 'RE',
			),
		)
	)
	->variables(
		array(
			'scratchpaderrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'scratchpaderrors',
					),
					'output' => array(
						'index' => 'scratchpaderrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'scratchpadmessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'scratchpadmessages',
					),
					'output' => array(
						'index' => 'scratchpadmessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'scratchpad' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Scratchpad',
					),
					'output' => array(
						'index' => 'scratchpad',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'scratchpad',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Scratchpad',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'createdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'output' => array(
						'index' => 'createdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'createuserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'output' => array(
						'index' => 'createuserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createuserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'editdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'output' => array(
						'index' => 'editdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'editdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'edituserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'output' => array(
						'index' => 'edituserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'edituserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'recordversion' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'output' => array(
						'index' => 'recordversion',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'recordversion',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
		)
	),
	#==============[ ADMINISTRATION ]===================
	'adminedit' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => TRUE,
			),
			'output' => array(
				'index' => 'adminedit',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'access' => array(
				'token' => 'account_admin',
				'requires' => 'RE',
			),
		)
	),
	# =================================================
	# admin section (edit): Administration options tab
	# =================================================
	'adminsectionedit' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'adminsectionedit',
			),
			'input' => array(
				'constraint' => array(
					'name' => 'edit',
					'value' => 'admin',
				),
			),
		)
	)
	->variables(
		array(
			'adminerrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'adminerrors',
					),
					'output' => array(
						'index' => 'adminerrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'adminmessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'adminmessages',
					),
					'output' => array(
						'index' => 'adminmessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'logins' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Logins',
					),
					'output' => array(
						'index' => 'logins',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'group' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_OBJECT,
						'name' => 'accountdata',
						'property' => 'GroupID',
						'filter' => array(
							'method' => Point::FILTER_LOOKUP,
							'arguments' => array(
								'name' => 'Access_Groups',
								'index' => 'ID',
								'value' => 'Name',
							),
						),
					),
					'output' => array(
						'index' => 'group',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'roleoptions' => Point::optionsection()
			->properties(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RoleID',
					),
					'output' => array(
						'index' => 'roleoptions',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'roleoption',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RoleID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
					'default' => System::instance()->DefaultRoleID,
				)
			)
			->driver(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_LOOKUP_TABLE,
						'name' => 'Access_Group_Roles',
						'index' => 'ID',
						'value' => 'Name',
						'where' => array(
							array('ImplicitRole','<>',1),
							// ** administered should be called from within gateway to pass arguments
							array('Rank','<=',User_Account::instance()->administered_rank()),
						),
						'orderby' => array(
							array('Rank'),
							array('Order'),
						),
					),
					'datapoolarray' => array(
						'name' => 'role',
						'index' => 'value',
						'value' => 'caption',
					),
					'selectionvariable' => 'role',
				)
			)
			->variables(
				array(
					'value' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'role',
								'index' => 'value',
								
							),
							'output' => array(
								'index' => 'value',
							),
							'datatype' => Point::DATATYPE_INTEGER,
						)
					),
					'selected' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_MATCH,
								'match' => array(
									'method' => Point::DATASOURCE_VARIABLE,
									'name' => 'role',
									'blockindex' => 'value',
								),
							),
							'output' => array(
								'index' => 'selected',
								'filter' => array(
									'method' => Point::FILTER_SELECTED,
								),
							),
							'datatype' => Point::DATATYPE_BOOLEAN,
						)
					),
					'caption' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'role',
								'index' => 'caption',
							),
							'output' => array(
								'index' => 'caption',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
				)
			),
			'statusoptions' => Point::optionsection()
			->properties(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'StatusID',
					),
					'output' => array(
						'index' => 'statusoptions',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'statusoption',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'StatusID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			)
			->driver(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_LOOKUP_TABLE,
						'name' => 'Access_Lookup_User_Status',
						'index' => 'ID',
						'value' => 'Name',
						'where' => array(
							array('ImplicitStatus','<>',1),
						),
					),
					'datapoolarray' => array(
						'name' => 'status',
						'index' => 'value',
						'value' => 'caption',
					),
					'selectionvariable' => 'status',
				)
			)
			->variables(
				array(
					'value' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'status',
								'index' => 'value',
							),
							'output' => array(
								'index' => 'value',
							),
							'datatype' => Point::DATATYPE_INTEGER,
						)
					),
					'selected' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_MATCH,
								'match' => array(
									'method' => Point::DATASOURCE_VARIABLE,
									'name' => 'status',
									'blockindex' => 'value',
								),
							),
							'output' => array(
								'index' => 'selected',
								'filter' => array(
									'method' => Point::FILTER_SELECTED,
								),
							),
							'datatype' => Point::DATATYPE_BOOLEAN,
						)
					),
					'caption' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'status',
								'index' => 'caption',
							),
							'output' => array(
								'index' => 'caption',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
				)
			),
			'commentpermissionchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'comment',
					),
					'output' => array(
						'index' => 'commentpermissionchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'commentpermission',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'comment',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->commentpermission,
				)
			),
			'blogpermissionchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'blog',
					),
					'output' => array(
						'index' => 'blogpermissionchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'blogpermission',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'blog',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->blogpermission,
				)
			),
			'multiblogpermissionchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'multiblog',
					),
					'output' => array(
						'index' => 'multiblogpermissionchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'multiblogpermission',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'multiblog',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->multiblogpermission,
				)
			),
			'articlepermissionchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'article',
					),
					'output' => array(
						'index' => 'articlepermissionchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'articlepermission',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'article',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->articlepermission,
				)
			),
			'unmoderatedchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'unmoderated',
					),
					'output' => array(
						'index' => 'unmoderatedchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'unmoderated',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'unmoderated',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->unmoderated,
				)
			),
			'createdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'output' => array(
						'index' => 'createdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'createuserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'output' => array(
						'index' => 'createuserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createuserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'editdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'output' => array(
						'index' => 'editdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'editdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'edituserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'output' => array(
						'index' => 'edituserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'edituserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'recordversion' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'output' => array(
						'index' => 'recordversion',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'recordversion',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
		)
	),
	# ====================================================
	# admin section (display): Administration options tab
	# ====================================================
	'adminsectiondisplay' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'adminsectiondisplay',
			),
		)
	)
	->variables(
		array(
			'group' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_OBJECT,
						'name' => 'accountdata',
						'property' => 'GroupID',
						'filter' => array(
							'method' => Point::FILTER_LOOKUP,
							'arguments' => array(
								'name' => 'Access_Groups',
								'index' => 'ID',
								'value' => 'Name',
							),
						),
					),
					'output' => array(
						'index' => 'group',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'logins' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'Logins',
					),
					'output' => array(
						'index' => 'logins',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'role' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RoleID',
						'filter' => array(
							'method' => Point::FILTER_LOOKUP,
							'arguments' => array(
								'name' => 'Access_Group_Roles',
								'index' => 'ID',
								'value' => 'Name',
							),
						),
					),
					'output' => array(
						'index' => 'role',
					),
					'datatype' => Point::DATATYPE_STRING,
					'default' => System::instance()->DefaultRoleID,
				)
			),
			'status' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'StatusID',
						'filter' => array(
							'method' => Point::FILTER_LOOKUP,
							'arguments' => array(
								'name' => 'Access_Lookup_User_Status',
								'index' => 'ID',
								'value' => 'Name',
							),
						),
					),
					'output' => array(
						'index' => 'status',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'commentpermissionchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'comment',
					),
					'output' => array(
						'index' => 'commentpermissionchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->commentpermission,
				)
			),
			'blogpermissionchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'blog',
					),
					'output' => array(
						'index' => 'blogpermissionchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->blogpermission,
				)
			),
			'multiblogpermissionchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'multiblog',
					),
					'output' => array(
						'index' => 'multiblogpermissionchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->multiblogpermission,
				)
			),
			'articlepermissionchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'article',
					),
					'output' => array(
						'index' => 'articlepermissionchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->articlepermission,
				)
			),
			'unmoderatedchecked' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD_JSON,
						'recordindex' => 'useraccount',
						'field' => 'Permissions',
						'json' => 'unmoderated',
					),
					'output' => array(
						'index' => 'unmoderatedchecked',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'default' => $include_config->unmoderated,
				)
			),
		)
	),
	#==============[ ADMIN NOTES ]===================
	'saveadminnotesdisabled' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_NOT_PERMITTED,
				'access' => array(
					'token' => 'account_adminnotes',
					'requires' => 'E',
				),
			),
			'output' => array(
				'index' => 'saveadminnotesdisabled',
				'filter' => array(
					'method' => Point::FILTER_DISABLED,
				),
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)
	),
	# ============================================
	# admin notes section: Administrator notes tab
	# ============================================
	'adminnotessection' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'adminnotessection',
			),
			'input' => array(
				'constraint' => array(
					'name' => 'edit',
					'value' => 'adminnotes',
				),
			),
			'access' => array(
				'token' => 'account_adminnotes',
				'requires' => 'RE',
			),
		)
	)
	->variables(
		array(
			'adminnoteserrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'adminnoteserrors',
					),
					'output' => array(
						'index' => 'adminnoteserrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'adminnotesmessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'adminnotesmessages',
					),
					'output' => array(
						'index' => 'adminnotesmessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'adminnotes' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'AdministratorNotes',
					),
					'output' => array(
						'index' => 'adminnotes',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'adminnotes',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'AdministratorNotes',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'createdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'output' => array(
						'index' => 'createdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'createuserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'output' => array(
						'index' => 'createuserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'createuserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'CreateUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'editdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'output' => array(
						'index' => 'editdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'editdate',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'edituserid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'output' => array(
						'index' => 'edituserid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'edituserid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'EditUserID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'recordversion' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'output' => array(
						'index' => 'recordversion',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'recordversion',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'useraccount',
						'field' => 'RecordVersion',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
		)
	),
));
unset($include_config);
return $include_array;
