<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()	
	->variables(array(
	# =================================
	# general
	# =================================
	'layouttype' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'layouttype',
			),
			'output' => array(
				'index' => 'layouttype',
			),
			'datatype' => Point::DATATYPE_STRING,
			'default' => 'tiles',
		)
	),
	# recordlisting
	'records' => Point::sectionlist()
		->properties(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_TABLEACTIVERECORD,
					'tableindex' => 'mastertable',
				),
				'output' => array(
					'index' => 'records',
				),
			)		
		)
		->variables(
			array(
				'id' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'ID',
						),
						'output' => array(
							'index' => 'id',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'is_favourite' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ISFAVOURITE,
							'articleidref' => 'id',
						),
						'output' => array(
							'index' => 'is_favourite',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'approval' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Approval',
						),
						'output' => array(
							'index' => 'approval',
						),
						'datatype' => Point::DATATYPE_STRING,
						'access' => array(
							'token' => 'article_unpublished',
							'requires' => 'R',
						),
					)
				),
				'imageurl' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Image',
						),
						'output' => array(
							'index' => 'imageurl',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'source' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Source',
						),
						'output' => array(
							'index' => 'source',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'blogcode' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'BlogCode',
						),
						'output' => array(
							'index' => 'code',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'pagecode' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'PageCode',
						),
						'output' => array(
							'index' => 'pagecode',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'pageparentid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'PageParentID',
						),
						'output' => array(
							'index' => 'pageparentid',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'title' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Title',
						),
						'output' => array(
							'index' => 'title',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'caption' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Caption',
						),
						'output' => array(
							'index' => 'caption',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'date' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'ArticleDate',
						),
						'output' => array(
							'index' => 'date',
						),
						'datatype' => Point::DATATYPE_DATE,
					)
				),
				'location' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Location',
						),
						'output' => array(
							'index' => 'location',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'profile' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'PublicProfile',
						),
						'output' => array(
							'index' => 'profile',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'authorusercode' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'AuthorUserCode',
						),
						'output' => array(
							'index' => 'authorusercode',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'author' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Author',
						),
						'output' => array(
							'index' => 'author',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'showbyline' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'ShowByline',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'showbyline',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'isapproved' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Approval',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => 'A',
								),
							),
						),
						'output' => array(
							'index' => 'isapproved',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'bindertitle' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'BinderTitle',
						),
						'output' => array(
							'index' => 'bindertitle',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'binderid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'BinderID',
						),
						'output' => array(
							'index' => 'binderid',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'description' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Description',
						),
						'output' => array(
							'index' => 'description',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'hidden' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Hide',
/*							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => "1",
								),
							),*/
						),
						'output' => array(
							'index' => 'hidden',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'trash' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'Trash',
						),
						'output' => array(
							'index' => 'trash',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'emptybody' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'EmptyBody',
						),
						'output' => array(
							'index' => 'emptybody',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
						'constraint' => (object) array(
							'constraints' => array(
								array(
									'name' => 'objecttype',
									'value' => 'blog',
								),
								array(
									'name' => 'objecttype',
									'value' => 'folder',
								),
								array(
									'name' => 'objecttype',
									'value' => 'entry',
								),
							),
							'condition' => 'OR',
						),
					)
				),
				'istreetop' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'isTreeTop',
						),
						'output' => array(
							'index' => 'istreetop',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
						'constraint' => array(
							'name' => 'objecttype',
							'value' => 'folder',
						),
					)
				),
				'defaultfolio' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'DefaultFolio',
						),
						'output' => array(
							'index' => 'defaultfolio',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
						'constraint' => array(
							'name' => 'objecttype',
							'value' => 'folder',
						),
					)
				),
				'updatedate' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'EditDate',
						),
						'output' => array(
							'index' => 'updatedate',
						),
						'datatype' => Point::DATATYPE_DATE,
						'constraint' => array(
							'name' => 'updatedata',
							'value' => TRUE,
						),
					)
				),
				'updateusercode' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'EditUserID',
							'filter' => array(
								'method' => Point::FILTER_LOOKUP,
								'arguments' => array(
									'name' => 'Access_Users',
									'index' => 'ID',
									'value' => 'Code',
								),
							),
						),
						'output' => array(
							'index' => 'updateusercode',
						),
						'datatype' => Point::DATATYPE_STRING,
						'constraint' => array(
							'name' => 'updatedata',
							'value' => TRUE,
						),
					)
				),
				'updateuser' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'EditUserID',
							'filter' => array(
								'method' => Point::FILTER_LOOKUP,
								'arguments' => array(
									'name' => 'Access_Users',
									'index' => 'ID',
									'value' => 'Name',
								),
							),
						),
						'output' => array(
							'index' => 'updateuser',
						),
						'datatype' => Point::DATATYPE_STRING,
						'constraint' => array(
							'name' => 'updatedata',
							'value' => TRUE,
						),
					)
				),
				'sessionid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'sessionid',
						),
						'output' => array(
							'index' => 'sessionid',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'pageparentrecord' => Point::sectionlist()
				->properties(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_TABLEACTIVERECORD,
							'tableindex' => 'pageparenttable',
							'orderby' => array(
								array('Title','ASC'),
							),
							'callback' => array( // to Node::set_folder_query($responder,$nodename,$tableindex); see method property below
								'method' => array('Node','set_folder_query'),
								'tableindex'=>'pageparenttable', // datamodel index
							),
						),
						'output' => array(
							'index' => 'pageparenttable',
						),
						'constraint' => array(
							'name' => 'objecttype',
							'value' => 'page',
						),
					)
				)
				->variables(
					array(
						'id' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'pageparentrecord',
									'field' => 'ID',
								),
								'output' => array(
									'index' => 'id',
								),
								'datatype' => Point::DATATYPE_INTEGER,
								'notconstraint' => array(
									'name' => 'insertmode',
									'value' => TRUE,
								),
							)
						),
						'code' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'pageparentrecord',
									'field' => 'PageCode',
								),
								'output' => array(
									'index' => 'code',
								),
								'datatype' => Point::DATATYPE_STRING,
								'notconstraint' => array(
									'name' => 'insertmode',
									'value' => TRUE,
								),
							)
						),
						'title' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'pageparentrecord',
									'field' => 'Title',
								),
								'output' => array(
									'index' => 'title',
								),
								'datatype' => Point::DATATYPE_STRING,
								'notconstraint' => array(
									'name' => 'insertmode',
									'value' => TRUE,
								),
							)
						),
					)
				),
				'parentlist' => Point::sectionlist()
					->properties(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_TABLEACTIVERECORD,
								'tableindex' => 'parentstable',
								'orderby' => array(
									array('Title','ASC'),
								),
								'callback' => array( // to Node::set_folder_query($responder,$nodename,$tableindex); see method property below
									'method' => array('Node','set_folder_query'),
									'tableindex'=>'parentstable', // datamodel index
								),
							),
							'output' => array(
								'index' => 'parentlist',
							),
							'notconstraint' => array(
								'name' => 'objecttype',
								'value' => 'blog',
							),
						)		
					)
					->variables(
						array(
							'fileinstanceid' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'InstanceID',
									),
									'output' => array(
										'index' => 'fileinstanceid',
									),
									'datatype' => Point::DATATYPE_INTEGER,
								)
							),
							'id' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'ID',
									),
									'output' => array(
										'index' => 'id',
									),
									'datatype' => Point::DATATYPE_INTEGER,
								)
							),
							'code' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'FolderCode',
									),
									'output' => array(
										'index' => 'code',
									),
									'datatype' => Point::DATATYPE_STRING,
								)
							),
							'title' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'Title',
									),
									'output' => array(
										'index' => 'title',
									),
									'datatype' => Point::DATATYPE_STRING,
								)
							),
							'caption' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'Caption',
									),
									'output' => array(
										'index' => 'caption',
									),
									'datatype' => Point::DATATYPE_STRING,
								)
							),
							'date' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'ArticleDate',
									),
									'output' => array(
										'index' => 'date',
									),
									'datatype' => Point::DATATYPE_DATE,
								)
							),
							'description' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'Description',
									),
									'output' => array(
										'index' => 'description',
									),
									'datatype' => Point::DATATYPE_STRING,
								)
							),
							'istreetop' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'isTreeTop',
									),
									'output' => array(
										'index' => 'istreetop',
									),
									'datatype' => Point::DATATYPE_BOOLEAN,
								)
							),
							'defaultfolio' => Point::variable(
								array(
									'retrieve' => array(
										'method' => Point::DATASOURCE_ACTIVERECORD,
										'recordindex' => 'parentsrecord',
										'field' => 'DefaultFolio',
									),
									'output' => array(
										'index' => 'defaultfolio',
									),
									'datatype' => Point::DATATYPE_STRING,
								)
							),
						)
					),
				'blogrecord' => Point::section()
				->properties(
					array(
						'output' => array(
							'index' => 'blogrecord',
						),
						'constraint' => array(
							'name' => 'objecttype',
							'value' => 'entry',
						),
					)
				)
				->variables(
					array(
						'blogid' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'blogrecord',
									'field' => 'ID',
								),
								'output' => array(
									'index' => 'id',
								),
								'datatype' => Point::DATATYPE_INTEGER,
							)
						),
						'blogcode' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'blogrecord',
									'field' => 'BlogCode',
								),
								'output' => array(
									'index' => 'blogcode',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'title' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'blogrecord',
									'field' => 'Title',
								),
								'output' => array(
									'index' => 'title',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
					)
				),
			)
		),
	));
