<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()	
	->variables(array(
	# global data
	'errorsection' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'errorsection',
			),
			'output' => array(
				'index' => 'errorsection',
			),
			'datatype' => Point::DATATYPE_ARRAY,
		)
	),
	'messagesection' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'messagesection',
			),
			'output' => array(
				'index' => 'messagesection',
			),
			'datatype' => Point::DATATYPE_ARRAY,
		)
	),
	'articleid' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'articleid',
			),
			'output' => array(
				'index' => 'articleid',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'approval' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'Approval',
			),
			'output' => array(
				'index' => 'approval',
			),
			'access' => array(
				'token' => 'article_settings',
				'requires' => 'R',
			),
			'default' => 'D',
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'defaultfolio' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'DefaultFolio',
			),
			'output' => array(
				'index' => 'defaultfolio',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'folder',
			),
		)
	),
	'istreetop' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'isTreeTop',
			),
			'output' => array(
				'index' => 'istreetop',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'folder',
			),
		)
	),
	'title' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'Title',
			),
			'output' => array(
				'index' => 'title',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	# display mode data
	'display' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'display',
			),
			'notconstraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
		)
	)
	->variables(
		array(
			'imageurl' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Image',
					),
					'output' => array(
						'index' => 'imageurl',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'source' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Source',
					),
					'output' => array(
						'index' => 'source',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'foldercode' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'FolderCode',
					),
					'output' => array(
						'index' => 'code',
					),
					'datatype' => Point::DATATYPE_STRING,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
				)
			),
			'pagecode' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'PageCode',
					),
					'output' => array(
						'index' => 'code',
					),
					'datatype' => Point::DATATYPE_STRING,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'page',
					),
				)
			),
			'blogcode' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'BlogCode',
					),
					'output' => array(
						'index' => 'code',
					),
					'datatype' => Point::DATATYPE_STRING,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'blog',
					),
				)
			),
			'title' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Title',
					),
					'output' => array(
						'index' => 'title',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'caption' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Caption',
					),
					'output' => array(
						'index' => 'caption',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'date' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ArticleDate',
					),
					'output' => array(
						'index' => 'date',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'location' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Location',
					),
					'output' => array(
						'index' => 'location',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'description' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Description',
					),
					'output' => array(
						'index' => 'description',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'body' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Body',
						'filter' => array(
							'method' => Point::FILTER_MARKUP,
							'arguments' => array(
								'parser' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'articlesrecord',
									'field' => 'MarkupTypeID',
								),
							),
						),
					),
					'output' => array(
						'index' => 'body',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'emptybody' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'EmptyBody',
					),
					'output' => array(
						'index' => 'emptybody',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'constraint' => (object) array(
						'constraints' => array(
							array(
								'name' => 'objecttype',
								'value' => 'blog',
							),
							array(
								'name' => 'objecttype',
								'value' => 'folder',
							),
							array(
								'name' => 'objecttype',
								'value' => 'entry',
							),
						),
						'condition' => 'OR',
					),
				)
			),
			'istreetop' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'isTreeTop',
					),
					'output' => array(
						'index' => 'istreetop',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
				)
			),
			# display filelist data
			'containerslist' => Point::sectionlist()
				->properties(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_TABLEACTIVERECORD,
							'tableindex' => 'containerstable',
							'orderby' => array(
								array('Title','ASC'),
							),
							'callback' => array( // to Node::set_folder_query($responder,$nodename,$tableindex); see method property below
								'method' => array('Node','set_folder_query'),
								'tableindex'=>'containerstable', // datamodel index
							),
						),
						'output' => array(
							'index' => 'containerslist',
						),
					)		
				)
				->variables(
					array(
						'fileinstanceid' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'InstanceID',
								),
								'output' => array(
									'index' => 'fileinstanceid',
								),
								'datatype' => Point::DATATYPE_INTEGER,
							)
						),
						'id' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'ID',
								),
								'output' => array(
									'index' => 'id',
								),
								'datatype' => Point::DATATYPE_INTEGER,
							)
						),
						'code' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'FileCode',
								),
								'output' => array(
									'index' => 'code',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'title' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'Title',
								),
								'output' => array(
									'index' => 'title',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'caption' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'Caption',
								),
								'output' => array(
									'index' => 'caption',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'date' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'ArticleDate',
								),
								'output' => array(
									'index' => 'date',
								),
								'datatype' => Point::DATATYPE_DATE,
							)
						),
						'description' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'Description',
								),
								'output' => array(
									'index' => 'description',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'istreetop' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'isTreeTop',
								),
								'output' => array(
									'index' => 'istreetop',
								),
								'datatype' => Point::DATATYPE_BOOLEAN,
							)
						),
						'defaultfolio' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'DefaultFolio',
								),
								'output' => array(
									'index' => 'defaultfolio',
								),
								'datatype' => Point::DATATYPE_STRING,
								'constraint' => array(
									'name' => 'objecttype',
									'value' => 'folder',
								),
							)
						),
					)
				),
			'childlist' => Point::sectionlist()
				->properties(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_TABLEACTIVERECORD,
							'tableindex' => 'childtable',
							'orderby' => array(
								array('Title','ASC'),
							),
							'callback' => array( // to Node::set_folder_query($responder,$nodename,$tableindex); see method property below
								'method' => array('Node','set_folder_query'),
								'tableindex'=>'childtable', // datamodel index
							),
						),
						'output' => array(
							'index' => 'pagechildren',
						),
						'constraint' => array(
							'name' => 'objecttype',
							'value' => 'page',
						),
					)		
				)
				->variables(
					array(
						'id' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'childrecord',
									'field' => 'ID',
								),
								'output' => array(
									'index' => 'id',
								),
								'datatype' => Point::DATATYPE_INTEGER,
							)
						),
						'code' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'childrecord',
									'field' => 'PageCode',
								),
								'output' => array(
									'index' => 'code',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'title' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'childrecord',
									'field' => 'Title',
								),
								'output' => array(
									'index' => 'title',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'caption' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'childrecord',
									'field' => 'Caption',
								),
								'output' => array(
									'index' => 'caption',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'date' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'childrecord',
									'field' => 'ArticleDate',
								),
								'output' => array(
									'index' => 'date',
								),
								'datatype' => Point::DATATYPE_DATE,
							)
						),
						'description' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'childrecord',
									'field' => 'Description',
								),
								'output' => array(
									'index' => 'description',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
					)
				),
			# display blogrecord data
			'blogrecord' => Point::section()
			->properties(
				array(
					'output' => array(
						'index' => 'blogrecord',
					),
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'entry',
					),
				)
			)
			->variables(
				array(
					'blogid' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'blogrecord',
								'field' => 'ID',
							),
							'output' => array(
								'index' => 'id',
							),
							'datatype' => Point::DATATYPE_INTEGER,
						)
					),
					'blogcode' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'blogrecord',
								'field' => 'BlogCode',
							),
							'output' => array(
								'index' => 'blogcode',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
					'title' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'blogrecord',
								'field' => 'Title',
							),
							'output' => array(
								'index' => 'title',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
				)
			),
			'pageparentid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'PageParentID',
					),
					'output' => array(
						'index' => 'pageparentid',
					),
					'datatype' => Point::DATATYPE_INTEGER,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'page',
					),
				)
			),
		)
	),
	# edit mode data
	'edit' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'edit',
			),
			'input' => array(
				'index' => 'edit',
			),
			'constraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
		)
	)
	->variables(
		array(
			'imageurl' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Image',
					),
					'output' => array(
						'index' => 'imageurl',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'imageurl',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Image',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'pageparentid' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'PageParentID',
					),
					'output' => array(
						'index' => 'pageparentid',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'pageparentid',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'extensionrecord',
						'field' => 'PageParentID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'page',
					),
				)
			),
			'pageparentrecord' => Point::section()
			->properties(
				array(
					'output' => array(
						'index' => 'pageparentrecord',
					),
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'page',
					),
				)
			)
			->variables(
				array(
					'id' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'pageparentrecord',
								'field' => 'ID',
							),
							'output' => array(
								'index' => 'id',
							),
							'datatype' => Point::DATATYPE_INTEGER,
							'notconstraint' => array(
								'name' => 'insertmode',
								'value' => TRUE,
							),
						)
					),
					'code' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'pageparentrecord',
								'field' => 'PageCode',
							),
							'output' => array(
								'index' => 'code',
							),
							'datatype' => Point::DATATYPE_STRING,
							'notconstraint' => array(
								'name' => 'insertmode',
								'value' => TRUE,
							),
						)
					),
					'title' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'pageparentrecord',
								'field' => 'Title',
							),
							'output' => array(
								'index' => 'title',
							),
							'datatype' => Point::DATATYPE_STRING,
							'notconstraint' => array(
								'name' => 'insertmode',
								'value' => TRUE,
							),
						)
					),
					'insertid' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_BLOCKVALUE,
								'path' => array('edit'),
								'name' => 'pageparentid',
							),
							'output' => array(
								'index' => 'id',
							),
							'datatype' => Point::DATATYPE_INTEGER,
							'constraint' => array(
								'name' => 'insertmode',
								'value' => TRUE,
							),
						)
					),
					'insertcode' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_BLOCKVALUE,
								'path' => array('edit'),
								'name' => 'pageparentid',
								'filter' => array(
									'method' => Point::FILTER_LOOKUP,
									'arguments' => array(
										'name' => 'Articles_Extensions',
										'index' => 'ArticleID',
										'value' => 'PageCode',
									),
								),
							),
							'output' => array(
								'index' => 'code',
							),
							'datatype' => Point::DATATYPE_STRING,
							'constraint' => array(
								'name' => 'insertmode',
								'value' => TRUE,
							),
						)
					),
					'inserttitle' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_BLOCKVALUE,
								'path' => array('edit'),
								'name' => 'pageparentid',
								'filter' => array(
									'method' => Point::FILTER_LOOKUP,
									'arguments' => array(
										'name' => 'Articles',
										'index' => 'ID',
										'value' => 'Title',
									),
								),
							),
							'output' => array(
								'index' => 'title',
							),
							'datatype' => Point::DATATYPE_STRING,
							'constraint' => array(
								'name' => 'insertmode',
								'value' => TRUE,
							),
						)
					),
				)
			),
			'source' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Source',
					),
					'output' => array(
						'index' => 'source',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'source',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Source',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'showbyline' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ShowByline',
					),
					'output' => array(
						'index' => 'showbyline',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'showbyline',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ShowByline',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
				)
			),
			'binderoptions' => Point::optionsection()
			->properties(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'BinderID',
					),
					'output' => array(
						'index' => 'binderoptions',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'binderoption',
					),
					'rules' => array(
						array('not_empty'),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'BinderID',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			)
			->driver(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'binderoptions',
					),
					'datapoolarray' => array(
						'name' => 'binderoption',
						'index' => 'value',
						'value' => 'caption',
					),
					'selectionvariable' => 'binder',
				)
			)
			->variables(
				array(
					'value' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'binderoption',
								'index' => 'value',
								
							),
							'output' => array(
								'index' => 'value',
							),
							'datatype' => Point::DATATYPE_INTEGER,
						)
					),
					'caption' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'binderoption',
								'index' => 'caption',
							),
							'output' => array(
								'index' => 'caption',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
					'selected' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_MATCH,
								'match' => array(
									'method' => Point::DATASOURCE_VARIABLE,
									'name' => 'binder',
									'blockindex' => 'value',
								),
							),
							'output' => array(
								'index' => 'selected',
								'filter' => array(
									'method' => Point::FILTER_SELECTED,
								),
							),
							'datatype' => Point::DATATYPE_BOOLEAN,
						)
					),
				)
			),
			'title' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Title',
					),
					'output' => array(
						'index' => 'title',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'title',
					),
					'rules' => array(
						array('not_empty'),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Title',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'codeblog' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'BlogCode',
					),
					'output' => array(
						'index' => 'code',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'code',
					),
					'rules' => array(
						array('not_empty'),
						array('regex', array(':value', '/^[A-Z]\w++$/D')),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'extensionrecord',
						'field' => 'BlogCode',
					),
					'datatype' => Point::DATATYPE_STRING,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'blog',
					),
				)
			),
			// over-ride for page, relaxed rule
			'codepage' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'PageCode',
					),
					'output' => array(
						'index' => 'code',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'code',
					),
					'rules' => array(
						array('regex', array(':value', '/^[A-Za-z]\w++$/D')),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'extensionrecord',
						'field' => 'PageCode',
					),
					'datatype' => Point::DATATYPE_STRING,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'page',
					),
				)
			),
			// over-ride for folder, relaxed rule
			'codefolder' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'FolderCode',
					),
					'output' => array(
						'index' => 'code',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'code',
					),
					'rules' => array(
						array('regex', array(':value', '/^[A-Za-z]\w++$/D')),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'extensionrecord',
						'field' => 'FolderCode',
					),
					'datatype' => Point::DATATYPE_STRING,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
				)
			),
			'caption' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Caption',
					),
					'output' => array(
						'index' => 'caption',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'caption',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Caption',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'date' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ArticleDate',
					),
					'output' => array(
						'index' => 'date',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'date',
					),
					'rules' => array(
						array('not_empty'),
						array('date'),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ArticleDate',
					),
					'default' => Date('r'),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
			'location' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Location',
					),
					'output' => array(
						'index' => 'location',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'location',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Location',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'description' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Description',
					),
					'output' => array(
						'index' => 'description',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'description',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Description',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'istreetop' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'isTreeTop',
					),
					'output' => array(
						'index' => 'istreetop',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'istreetop',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'extensionrecord',
						'field' => 'isTreeTop',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
				)
			),
			'body' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Body',
					),
					'output' => array(
						'index' => 'body',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'body',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'Body',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'defaultfolios' => Point::optionsection()
			->properties(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'DefaultFolio',
					),
					'output' => array(
						'index' => 'defaultfolios',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'defaultfolio',
					),
					'rules' => array(
						array('not_empty'),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'extensionrecord',
						'field' => 'DefaultFolio',
					),
					'datatype' => Point::DATATYPE_STRING,
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
				)
			)
			->driver(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VALUE,
						'value' => array(
							'list' => 'List', // column 3
							'planks' => 'Planks', // 1
							'panes' => 'Panes', // 1
							'table' => 'Table', // 1
							'smalltiles' => 'Small Tiles', // inline
							'mediumtiles' => 'Medium Tiles', // 4
							'largetiles' => 'Large Tiles', // 3
							'gallery' => 'Gallery', // 2
							'columns' => 'Columns', // column 2
						),
					),
					'datapoolarray' => array(
						'name' => 'defaultfolio',
						'index' => 'value',
						'value' => 'caption',
					),
					'selectionvariable' => 'folio',
				)
			)
			->variables(
				array(
					'value' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'defaultfolio',
								'index' => 'value',
								
							),
							'output' => array(
								'index' => 'value',
							),
							'datatype' => Point::DATATYPE_INTEGER,
						)
					),
					'caption' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ARRAY,
								'name' => 'defaultfolio',
								'index' => 'caption',
							),
							'output' => array(
								'index' => 'caption',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
					'selected' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_MATCH,
								'match' => array(
									'method' => Point::DATASOURCE_VARIABLE,
									'name' => 'folio',
									'blockindex' => 'value',
								),
							),
							'output' => array(
								'index' => 'selected',
								'filter' => array(
									'method' => Point::FILTER_SELECTED,
								),
							),
							'datatype' => Point::DATATYPE_BOOLEAN,
						)
					),
				)
			),
			# edit containerslist data
			'containerslist' => Point::sectionlist()
				->properties(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_TABLEACTIVERECORD,
							'tableindex' => 'containerstable',
							'orderby' => array(
								array('Title','ASC'),
							),
						),
						'output' => array(
							'index' => 'containerslist',
						),
					)		
				)
				->variables(
					array(
						'fileinstanceid' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'InstanceID',
								),
								'output' => array(
									'index' => 'fileinstanceid',
								),
								'datatype' => Point::DATATYPE_INTEGER,
							)
						),
						'id' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'ID',
								),
								'output' => array(
									'index' => 'id',
								),
								'datatype' => Point::DATATYPE_INTEGER,
							)
						),
						'code' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'FileCode',
								),
								'output' => array(
									'index' => 'code',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'title' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'Title',
								),
								'output' => array(
									'index' => 'title',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'caption' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'Caption',
								),
								'output' => array(
									'index' => 'caption',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'date' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'ArticleDate',
								),
								'output' => array(
									'index' => 'date',
								),
								'datatype' => Point::DATATYPE_DATE,
							)
						),
						'description' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'Description',
								),
								'output' => array(
									'index' => 'description',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
						'istreetop' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'isTreeTop',
								),
								'output' => array(
									'index' => 'istreetop',
								),
								'datatype' => Point::DATATYPE_BOOLEAN,
							)
						),
						'defaultfolio' => Point::variable(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_ACTIVERECORD,
									'recordindex' => 'containersrecord',
									'field' => 'DefaultFolio',
								),
								'output' => array(
									'index' => 'defaultfolio',
								),
								'datatype' => Point::DATATYPE_STRING,
							)
						),
					)
				),
			# edit blogrecord data
			'blogrecord' => Point::section()
			->properties(
				array(
					'output' => array(
						'index' => 'blogrecord',
					),
					'constraint' => array(
						'name' => 'objecttype',
						'value' => 'entry',
					),
					'notconstraint' => array(
						'name' => 'insertmode',
						'value' => TRUE,
					),
				)
			)
			->variables(
				array(
					'blogid' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'blogrecord',
								'field' => 'ID',
							),
							'output' => array(
								'index' => 'id',
							),
							'datatype' => Point::DATATYPE_INTEGER,
						)
					),
					'blogcode' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'blogrecord',
								'field' => 'BlogCode',
							),
							'output' => array(
								'index' => 'blogcode',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
					'title' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_ACTIVERECORD,
								'recordindex' => 'blogrecord',
								'field' => 'Title',
							),
							'output' => array(
								'index' => 'title',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
				)
			),
			# edit preview data
			'preview' => Point::section()
			->properties(
				array(
					'output' => array(
						'index' => 'preview',
					),
					'constraint' => array(
						'name' => 'preview',
						'value' => TRUE,
					),
				)
			)
			->variables(
				array(
					'binderidpreview' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_BLOCKVALUE,
								'path' => array('edit'),
								'name' => 'binderoptions',
							),
							'output' => array(
								'index' => 'binderidpreview',
							),
							'datatype' => Point::DATATYPE_INTEGER,
						)
					),
					'bindertitlepreview' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_BLOCKVALUE,
								'path' => array('edit'),
								'name' => 'binderoptions',
								'filter' => array(
									'method' => Point::FILTER_LOOKUP,
									'arguments' => array(
										'name' => 'Binders',
										'index' => 'ID',
										'value' => 'Title',
									),
								),
							),
							'output' => array(
								'index' => 'bindertitlepreview',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
					'bodypreview' => Point::variable(
						array(
							'retrieve' => array(
								'method' => Point::DATASOURCE_BLOCKVALUE,
								'path' => array('edit'),
								'name' => 'body',
								'filter' => array(
									'method' => Point::FILTER_MARKUP,
									'arguments' => array(
										'parser' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'articlesrecord',
											'field' => 'MarkupTypeID',
										),
									),
								),
							),
							'output' => array(
								'index' => 'bodypreview',
							),
							'datatype' => Point::DATATYPE_STRING,
						)
					),
					# display containerslist data
					'containerslist' => Point::sectionlist()
						->properties(
							array(
								'retrieve' => array(
									'method' => Point::DATASOURCE_TABLEACTIVERECORD,
									'tableindex' => 'containerstable',
									'orderby' => array(
										array('Title','ASC'),
									),
								),
								'output' => array(
									'index' => 'containerslist',
								),
							)		
						)
						->variables(
							array(
								'fileinstanceid' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'InstanceID',
										),
										'output' => array(
											'index' => 'fileinstanceid',
										),
										'datatype' => Point::DATATYPE_INTEGER,
									)
								),
								'id' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'ID',
										),
										'output' => array(
											'index' => 'id',
										),
										'datatype' => Point::DATATYPE_INTEGER,
									)
								),
								'code' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'FileCode',
										),
										'output' => array(
											'index' => 'code',
										),
										'datatype' => Point::DATATYPE_STRING,
									)
								),
								'title' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'Title',
										),
										'output' => array(
											'index' => 'title',
										),
										'datatype' => Point::DATATYPE_STRING,
									)
								),
								'caption' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'Caption',
										),
										'output' => array(
											'index' => 'caption',
										),
										'datatype' => Point::DATATYPE_STRING,
									)
								),
								'date' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'ArticleDate',
										),
										'output' => array(
											'index' => 'date',
										),
										'datatype' => Point::DATATYPE_DATE,
									)
								),
								'description' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'Description',
										),
										'output' => array(
											'index' => 'description',
										),
										'datatype' => Point::DATATYPE_STRING,
									)
								),
								'istreetop' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'isTreeTop',
										),
										'output' => array(
											'index' => 'istreetop',
										),
										'datatype' => Point::DATATYPE_BOOLEAN,
									)
								),
								'defaultfolio' => Point::variable(
									array(
										'retrieve' => array(
											'method' => Point::DATASOURCE_ACTIVERECORD,
											'recordindex' => 'containersrecord',
											'field' => 'DefaultFolio',
										),
										'output' => array(
											'index' => 'defaultfolio',
										),
										'datatype' => Point::DATATYPE_STRING,
										'constraint' => array(
											'name' => 'objecttype',
											'value' => 'folder',
										),
									)
								),
							)
						),
				)
			),
		)
	),
	# author section data
	'authorsection' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'authorsection',
			),
			'input' => array(
				'index' => 'authorsection',
				'constraint' => array(
					'name' => 'editsection',
					'value' => 'author',
				),
			),
			'constraint' => array(
				'name' => 'adminmode',
				'value' => TRUE,
			),
		)
	)
	->variables(
		array(
			'authorerrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'authorerrors',
					),
					'output' => array(
						'index' => 'authorerrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'authormessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'authormessages',
					),
					'output' => array(
						'index' => 'authormessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'authornotes' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'AuthorNotes',
					),
					'output' => array(
						'index' => 'authornotes',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'authornotes',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'AuthorNotes',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'authornotesclosed' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'AuthorNotesClosed',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => '1',
							),
						),
					),
					'output' => array(
						'index' => 'authornotesclosed',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'authornotesclosed',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'AuthorNotesClosed',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
				)
			),
			'showbyline' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ShowByline',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => '1',
							),
						),
					),
					'output' => array(
						'index' => 'showbyline',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'showbyline',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ShowByline',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
				)
			),
		)
	),
	# approval section data
	'approvalsection' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'approvalsection',
			),
			'input' => array(
				'index' => 'approvalsection',
				'constraint' => array(
					'name' => 'editsection',
					'value' => 'approval',
				),
			),
			'constraint' => array(
				'name' => 'adminmode',
				'value' => TRUE,
			),
		)
	)
	->variables(
		array(
			'approvalerrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'approvalerrors',
					),
					'output' => array(
						'index' => 'approvalerrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'approvalmessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'approvalmessages',
					),
					'output' => array(
						'index' => 'approvalmessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'approvalnotes' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ApproveNotes',
					),
					'output' => array(
						'index' => 'approvalnotes',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'approvalnotes',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'ApproveNotes',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
		)
	),
	// s/b in authorsection data?
	'newauthorcode' => Point::variable(
		array(
			'output' => array(
				'index' => 'newauthorcode',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'newauthorcode',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'changeauthor',
				'value' => TRUE,
			),
		)
	),
	# followup section data
	'followupsection' => Point::section()
	->properties(
		array(
			'output' => array(
				'index' => 'followupsection',
			),
			'input' => array(
				'index' => 'followupsection',
				'constraint' => array(
					'name' => 'editsection',
					'value' => 'followup',
				),
			),
			'constraint' => array(
				'name' => 'adminmode',
				'value' => TRUE,
			),
		)
	)
	->variables(
		array(
			'followuperrors' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'followuperrors',
					),
					'output' => array(
						'index' => 'followuperrors',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'followupmessages' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'followupmessages',
					),
					'output' => array(
						'index' => 'followupmessages',
					),
					'datatype' => Point::DATATYPE_ARRAY,
				)
			),
			'followupnotes' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'FollowupNotes',
					),
					'output' => array(
						'index' => 'followupnotes',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'followupnotes',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'FollowupNotes',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
			'followupclosed' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'FollowupNotesClosed',
						'filter' => array(
							'method' => Point::FILTER_COMPARE,
							'arguments' => array(
								'compare' => '1',
							),
						),
					),
					'output' => array(
						'index' => 'followupclosed',
						'filter' => array(
							'method' => Point::FILTER_CHECKED,
						),
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'followupclosed',
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'FollowupNotesClosed',
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
				)
			),
			'followupdate' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ACTIVERECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'FollowupDate',
					),
					'output' => array(
						'index' => 'followupdate',
					),
					'input' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'post',
						'index' => 'followupdate',
					),
					'rules' => array(
						array('date'),
					),
					'store' => array(
						'method' => Point::DATATARGET_RECORD,
						'recordindex' => 'articlesrecord',
						'field' => 'FollowupDate',
					),
					'datatype' => Point::DATATYPE_DATE,
				)
			),
		)
	),
	# more global data
	'profile' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'PublicProfile',
			),
			'output' => array(
				'index' => 'profile',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)
	),
	'code' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'Code',
			),
			'output' => array(
				'index' => 'code',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'authorusercode' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'AuthorUserCode',
			),
			'output' => array(
				'index' => 'authorusercode',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'author' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'Author',
			),
			'output' => array(
				'index' => 'author',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'showbyline' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'ShowByline',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => '1',
					),
				),
			),
			'output' => array(
				'index' => 'showbyline',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)
	),
	'bindertitle' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'BinderTitle',
			),
			'output' => array(
				'index' => 'bindertitle',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'binderid' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'BinderID',
			),
			'output' => array(
				'index' => 'binderid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	),
	'id' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'ID',
			),
			'output' => array(
				'index' => 'id',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'id',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'ID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	),
	'newpageparentid' => Point::variable(
		array(
			'output' => array(
				'index' => 'pageparentid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'newpageparentid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'changepageparent',
				'value' => TRUE,
			),
		)
	),
	'pageparentid' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'PageParentID',
			),
			'output' => array(
				'index' => 'pageparentid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'page',
			),
		)
	),
	'createdate' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'CreateDate',
			),
			'output' => array(
				'index' => 'createdate',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'createdate',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'CreateDate',
			),
			'datatype' => Point::DATATYPE_DATE,
		)
	),
	'createuserid' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'CreateUserID',
			),
			'output' => array(
				'index' => 'createuserid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'createuserid',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'CreateUserID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	),
	'createname' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'CreateUserID',
				'filter' => array(
					'method' => Point::FILTER_LOOKUP,
					'arguments' => array(
						'name' => 'Access_Users',
						'index' => 'ID',
						'value' => 'Name',
					),
				),
			),
			'output' => array(
				'index' => 'createname',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'createcode' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'CreateUserID',
				'filter' => array(
					'method' => Point::FILTER_LOOKUP,
					'arguments' => array(
						'name' => 'Access_Users',
						'index' => 'ID',
						'value' => 'Code',
					),
				),
			),
			'output' => array(
				'index' => 'createcode',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'editdate' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'EditDate',
			),
			'output' => array(
				'index' => 'editdate',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'editdate',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'EditDate',
			),
			'datatype' => Point::DATATYPE_DATE,
		)
	),
	'edituserid' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'EditUserID',
			),
			'output' => array(
				'index' => 'edituserid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'edituserid',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'EditUserID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	),
	'editname' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'EditUserID',
				'filter' => array(
					'method' => Point::FILTER_LOOKUP,
					'arguments' => array(
						'name' => 'Access_Users',
						'index' => 'ID',
						'value' => 'Name',
					),
				),
			),
			'output' => array(
				'index' => 'editname',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'editcode' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'EditUserID',
				'filter' => array(
					'method' => Point::FILTER_LOOKUP,
					'arguments' => array(
						'name' => 'Access_Users',
						'index' => 'ID',
						'value' => 'Code',
					),
				),
			),
			'output' => array(
				'index' => 'editcode',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'recordversion' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'RecordVersion',
			),
			'output' => array(
				'index' => 'recordversion',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'recordversion',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'articlesrecord',
				'field' => 'RecordVersion',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	),
));
