<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()	
->variables(array(
	# =================================
	# general
	# =================================
	'layouttype' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_VARIABLE,
			'name' => 'layouttype',
		),
		'output' => array(
			'index' => 'layouttype',
		),
		'datatype' => Point::DATATYPE_STRING,
		'default' => 'planks',
	)),
	'recordset_delimiter' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_CALCULATE_RECORDSET_DELIMITER,
			'layouttypeindex' => 'layouttype',
		),
		'output' => array(
			'index' => 'recordset_delimiter',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
		'default' => FALSE,
	)),
	# =================================
	# record listing
	# =================================
	'messagesection' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_VARIABLE,
			'name' => 'messagesection',
		),
		'output' => array(
			'index' => 'messagesection',
		),
		'datatype' => Point::DATATYPE_ARRAY,
	)),
	'records' => Point::sectionlist()
	->properties(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_TABLEACTIVERECORD,
			'tableindex' => 'mastertable',
			'indexvariable' => '__rownumber__',
			'newrowvariable' => '__newrow__',
			'layouttypeindex' => 'layouttype',
		),
		'output' => array(
			'index' => 'records',
		),
	))
	->variables(array(
		'isnewrow' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => '__newrow__',
			),
			'output' => array(
				'index' => 'isnewrow',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'default' => FALSE,
		)),
		'id' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ID',
			),
			'output' => array(
				'index' => 'id',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'treetopid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ID',
			),
			'output' => array(
				'index' => 'recordinstanceid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'treetopadmin',
				'value' =>TRUE,
			),
		)),
		'instanceid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'InstanceID',
			),
			'output' => array(
				'index' => 'instanceid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'notconstraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'node',
						'value' => 'bookmarks',
					),
					array(
						'name' => 'homepage',
						'value' => TRUE,
					),
				),
				'condition' => 'OR',
			),
		)),
		'bookinstanceid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD_JSON,
				'recordindex' => 'masterrecord',
				'field' => 'Parameters',
				'json' => 'instanceid',
			),
			'output' => array(
				'index' => 'instanceid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'node',
				'value' => 'bookmarks',
			),
		)),
		'path' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD_JSON,
				'recordindex' => 'masterrecord',
				'field' => 'Parameters',
				'json' => 'path',
			),
			'output' => array(
				'index' => 'path',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'node',
				'value' => 'bookmarks',
			),
		)),
		'is_favourite' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ISFAVOURITE,
				'articleidref' => 'id',
			),
			'output' => array(
				'index' => 'is_favourite',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'approval' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Approval',
			),
			'output' => array(
				'index' => 'approval',
			),
			'datatype' => Point::DATATYPE_STRING,
			'access' => array(
				'token' => 'article_unpublished',
				'requires' => 'R',
			),
		)),
		'objecttype' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ObjectType',
			),
			'output' => array(
				'index' => 'objecttype',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'imageid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Image',
			),
			'output' => array(
				'index' => 'imageid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		// imageurl; imagetitle, and imagecaption are generated as side-effects
		'imagedata' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_LOOKUP_LAYOUT_IMAGEDATA,
				'layouttypeindex' => 'layouttype', // global, get layouttype
				'recordtypeindex' => 'objecttype', // above, get objecttype
				'imageidindex' => 'imageid', // get imageid
				'recordidindex' => 'id', // for 'picture' record type, or target link
			),
			'output' => array(
				'index' => 'imageurl',
			),
			'datatype' => Point::DATATYPE_STRING,
		)), 
		'source' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Source',
			),
			'output' => array(
				'index' => 'source',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'url' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'URL',
			),
			'output' => array(
				'index' => 'url',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'filename' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FileName',
			),
			'output' => array(
				'index' => 'filename',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'directory' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Directory',
			),
			'output' => array(
				'index' => 'directory',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'parentid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ParentID',
			),
			'output' => array(
				'index' => 'parentid',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'title' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Title',
			),
			'output' => array(
				'index' => 'title',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'caption' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Caption',
			),
			'output' => array(
				'index' => 'caption',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'date' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ArticleDate',
			),
			'output' => array(
				'index' => 'date',
			),
			'datatype' => Point::DATATYPE_DATE,
		)),
		'location' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Location',
			),
			'output' => array(
				'index' => 'location',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'profile' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'PublicProfile',
			),
			'output' => array(
				'index' => 'profile',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'authorusercode' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'AuthorUserCode',
			),
			'output' => array(
				'index' => 'authorusercode',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'author' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Author',
			),
			'output' => array(
				'index' => 'author',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'showbyline' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ShowByline',
			),
			'output' => array(
				'index' => 'showbyline',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'isapproved' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Approval',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'A',
					),
				),
			),
			'output' => array(
				'index' => 'isapproved',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'bindertitle' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'BinderTitle',
			),
			'output' => array(
				'index' => 'bindertitle',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'binderid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'BinderID',
			),
			'output' => array(
				'index' => 'binderid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'description' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Description',
			),
			'output' => array(
				'index' => 'description',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'privatized' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Hide',
			),
			'output' => array(
				'index' => 'privatized',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'locked' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Locked',
			),
			'output' => array(
				'index' => 'locked',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'frozen' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Frozen',
			),
			'output' => array(
				'index' => 'frozen',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'trash' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Trash',
			),
			'output' => array(
				'index' => 'trash',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'emptybody' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'EmptyBody',
			),
			'output' => array(
				'index' => 'emptybody',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'body' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Body',
				'filter' => array(
					'method' => Point::FILTER_MARKUP,
					'arguments' => array(
						'parser' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'MarkupTypeID',
						),
					),
				),
			),
			'output' => array(
				'index' => 'body',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'showbody',
				'value' => TRUE,
			),
		)),
		'is_comments' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ISCOMMENTS,
				'articleidref' => 'id',
			),
			'output' => array(
				'index' => 'is_comments',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'is_attachments' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ISATTACHMENTS,
				'articleidref' => 'id',
			),
			'output' => array(
				'index' => 'is_attachments',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'is_narrative' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ISNARRATIVE,
				'valueref' => 'emptybody',
			),
			'output' => array(
				'index' => 'is_narrative',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'is_articleancillarydata' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ISANCILLARYDATA,
				'blockrefs' => array('is_comments','is_attachments'),
			),
			'output' => array(
				'index' => 'is_articleancillarydata',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'is_containerancillartydata' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ISANCILLARYDATA,
				'blockrefs' => array('is_comments','is_attachments','is_narrative'),
			),
			'output' => array(
				'index' => 'is_containerancillarydata',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'istreetop' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'isTreeTop',
			),
			'output' => array(
				'index' => 'istreetop',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'defaultfolio' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DefaultFolio',
			),
			'output' => array(
				'index' => 'defaultfolio',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'updatedate' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'EditDate',
			),
			'output' => array(
				'index' => 'updatedate',
			),
			'datatype' => Point::DATATYPE_DATETIME,
			'constraint' => array(
				'name' => 'updatedata',
				'value' => TRUE,
			),
		)),
		'updateusercode' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'EditUserID',
				'filter' => array(
					'method' => Point::FILTER_LOOKUP,
					'arguments' => array(
						'name' => 'Access_Users',
						'index' => 'ID',
						'value' => 'Code',
					),
				),
			),
			'output' => array(
				'index' => 'updateusercode',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'updatedata',
				'value' => TRUE,
			),
		)),
		'updateuser' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'EditUserID',
				'filter' => array(
					'method' => Point::FILTER_LOOKUP,
					'arguments' => array(
						'name' => 'Access_Users',
						'index' => 'ID',
						'value' => 'Name',
					),
				),
			),
			'output' => array(
				'index' => 'updateuser',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'updatedata',
				'value' => TRUE,
			),
		)),
		'foldercode' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FolderCode',
			),
			'output' => array(
				'index' => 'foldercode',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'blogcode' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'BlogCode',
			),
			'output' => array(
				'index' => 'blogcode',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'pagecode' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'PageCode',
			),
			'output' => array(
				'index' => 'pagecode',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'dividerabove' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DividerAbove',
			),
			'output' => array(
				'index' => 'is_lineabove',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'dividerbelow' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DividerBelow',
			),
			'output' => array(
				'index' => 'is_linebelow',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'treetopdividerabove' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DividerAbove',
			),
			'output' => array(
				'index' => 'dividerabove',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => array(
				'name' => 'treetopadmin',
				'value' =>TRUE,
			),
		)),
		'treetopdividerbelow' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DividerBelow',
			),
			'output' => array(
				'index' => 'dividerbelow',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => array(
				'name' => 'treetopadmin',
				'value' =>TRUE,
			),
		)),
		'customorder' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Order',
			),
			'output' => array(
				'index' => 'customorder',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'treetoporder' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Order',
			),
			'output' => array(
				'index' => 'order',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'treetopadmin',
				'value' =>TRUE,
			),
		)),
		'ordertext' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'OrderText',
			),
			'output' => array(
				'index' => 'ordertext',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'ordertextraw' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'OrderTextRaw',
			),
			'output' => array(
				'index' => 'promptraw',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'treetopadmin',
				'value' =>TRUE,
			),
		)),
		'instancedescription' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'InstanceDescription',
			),
			'output' => array(
				'index' => 'instancedescription',
			),
			'datatype' => Point::DATATYPE_STRING,
			'notconstraint' => array(
				'name' => 'treetopadmin',
				'value' =>TRUE,
			),
			'notconstraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'treetopadmin',
						'value' =>TRUE,
					),
					array(
						'name' => 'treetop',
						'value' =>TRUE,
					),
				),
				'condition' => 'OR',
			),
		)),
		'orderguide' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'OrderGuide',
			),
			'output' => array(
				'index' => 'instancedescription',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'treetopadmin',
						'value' =>TRUE,
					),
					array(
						'name' => 'treetop',
						'value' =>TRUE,
					),
				),
				'condition' => 'OR',
			),
		)),
		'partialrecordindex' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_LOOKUP_LAYOUT_PARTIAL,
				'recordtypeindex' => 'objecttype', // above
				'layouttypeindex' => 'layouttype', // global
				'arrayname' => 'nodepartials',
			),
			'output' => array(
				'index' => 'partial_record',
			),
			'datatype' => Point::DATATYPE_STRING,
			'notconstraint' => array(
				'name' => 'treetopadmin',
				'value' =>TRUE,
			),
		)), 
		'partialadminrecordindex' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_LOOKUP_PARTIAL,
				'recordtypeindex' => 'objecttype', // above
				'arrayname' => 'adminnodepartials',
			),
			'output' => array(
				'index' => 'partial_admin_record',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'treetopadmin',
				'value' =>TRUE,
			),
		)),
		# ---------------[ blogrecord data ]------------- #
		'blogrecord' => Point::section()
		->properties(array(
			'output' => array(
				'index' => 'blogrecord',
			),
			'constraint' => array(
				'name' => 'showblogparent',
				'value' => TRUE,
			),
		))
		->variables(array(
			'blogid' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'blogrecord',
					'field' => 'ID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'blogcode' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'blogrecord',
					'field' => 'BlogCode',
				),
				'output' => array(
					'index' => 'blogcode',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'blogrecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
		)),
		# ---------------[ page data ]------------- #
		'pageparentid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'PageParentID',
			),
			'output' => array(
				'index' => 'pageparentid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'pageparentrecord' => Point::section()
		->properties(array(
			'output' => array(
				'index' => 'pageparentrecord',
			),
			'constraint' => array(
				'name' => 'showpageparent',
				'value' => TRUE,
			),
		))
		->variables(array(
			'id' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pageparentrecord',
					'field' => 'ID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'code' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pageparentrecord',
					'field' => 'PageCode',
				),
				'output' => array(
					'index' => 'code',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pageparentrecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
		)),
		# ---------------[ comment article data ]------------- #
		'commentarticleid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'CommentArticleID',
			),
			'output' => array(
				'index' => 'commentarticleid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'commentarticlerecord' => Point::section()
		->properties(array(
			'output' => array(
				'index' => 'commentarticlerecord',
			),
			'constraint' => array(
				'name' => 'commentarticles',
				'value' => 'required',
			),
		))
		->variables(array(
			'id' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'ID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'commoncode' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'CommonCode',
				),
				'output' => array(
					'index' => 'commoncode',
				),
				'datatype' => Point::DATATYPE_STRING,
				'notconstraint' => array(
					'name' => 'insertmode',
					'value' => TRUE,
				),
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
				'notconstraint' => array(
					'name' => 'insertmode',
					'value' => TRUE,
				),
			)),
			'objecttype' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'ObjectType',
				),
				'output' => array(
					'index' => 'objecttype',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'partialrecordindex' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_LOOKUP_PARTIAL,
					'recordtypeindex' => 'objecttype', // above
					'arrayname' => 'masterpartials',
				),
				'output' => array(
					'index' => 'partial_record',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
		)),
		'containerslist' => Point::sectionlist()
		->properties(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_TABLEACTIVERECORD,
				'tableindex' => 'containerstable',
				'orderby' => array(
					array('Title','ASC'),
				),
				'callback' => array(
					'method' => array('Node','set_table_mixed_constraints'),
					'tableindex'=>'containerstable',
				),
			),
			'output' => array(
				'index' => 'containerslist',
			),
			'notconstraint' => array(
				'name' => 'containerslist',
				'value' => 'notrequired',
			),
		))
		->variables(array(
			'containerinstanceid' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'InstanceID',
				),
				'output' => array(
					'index' => 'containerinstanceid',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'id' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'FolderID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'foldercode' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'FolderCode',
				),
				'output' => array(
					'index' => 'code',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'caption' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'Caption',
				),
				'output' => array(
					'index' => 'caption',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'date' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'ArticleDate',
				),
				'output' => array(
					'index' => 'date',
				),
				'datatype' => Point::DATATYPE_DATE,
			)),
			'description' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'Description',
				),
				'output' => array(
					'index' => 'description',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'istreetop' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'isTreeTop',
				),
				'output' => array(
					'index' => 'istreetop',
				),
				'datatype' => Point::DATATYPE_BOOLEAN,
			)),
			'defaultfolio' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'DefaultFolio',
				),
				'output' => array(
					'index' => 'defaultfolio',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'objecttype' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'ObjectType',
				),
				'output' => array(
					'index' => 'objecttype',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'partialrecordindex' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_LOOKUP_PARTIAL,
					'recordtypeindex' => 'objecttype',
					'arrayname' => 'containerpartials',
				),
				'output' => array(
					'index' => 'partial_container',
				),
				'datatype' => Point::DATATYPE_STRING,
			)), 
			'adminpartialrecordindex' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_LOOKUP_PARTIAL,
					'recordtypeindex' => 'objecttype',
					'arrayname' => 'admincontainerpartials',
				),
				'output' => array(
					'index' => 'partial_container_record',
				),
				'datatype' => Point::DATATYPE_STRING,
			)), 
		)),
	)),
));
