<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()	
->variables(array(
	# =================================================================
	# --------------------[ common global data ]------------------------
	# =================================================================
	'id' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'ID',
		),
		'output' => array(
			'index' => 'id',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'id',
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'masterrecord',
			'field' => 'ID',
		),
		'datatype' => Point::DATATYPE_INTEGER,
	)),
	'recordtype' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'ObjectType',
		),
		'output' => array(
			'index' => 'recordtype',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'imageid' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'Image',
		),
		'output' => array(
			'index' => 'imageid',
		),
		'datatype' => Point::DATATYPE_INTEGER,
	)),
	'imagetitle' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_SELF,
		),
		'output' => array(
			'index' => 'imagetitle',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'imagecaption' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_SELF,
		),
		'output' => array(
			'index' => 'imagecaption',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'imagedescription' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_SELF,
		),
		'output' => array(
			'index' => 'imagedescription',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'smallimageurl' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_SELF,
		),
		'output' => array(
			'index' => 'smallimageurl',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	// imageurl; imagetitle, and imagecaption, imagedescription, smallimageurl are generated as side-effects
	'imagedata' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_LOOKUP_RECORD_IMAGEDATA,
			'recordtypeindex' => 'recordtype',
			'imageidindex' => 'imageid', // get imageid
			'recordidindex' => 'id', // for 'picture' record type, or target link
			'smallimageurlindex'=> 'smallimageurl',
			'imagedescriptionindex' => 'imagedescription',
			'imagecaptionindex' => 'imagecaption',
			'imagetitleindex' => 'imagetitle',
		),
		'output' => array(
			'index' => 'largeimageurl',
		),
		'datatype' => Point::DATATYPE_STRING,
	)), 
	'contentcount' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_CONTENTCOUNT,
			'idindex' => 'id',
		),
		'output' => array(
			'index' => 'contentcount',
		),
		'datatype' => Point::DATATYPE_MIXED,
	)),
	'blogcode' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'BlogCode',
		),
		'output' => array(
			'index' => 'code',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'code',
			'constraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
		),
		'rules' => array(
			array('not_empty'),
			array('regex', array(':value', '/^[A-Z]\w++$/D')),
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'extensionrecord',
			'field' => 'BlogCode',
		),
		'datatype' => Point::DATATYPE_STRING,
		'constraint' => array(
			'name' => 'objecttype',
			'value' => 'blog',
		),
	)),
	'pagecode' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'PageCode',
		),
		'output' => array(
			'index' => 'code',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'code',
			'constraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
		),
		'rules' => array(
			array('regex', array(':value', '/^[A-Za-z]\w++$/D')),
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'extensionrecord',
			'field' => 'PageCode',
		),
		'datatype' => Point::DATATYPE_STRING,
		'constraint' => array(
			'name' => 'objecttype',
			'value' => 'page',
		),
	)),
	'foldercode' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'FolderCode',
		),
		'output' => array(
			'index' => 'code',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'code',
			'constraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
		),
		'rules' => array(
			array('regex', array(':value', '/^[A-Za-z]\w++$/D')),
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'extensionrecord',
			'field' => 'FolderCode',
		),
		'datatype' => Point::DATATYPE_STRING,
		'constraint' => array(
			'name' => 'objecttype',
			'value' => 'folder',
		),
	)),
	'is_favourite' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ISFAVOURITE,
			'articleidref' => 'id',
		),
		'output' => array(
			'index' => 'is_favourite',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
	)),
	'emptybody' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'EmptyBody',
		),
		'output' => array(
			'index' => 'emptybody',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
	)),
	'is_comments' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ISCOMMENTS,
			'articleidref' => 'id',
		),
		'output' => array(
			'index' => 'is_comments',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
		'notconstraint' => array(
			'name' => 'objecttype',
			'value' => 'comment',
		),
	)),
	'is_attachments' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ISATTACHMENTS,
			'articleidref' => 'id',
		),
		'output' => array(
			'index' => 'is_attachments',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
		'notconstraint' => array(
			'name' => 'objecttype',
			'value' => 'comment',
		),
	)),
	'is_narrative' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ISNARRATIVE,
			'valueref' => 'emptybody',
		),
		'output' => array(
			'index' => 'is_narrative',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
		'notconstraint' => array(
			'name' => 'objecttype',
			'value' => 'comment',
		),
	)),
	'is_articleancillarydata' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ISANCILLARYDATA,
			'blockrefs' => array('is_comments','is_attachments'),
		),
		'output' => array(
			'index' => 'is_articleancillarydata',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
		'notconstraint' => array(
			'name' => 'objecttype',
			'value' => 'comment',
		),
	)),
	'is_containerancillarydata' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ISANCILLARYDATA,
			'blockrefs' => array('is_comments','is_attachments','is_narrative'),
		),
		'output' => array(
			'index' => 'is_containerancillarydata',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
		'notconstraint' => array(
			'name' => 'objecttype',
			'value' => 'comment',
		),
	)),
	'approval' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'Approval',
		),
		'output' => array(
			'index' => 'approval',
		),
/*		'access' => array(
			'token' => 'article_settings',
			'requires' => 'R',
		), */
		'access' => array(
			'permission' => 'canedit',
		),
		'default' => 'D',
		'datatype' => Point::DATATYPE_STRING,
	)),
	'defaultfolio' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'DefaultFolio',
		),
		'output' => array(
			'index' => 'defaultfolio',
		),
		'datatype' => Point::DATATYPE_STRING,
		'constraint' => (object) array(
			'constraints' => array(
				array(
					'name' => 'objecttype',
					'value' => 'folder',
				),
				array(
					'name' => 'objecttype',
					'value' => 'inbox',
				),
				array(
					'name' => 'objecttype',
					'value' => 'file',
				),
				array(
					'name' => 'objecttype',
					'value' => 'directory',
				),
			),
			'condition' => 'OR',
		),
	)),
	'title' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'Title',
		),
		'output' => array(
			'index' => 'title',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'title',
			'constraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
		),
		'rules' => array(
			array('not_empty'),
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'masterrecord',
			'field' => 'Title',
		),
		'datatype' => Point::DATATYPE_STRING,
		'notconstraint' => (object) array(
			'constraints' => array(
				array(
					'name' => 'objecttype',
					'value' => 'comment',
				),
				array(
					'name' => 'objecttype',
					'value' => 'directory',
				),
			),
			'condition' => 'OR',
		),
	)),
	'directorytitle' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'Title',
		),
		'output' => array(
			'index' => 'title',
		),
		'datatype' => Point::DATATYPE_STRING,
		'constraint' =>	array(
			'name' => 'objecttype',
			'value' => 'directory',
		),
	)),
	'messagesection' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_VARIABLE,
			'name' => 'messagesection',
		),
		'output' => array(
			'index' => 'messagesection',
		),
		'datatype' => Point::DATATYPE_ARRAY,
	)),
	# =================================================================
	# --------------------[ narrative section ]------------------------
	# =================================================================
	'narrativesection' => Point::section()
	->properties(array(
		'output' => array(
			'index' => 'narrativesection',
		),
		'input' => array(
			'index' => 'narrativesection',
			'constraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
		),
	))
	->variables(array(
		# display fields
		'imageurl' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Image',
			),
			'output' => array(
				'index' => 'imageurl',
			),
			'rules' => array(
				array('Services::validate_picture_id'),
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'imageurl',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Image',
			),
			'datatype' => Point::DATATYPE_STRING,
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'caption' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Caption',
			),
			'output' => array(
				'index' => 'caption',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'caption',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Caption',
			),
			'datatype' => Point::DATATYPE_STRING,
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'date' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ArticleDate',
			),
			'output' => array(
				'index' => 'date',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'date',
			),
			'rules' => array(
				array('not_empty'),
				array('date'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ArticleDate',
			),
			'default' => Date('r'),
			'datatype' => Point::DATATYPE_DATE,
		)),
		'location' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Location',
			),
			'output' => array(
				'index' => 'location',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'location',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Location',
			),
			'datatype' => Point::DATATYPE_STRING,
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'source' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Source',
			),
			'output' => array(
				'index' => 'source',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'source',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Source',
			),
			'datatype' => Point::DATATYPE_STRING,
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'description' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Description',
			),
			'output' => array(
				'index' => 'description',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'description',
			),
			'rules' => array(
				array('max_length',array(':value',255)),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Description',
			),
			'datatype' => Point::DATATYPE_STRING,
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'embedcode' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'EmbedCode',
			),
			'output' => array(
				'index' => 'displayembedcode',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'widget',
			),
		)),
		'displaybody' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Body',
				'filter' => array(
					'method' => Point::FILTER_MARKUP,
					'arguments' => array(
						'parser' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'MarkupTypeID',
						),
					),
				),
			),
			'output' => array(
				'index' => 'displaybody',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		# edit fields
		'editembedcode' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'EmbedCode',
			),
			'output' => array(
				'index' => 'embedcode',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'embedcode',
			),
			'rules' => array(
				array('max_length',array(':value',65536)),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'EmbedCode',
				'filter' => array(
					'method' => Point::FILTER_PURIFYTRUSTED,
				),
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'edit',
						'value' => TRUE,
					),
					array(
						'name' => 'objecttype',
						'value' => 'widget',
					),
				),
			),
		)),
		'editbody' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Body',
			),
			'output' => array(
				'index' => 'body',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'body',
			),
			'rules' => array(
				array('max_length',array(':value',65536)),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Body',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
		)),
		'binderid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'BinderID',
			),
			'output' => array(
				'index' => 'binderid',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'binderoptions' => Point::selectoptions()
		->properties(array( // selectionvariable
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'BinderID',
			),
			'output' => array(
				'index' => 'binderoptions',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'binderoption',
			),
			'rules' => array(
				array('not_empty'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'BinderID',
				),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'edit',
				'value' => TRUE,
			),
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		))
		->driver(array( // optiondata
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'binderoptions',
			),
			'datapoolarray' => array(
				'name' => 'binderoption',
				'index' => 'value',
				'value' => 'caption',
			),
			'selectionvariable' => 'binder',
		))
		->variables(array( // optionrow
			'value' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'binderoption',
					'index' => 'value',
					
				),
				'output' => array(
					'index' => 'value',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'caption' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'binderoption',
					'index' => 'caption',
				),
				'output' => array(
					'index' => 'caption',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'selected' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_MATCH,
					'match' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'binder',
						'blockindex' => 'value',
					),
				),
				'output' => array(
					'index' => 'selected',
				),
				'datatype' => Point::DATATYPE_BOOLEAN,
			)),
		)),
		'bindertitle' => Point::variable(array(	
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'BinderTitle',
			),
			'output' => array(
				'index' => 'bindertitle',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'binderidpreview' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_BLOCKVALUE,
				'path' => array('narrativesection'),
				'name' => 'binderoptions',
			),
			'output' => array(
				'index' => 'binderidpreview',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'preview',
				'value' => TRUE,
			),
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'bindertitlepreview' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_BLOCKVALUE,
				'name' => 'binderoptions',
				'filter' => array(
					'method' => Point::FILTER_LOOKUP,
					'arguments' => array(
						'name' => 'Binders',
						'index' => 'ID',
						'value' => 'Title',
					),
				),
			),
			'output' => array(
				'index' => 'bindertitlepreview',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'preview',
				'value' => TRUE,
			),
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'embedcodepreview' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_BLOCKVALUE,
				'name' => 'editembedcode',
				'filter' => array(
					'method' => Point::FILTER_PURIFYTRUSTED,
				),
			),
			'output' => array(
				'index' => 'embedcodepreview',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'preview',
						'value' => TRUE,
					),
					array(
						'name' => 'objecttype',
						'value' => 'widget',
					),
				),
			),
		)),
		'bodypreview' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_BLOCKVALUE,
				'name' => 'editbody',
				'filter' => array(
					'method' => Point::FILTER_MARKUP,
					'arguments' => array(
						'parser' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'masterrecord',
							'field' => 'MarkupTypeID',
						),
					),
				),
			),
			'output' => array(
				'index' => 'bodypreview',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'preview',
				'value' => TRUE,
			),
		)),
		# specialized fields
		'url' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'URL',
			),
			'output' => array(
				'index' => 'url',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'url',
			),
			'rules' => array(
				array('url'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'URL',
			),
			'datatype' => Point::DATATYPE_STRING,
			'notconstraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'docfilename' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FileName',
			),
			'output' => array(
				'index' => 'filename',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'filename',
			),
			'rules' => array(
				array('Services::validate_filetype', array(':value',array('pdf', 'doc', 'xls','odt','fodt','ods','fods',))),
				array('regex', array(':value', '/^[\S]*$/D')),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'FileName',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'docfile',
			),
		)),
		'picfilename' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FileName',
			),
			'output' => array(
				'index' => 'filename',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'filename',
			),
			'rules' => array(
				array('regex', array(':value', '/^[\S]*$/D')),
				array('Services::validate_filetype', array(':value', array('jpg', 'png', 'gif',))),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'FileName',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'picture',
			),
		)),
		'directory' => Point::variable(array(	
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'Directory',
			),
			'output' => array(
				'index' => 'directory',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'repositoryid' => Point::selectoptions()
		->properties(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'RepositoryID',
			),
			'output' => array(
				'index' => 'repositoryidoptions',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'repositoryid',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'RepositoryID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => (object) array(
				'constraints' => array(
					(object) array(
						'constraints' => array(
							array(
								'name' => 'objecttype',
								'value' => 'docfile',
							),
							array(
								'name' => 'edit',
								'value' => TRUE,
							),
						),
					),
					(object) array(
						'constraints' => array(
							array(
								'name' => 'objecttype',
								'value' => 'picture',
							),
							array(
								'name' => 'edit',
								'value' => TRUE,
							),
						),
					),
				),
			),
		))
		->driver(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_LOOKUP_TABLE,
				'name' => 'System_Repositories',
				'index' => 'ID',
				'value' => 'Directory',
			),
			'datapoolarray' => array(
				'name' => 'repositoryid',
				'index' => 'value',
				'value' => 'caption',
			),
			'selectionvariable' => 'repositoryid',
		))
		->variables(array(
			'value' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'repositoryid',
					'index' => 'value',
					
				),
				'output' => array(
					'index' => 'value',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'caption' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'repositoryid',
					'index' => 'caption',
				),
				'output' => array(
					'index' => 'caption',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'selected' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_MATCH,
					'match' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'repositoryid',
						'blockindex' => 'value',
					),
				),
				'output' => array(
					'index' => 'selected',
					'filter' => array(
						'method' => Point::FILTER_SELECTED,
					),
				),
				'datatype' => Point::DATATYPE_BOOLEAN,
			)),
		)),
		'istreetop' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'isTreeTop',
			),
			'output' => array(
				'index' => 'istreetop',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'istreetop',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'isTreeTop',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
					array(
						'name' => 'objecttype',
						'value' => 'file',
					),
					array(
						'name' => 'objecttype',
						'value' => 'inbox',
					),
				),
				'condition' => 'OR',
			),
		)),
		'defaultorder' => Point::variable(array(
			'input' => array (
				'method' => POINT::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'defaultorder',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'DefaultOrder',
			),
			'rules' => array(
				array('not_empty'),
				array('regex', array(':value', '/^Title|ArticleDate$/D')),
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
					array(
						'name' => 'objecttype',
						'value' => 'file',
					),
					array(
						'name' => 'objecttype',
						'value' => 'inbox',
					),
					array(
						'name' => 'objecttype',
						'value' => 'directory',
					),
				),
				'condition' => 'OR',
			),
		)),
		'titleselected' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DefaultOrder',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'Title',
					),
				),
			),
			'recover' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'defaultorder',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'Title',
					),
				),
			),
			'output' => array(
				'index' => 'titleselected',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
					array(
						'name' => 'objecttype',
						'value' => 'file',
					),
					array(
						'name' => 'objecttype',
						'value' => 'inbox',
					),
					array(
						'name' => 'objecttype',
						'value' => 'directory',
					),
				),
				'condition' => 'OR',
			),
		)),
		'dateselected' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DefaultOrder',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'ArticleDate',
					),
				),
			),
			'recover' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'defaultorder',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'ArticleDate',
					),
				),
			),
			'output' => array(
				'index' => 'dateselected',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
					array(
						'name' => 'objecttype',
						'value' => 'file',
					),
					array(
						'name' => 'objecttype',
						'value' => 'inbox',
					),
					array(
						'name' => 'objecttype',
						'value' => 'directory',
					),
				),
				'condition' => 'OR',
			),
		)),
		'defaultdirection' => Point::variable(array(
			'input' => array (
				'method' => POINT::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'defaultdirection',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'DefaultDirection',
			),
			'rules' => array(
				array('not_empty'),
				array('regex', array(':value', '/^ASC|DESC$/D')),
			),
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
					array(
						'name' => 'objecttype',
						'value' => 'file',
					),
					array(
						'name' => 'objecttype',
						'value' => 'inbox',
					),
					array(
						'name' => 'objecttype',
						'value' => 'directory',
					),
				),
				'condition' => 'OR',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'ascendingselected' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DefaultDirection',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'ASC',
					),
				),
			),
			'recover' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'defaultdirection',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'ASC',
					),
				),
			),
			'output' => array(
				'index' => 'ascendingselected',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
					array(
						'name' => 'objecttype',
						'value' => 'file',
					),
					array(
						'name' => 'objecttype',
						'value' => 'inbox',
					),
					array(
						'name' => 'objecttype',
						'value' => 'directory',
					),
				),
				'condition' => 'OR',
			),
		)),
		'descendingselected' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DefaultDirection',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'DESC',
					),
				),
			),
			'recover' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'defaultdirection',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => 'DESC',
					),
				),
			),
			'output' => array(
				'index' => 'descendingselected',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
					array(
						'name' => 'objecttype',
						'value' => 'file',
					),
					array(
						'name' => 'objecttype',
						'value' => 'inbox',
					),
					array(
						'name' => 'objecttype',
						'value' => 'directory',
					),
				),
				'condition' => 'OR',
			),
		)),
		'defaultfolios' => Point::selectoptions()
		->properties(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'DefaultFolio',
			),
			'output' => array(
				'index' => 'defaultfolios',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'defaultfolio',
			),
			'rules' => array(
				array('not_empty'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'DefaultFolio',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => (object) array(
				'constraints' => array(
					array(
						'name' => 'objecttype',
						'value' => 'folder',
					),
					array(
						'name' => 'objecttype',
						'value' => 'file',
					),
					array(
						'name' => 'objecttype',
						'value' => 'inbox',
					),
					array(
						'name' => 'objecttype',
						'value' => 'directory',
					),
				),
				'condition' => 'OR',
			),
			'default' => 'planks',
		))
		->driver(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VALUE,
				'value' => array(
//					'list' => 'List', // column 3
					'planks' => 'Planks', // 1
//					'panes' => 'Panes', // 1
//					'table' => 'Table', // 1
//					'smalltiles' => 'Small Tiles', // inline
//					'mediumtiles' => 'Medium Tiles', // 4
					'largetiles' => 'Large Tiles', // 3
					'gallery' => 'Gallery', // 2
//					'columns' => 'Columns', // column 2
				),
			),
			'datapoolarray' => array(
				'name' => 'defaultfolio',
				'index' => 'value',
				'value' => 'caption',
			),
			'selectionvariable' => 'folio',
		))
		->variables(array(
			'value' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'defaultfolio',
					'index' => 'value',
					
				),
				'output' => array(
					'index' => 'value',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'caption' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'defaultfolio',
					'index' => 'caption',
				),
				'output' => array(
					'index' => 'caption',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'selected' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_MATCH,
					'match' => array(
						'method' => Point::DATASOURCE_VARIABLE,
						'name' => 'folio',
						'blockindex' => 'value',
					),
				),
				'output' => array(
					'index' => 'selected',
					'filter' => array(
						'method' => Point::FILTER_SELECTED,
					),
				),
				'datatype' => Point::DATATYPE_BOOLEAN,
			)),
		)),
		# ---------------[ containerslist data ]------------- #
		'containerslist' => Point::sectionlist()
		->properties(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_TABLEACTIVERECORD,
				'tableindex' => 'containerstable',
				'orderby' => array(
					array('Title','ASC'),
				),
			),
			'output' => array(
				'index' => 'containerslist',
			),
			'notconstraint' => array(
				'name' => 'containerslist',
				'value' => 'notrequired',
			),
		))
		->variables(array(
			'containerinstanceid' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'InstanceID',
				),
				'output' => array(
					'index' => 'containerinstanceid',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'id' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'ID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'foldercode' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'FolderCode',
				),
				'output' => array(
					'index' => 'code',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'caption' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'Caption',
				),
				'output' => array(
					'index' => 'caption',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'date' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'ArticleDate',
				),
				'output' => array(
					'index' => 'date',
				),
				'datatype' => Point::DATATYPE_DATE,
			)),
			'description' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'Description',
				),
				'output' => array(
					'index' => 'description',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'istreetop' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'isTreeTop',
				),
				'output' => array(
					'index' => 'istreetop',
				),
				'datatype' => Point::DATATYPE_BOOLEAN,
			)),
			'objecttype' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'containersrecord',
					'field' => 'ObjectType',
				),
				'output' => array(
					'index' => 'objecttype',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'partialrecordindex' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_LOOKUP_PARTIAL,
					'recordtypeindex' => 'objecttype',
					'arrayname' => 'containerpartials',
				),
				'output' => array(
					'index' => 'partial_container',
				),
				'datatype' => Point::DATATYPE_STRING,
			)), 
		)),
		# ---------------[ page child list data ]------------- #
		'pagechildlist' => Point::sectionlist()
		->properties(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_TABLEACTIVERECORD,
				'tableindex' => 'pagechildtable',
				'orderby' => array(
					array('Title','ASC'),
				),
				'callback' => array( // to Node::set_table_constraints($responder,$nodename,$tableindex); see method property below
					'method' => array('Node','set_table_constraints'),
					'tableindex'=>'pagechildtable', // datamodel index
				),
			),
			'output' => array(
				'index' => 'pagechildren',
			),
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'page',
			),
		))
		->variables(array(
			'id' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pagechildrecord',
					'field' => 'ID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'code' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pagechildrecord',
					'field' => 'PageCode',
				),
				'output' => array(
					'index' => 'code',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pagechildrecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'caption' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pagechildrecord',
					'field' => 'Caption',
				),
				'output' => array(
					'index' => 'caption',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'date' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pagechildrecord',
					'field' => 'ArticleDate',
				),
				'output' => array(
					'index' => 'date',
				),
				'datatype' => Point::DATATYPE_DATE,
			)),
			'description' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pagechildrecord',
					'field' => 'Description',
				),
				'output' => array(
					'index' => 'description',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
		)),
		# ---------------[ blogrecord data ]------------- #
		'blogrecord' => Point::section()
		->properties(array(
			'output' => array(
				'index' => 'blogrecord',
			),
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'entry',
			),
		))
		->variables(array(
			'blogid' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'blogrecord',
					'field' => 'ID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
			)),
			'blogcode' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'blogrecord',
					'field' => 'BlogCode',
				),
				'output' => array(
					'index' => 'blogcode',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'blogrecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
		)),
		# ---------------[ page parent data ]------------- #
		'pageparentid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'PageParentID',
			),
			'output' => array(
				'index' => 'pageparentid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'pageparentid',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'PageParentID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'page',
			),
		)),
		'pageparentrecord' => Point::section()
		->properties(array(
			'output' => array(
				'index' => 'pageparentrecord',
			),
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'page',
			),
		))
		->variables(array(
			'id' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pageparentrecord',
					'field' => 'ID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
				'notconstraint' => array(
					'name' => 'insertmode',
					'value' => TRUE,
				),
			)),
			'code' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pageparentrecord',
					'field' => 'PageCode',
				),
				'output' => array(
					'index' => 'code',
				),
				'datatype' => Point::DATATYPE_STRING,
				'notconstraint' => array(
					'name' => 'insertmode',
					'value' => TRUE,
				),
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'pageparentrecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
				'notconstraint' => array(
					'name' => 'insertmode',
					'value' => TRUE,
				),
			)),
		)),
		# ---------------[ comment article data ]------------- #
		'commentarticleid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'CommentArticleID',
			),
			'output' => array(
				'index' => 'commentarticleid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'commentarticleid',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'extensionrecord',
				'field' => 'CommentArticleID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
		)),
		'commentarticlerecord' => Point::section()
		->properties(array(
			'output' => array(
				'index' => 'commentarticlerecord',
			),
			'constraint' => array(
				'name' => 'objecttype',
				'value' => 'comment',
			),
			'notconstraint' => array(
				'name' => 'insertmode',
				'value' => TRUE,
			),
		))
		->variables(array(
			'id' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'ID',
				),
				'output' => array(
					'index' => 'id',
				),
				'datatype' => Point::DATATYPE_INTEGER,
				'notconstraint' => array(
					'name' => 'insertmode',
					'value' => TRUE,
				),
			)),
			'entryparentcode' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'ParentID',
					'filter' => array(
						'method' => Point::FILTER_LOOKUP,
						'arguments' => array(
							'name' => 'Articles_Extensions',
							'index' => 'ArticleID',
							'value' => 'BlogCode',
						),
					),
				),
				'output' => array(
					'index' => 'entryparentcode',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'commoncode' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'CommonCode',
				),
				'output' => array(
					'index' => 'commoncode',
				),
				'datatype' => Point::DATATYPE_STRING,
				'notconstraint' => array(
					'name' => 'insertmode',
					'value' => TRUE,
				),
			)),
			'title' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'Title',
				),
				'output' => array(
					'index' => 'title',
				),
				'datatype' => Point::DATATYPE_STRING,
				'notconstraint' => array(
					'name' => 'insertmode',
					'value' => TRUE,
				),
			)),
			'objecttype' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_ACTIVERECORD,
					'recordindex' => 'commentarticlerecord',
					'field' => 'ObjectType',
				),
				'output' => array(
					'index' => 'objecttype',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
			'partialrecordindex' => Point::variable(array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_LOOKUP_PARTIAL,
					'recordtypeindex' => 'objecttype', // above
					'arrayname' => 'masterpartials',
				),
				'output' => array(
					'index' => 'partial_record',
				),
				'datatype' => Point::DATATYPE_STRING,
			)),
		)),
	)),
	# =================================================================
	# --------------------[ author section ]------------------------
	# =================================================================
	'authorsection' => Point::section()
	->properties(array(
		'output' => array(
			'index' => 'authorsection',
		),
		'input' => array(
			'index' => 'authorsection',
			'constraint' => array(
				'name' => 'editsection',
				'value' => 'author',
			),
		),
		'constraint' => array(
			'name' => 'adminmode',
			'value' => TRUE,
		),
		'notconstraint' => array(
			'name' => 'objecttype',
			'value' => 'comment',
		),
	))
	->variables(array(
		'authornotes' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'AuthorNotes',
			),
			'output' => array(
				'index' => 'authornotes',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'authornotes',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'AuthorNotes',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'authornotesclosed' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'AuthorNotesClosed',
			),
			'output' => array(
				'index' => 'authornotesclosed',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'authornotesclosed',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'AuthorNotesClosed',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'newauthorcode' => Point::variable(array(
			'output' => array(
				'index' => 'newauthorcode',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'newauthorcode',
			),
			'datatype' => Point::DATATYPE_STRING,
			'constraint' => array(
				'name' => 'changeauthor',
				'value' => TRUE,
			),
		)),
	)),
	# =================================================================
	# --------------------[ approval section ]------------------------
	# =================================================================
	'approvalsection' => Point::section()
	->properties(array(
		'output' => array(
			'index' => 'approvalsection',
		),
		'input' => array(
			'index' => 'approvalsection',
			'constraint' => array(
				'name' => 'editsection',
				'value' => 'approval',
			),
		),
		'constraint' => array(
			'name' => 'adminmode',
			'value' => TRUE,
		),
	))
	->variables(array(
		'approvalnotes' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ApproveNotes',
			),
			'output' => array(
				'index' => 'approvalnotes',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'approvalnotes',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'ApproveNotes',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
	)),
	# =================================================================
	# --------------------[ followup section ]------------------------
	# =================================================================
	'followupsection' => Point::section()
	->properties(array(
		'output' => array(
			'index' => 'followupsection',
		),
		'input' => array(
			'index' => 'followupsection',
			'constraint' => array(
				'name' => 'editsection',
				'value' => 'followup',
			),
		),
		'constraint' => array(
			'name' => 'adminmode',
			'value' => TRUE,
		),
		'notconstraint' => array(
			'name' => 'objecttype',
			'value' => 'comment',
		),
	))
	->variables(array(
		'followupnotes' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FollowupNotes',
			),
			'output' => array(
				'index' => 'followupnotes',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'followupnotes',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FollowupNotes',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'followupclosed' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FollowupNotesClosed',
			),
			'output' => array(
				'index' => 'followupclosed',
				'filter' => array(
					'method' => Point::FILTER_CHECKED,
				),
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'followupclosed',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FollowupNotesClosed',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'followupdate' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FollowupDate',
			),
			'output' => array(
				'index' => 'followupdate',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'followupdate',
			),
			'rules' => array(
				array('date'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'masterrecord',
				'field' => 'FollowupDate',
			),
			'datatype' => Point::DATATYPE_DATE,
		)),
	)),
	# =================================================================
	# --------------------[ standard global data ]------------------------
	# =================================================================
	// profile data
	'profile' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'PublicProfile',
		),
		'output' => array(
			'index' => 'profile',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
	)),
	'authorusercode' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'AuthorUserCode',
		),
		'output' => array(
			'index' => 'authorusercode',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'author' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'Author',
		),
		'output' => array(
			'index' => 'author',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'showbyline' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'ShowByline',
		),
		'output' => array(
			'index' => 'showbyline',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'showbyline',
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'masterrecord',
			'field' => 'ShowByline',
		),
		'datatype' => Point::DATATYPE_BOOLEAN,
	)),
	// inform view if articleid was requested
	'articleid' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_VARIABLE,
			'name' => 'articleid',
		),
		'output' => array(
			'index' => 'articleid',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	// audit data
	'createdate' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'CreateDate',
		),
		'output' => array(
			'index' => 'createdate',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'createdate',
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'masterrecord',
			'field' => 'CreateDate',
		),
		'datatype' => Point::DATATYPE_DATETIME,
	)),
	'createuserid' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'CreateUserID',
		),
		'output' => array(
			'index' => 'createuserid',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'createuserid',
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'masterrecord',
			'field' => 'CreateUserID',
		),
		'datatype' => Point::DATATYPE_INTEGER,
	)),
	'createname' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'CreateUserID',
			'filter' => array(
				'method' => Point::FILTER_LOOKUP,
				'arguments' => array(
					'name' => 'Access_Users',
					'index' => 'ID',
					'value' => 'Name',
				),
			),
		),
		'output' => array(
			'index' => 'createname',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'createcode' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'CreateUserID',
			'filter' => array(
				'method' => Point::FILTER_LOOKUP,
				'arguments' => array(
					'name' => 'Access_Users',
					'index' => 'ID',
					'value' => 'Code',
				),
			),
		),
		'output' => array(
			'index' => 'createcode',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'editdate' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'EditDate',
		),
		'output' => array(
			'index' => 'editdate',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'editdate',
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'masterrecord',
			'field' => 'EditDate',
		),
		'datatype' => Point::DATATYPE_DATETIME,
	)),
	'edituserid' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'EditUserID',
		),
		'output' => array(
			'index' => 'edituserid',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'edituserid',
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'masterrecord',
			'field' => 'EditUserID',
		),
		'datatype' => Point::DATATYPE_INTEGER,
	)),
	'editname' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'EditUserID',
			'filter' => array(
				'method' => Point::FILTER_LOOKUP,
				'arguments' => array(
					'name' => 'Access_Users',
					'index' => 'ID',
					'value' => 'Name',
				),
			),
		),
		'output' => array(
			'index' => 'editname',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'editcode' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'EditUserID',
			'filter' => array(
				'method' => Point::FILTER_LOOKUP,
				'arguments' => array(
					'name' => 'Access_Users',
					'index' => 'ID',
					'value' => 'Code',
				),
			),
		),
		'output' => array(
			'index' => 'editcode',
		),
		'datatype' => Point::DATATYPE_STRING,
	)),
	'recordversion' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'RecordVersion',
		),
		'output' => array(
			'index' => 'recordversion',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'recordversion',
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORD,
			'recordindex' => 'masterrecord',
			'field' => 'RecordVersion',
		),
		'datatype' => Point::DATATYPE_INTEGER,
	)),
	'commentarticleid' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'CommentArticleID',
		),
		'output' => array(
			'index' => 'commentarticleid',
		),
		'datatype' => Point::DATATYPE_INTEGER,
		'constraint' => array(
			'name' => 'objecttype',
			'value' => 'comment',
		),
	)),
	'pageparentid' => Point::variable(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'masterrecord',
			'field' => 'PageParentID',
		),
		'output' => array(
			'index' => 'pageparentid',
		),
		'datatype' => Point::DATATYPE_INTEGER,
		'constraint' => array(
			'name' => 'objecttype',
			'value' => 'page',
		),
	)),
));
