<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()
	->variables(array(
		'registerdirect' => Point::variable(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_PERMITTED,
					'access' => array(
						'token' => 'account_register',
						'requires' => 'CR',
					),
				),
				'output' => array(
					'index' => 'registerdirect',
				),
				'datatype' => Point::DATATYPE_BOOLEAN,
			)
		),
		'moderated' => Point::variable(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_VARIABLE,
					'name' => 'moderated',
				),
				'output' => array(
					'index' => 'moderated',
				),
				'datatype' => Point::DATATYPE_BOOLEAN,
			)
		),
/*		'base' => Point::variable(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_VARIABLE,
					'name' => 'base',
				),
				'output' => array(
					'index' => 'base',
				),
				'datatype' => Point::DATATYPE_STRING,
			)
		),
*/
		'registererrors' => Point::variable(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_VARIABLE,
					'name' => 'registererrors',
				),
				'output' => array(
					'index' => 'registererrors',
				),
				'datatype' => Point::DATATYPE_ARRAY,
			)
		),
		'registermessages' => Point::variable(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_VARIABLE,
					'name' => 'registermessages',
				),
				'output' => array(
					'index' => 'registermessages',
				),
				'datatype' => Point::DATATYPE_ARRAY,
			)
		),
		'usercode'=> Point::variable(
			array(
				'output' => array(
					'index' => 'usercode',
				),
				'input' => array (
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'usercode',
				),
				'rules' => array(
					array('not_empty'),
					array('regex', array(':value', '/^[a-zA-Z]\w++$/D')),
				),
				'datatype' => Point::DATATYPE_STRING,
			)
		),
		'password'=> Point::variable(
			array(
				'output' => array(
					'index' => 'password',
				),
				'input' => array (
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'password',
				),
				'rules' => array(
					array('not_empty'),
					array('min_length', array(':value', 5)),
					array('max_length', array(':value', 20)),
					array('matches', array(':validation', ':field', 'confirm')),
				),
				'datatype' => Point::DATATYPE_STRING,
			)
		),
		'confirm'=> Point::variable(
			array(
				'output' => array(
					'index' => 'confirm',
				),
				'input' => array (
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'confirm',
				),
				'datatype' => Point::DATATYPE_STRING,
			)
		),
		'email'=> Point::variable(
			array(
				'output' => array(
					'index' => 'email',
				),
				'input' => array (
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'email',
				),
				'rules' => array(
					array('not_empty'),
					array('email'),
				),
				'datatype' => Point::DATATYPE_STRING,
			)
		),
		'name'=> Point::variable(
			array(
				'output' => array(
					'index' => 'name',
				),
				'input' => array (
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'name',
				),
				'rules' => array(
					array('not_empty'),
				),
				'datatype' => Point::DATATYPE_STRING,
			)
		),
		'city'=> Point::variable(
			array(
				'output' => array(
					'index' => 'city',
				),
				'input' => array (
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'city',
				),
				'rules' => array(
					array('not_empty'),
				),
				'datatype' => Point::DATATYPE_STRING,
			)
		),
		'memo'=> Point::variable(
			array(
				'output' => array(
					'index' => 'memo',
				),
				'input' => array (
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'memo',
				),
				'rules' => array(
					array('not_empty'),
				),
				'datatype' => Point::DATATYPE_STRING,
			)
		),
	));
