<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()	
->variables(array(
'base' => Point::variable(array(
	'retrieve' => array(
		'method' => Point::DATASOURCE_VARIABLE,
		'name' => 'base',
	),
	'output' => array(
		'index' => 'base',
	),
	'datatype' => Point::DATATYPE_STRING,
)),
'rolemessages' => Point::variable(array(
	'retrieve' => array(
		'method' => Point::DATASOURCE_VARIABLE,
		'name' => 'rolemessages',
	),
	'output' => array(
		'index' => 'rolemessages',
	),
	'datatype' => Point::DATATYPE_ARRAY,
)),
'roleerrors' => Point::variable(array(
	'retrieve' => array(
		'method' => Point::DATASOURCE_VARIABLE,
		'name' => 'roleerrors',
	),
	'output' => array(
		'index' => 'roleerrors',
	),
	'datatype' => Point::DATATYPE_ARRAY,
)),
'groupoptions' => Point::selectoptions()
	->properties(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_ACTIVERECORD,
			'recordindex' => 'grouprecord',
			'field' => 'ID',
		),
		'output' => array(
			'index' => 'groupoptions',
		),
		'input' => array(
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'groupoption',
			'constraint' => array(
				'name' => 'changegroup',
				'value' => TRUE,
			),
		),
		'datatype' => Point::DATATYPE_INTEGER,
	))
	->driver(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_LOOKUP_TABLE,
			'name' => 'Access_Groups',
			'index' => 'ID',
			'value' => 'Name',
			'orderby' => array(
				array('Name'),
			),
		),
		'datapoolarray' => array(
			'name' => 'group',
			'index' => 'value',
			'value' => 'caption',
		),
		'selectionvariable' => 'group',
	))
	->variables(array(
		'value' => Point::variable(	array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'group',
				'index' => 'value',
			),
			'output' => array(
				'index' => 'value',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'selected' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_MATCH,
				'match' => array(
					'method' => Point::DATASOURCE_VARIABLE,
					'name' => 'group',
					'blockindex' => 'value',
				),
			),
			'output' => array(
				'index' => 'selected',
				'filter' => array(
					'method' => Point::FILTER_SELECTED,
				),
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'caption' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'group',
				'index' => 'caption',
			),
			'output' => array(
				'index' => 'caption',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
	)
),
'groupid' => Point::variable(array(
	'retrieve' => array(
		'method' => Point::DATASOURCE_ACTIVERECORD,
		'recordindex' => 'grouprecord',
		'field' => 'ID',
	),
	'output' => array(
		'index' => 'groupid',
	),
	'input' => array(
		'method' => Point::DATASOURCE_ARRAY,
		'name' => 'post',
		'index' => 'groupid',
		'notconstraint' => array(
			'name' => 'changegroup',
			'value' => TRUE,
		),
	),
	'datatype' => Point::DATATYPE_INTEGER,
)),
'groupname' => Point::variable(array(
	'retrieve' => array(
		'method' => Point::DATASOURCE_ACTIVERECORD,
		'recordindex' => 'grouprecord',
		'field' => 'Name',
	),
	'output' => array(
		'index' => 'groupname',
	),
	'datatype' => Point::DATATYPE_STRING,
)),
'groupdescription' => Point::variable(array(
	'retrieve' => array(
		'method' => Point::DATASOURCE_ACTIVERECORD,
		'recordindex' => 'grouprecord',
		'field' => 'Description',
	),
	'output' => array(
		'index' => 'groupdescription',
	),
	'datatype' => Point::DATATYPE_STRING,
)),
'records' => Point::sectionlist()
	->properties(array(
		'retrieve' => array(
			'method' => Point::DATASOURCE_TABLEACTIVERECORD,
			'tableindex' => 'roletable',
			'indexvariable' => 'index',
			'referencevariable' => 'reference',
			'referenceprefix' => 'role',
			'recordstatusindex' => 'recordstatus',
			'primarykeyfieldname' => 'ID',
			'primarykeyblockindex' => 'id',
			'newrecordsvariable' => 'newrecordcount',
			'orderby' => array(
				array('Rank'),
				array('Order'),
				array('Name'),
			),
			'zebrastripes' => array(
				'zebravariable' => 'zebraclass',
				'zebravalues' => array('zebraeven','zebraodd'),
			),
		),
		'output' => array(
			'index' => 'records',
		),
		'input' => array(
			'notconstraint' => array(
				'name' => 'changegroup',
				'value' => TRUE,
			),
			'method' => Point::DATASOURCE_ARRAY,
			'name' => 'post',
			'index' => 'roles',
			'referencevariable' => 'reference',
			'recordstatusindex' => 'recordstatus',
		),
		'store' => array(
			'method' => Point::DATATARGET_RECORDSET,
			'tableindex' => 'rolerecords',
			'recordvariable' => 'rolerecord',
		),
		'recordstatusindex' => 'recordstatus',
		'errorindexindex' => 'errorindex',
	))
	->variables(array(
		'zebraclass' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'zebraclass',
			),
			'output' => array(
				'index' => 'zebraclass',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'reference' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'reference',
			),
			'output' => array(
				'index' => 'reference',
			),
			'input' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'reference',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'code' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Code',
			),
			'output' => array(
				'index' => 'code',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','code'),
				'referencevariable' => 'reference',
			),
			'rules' => array(
				array('not_empty'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Code',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'name' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Name',
			),
			'output' => array(
				'index' => 'name',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','name'),
				'referencevariable' => 'reference',
			),
			'rules' => array(
				array('not_empty'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Name',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'description' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Description',
			),
			'output' => array(
				'index' => 'description',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','description'),
				'referencevariable' => 'reference',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Description',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'rank' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Rank',
			),
			'output' => array(
				'index' => 'rank',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','rank'),
				'referencevariable' => 'reference',
			),
			'rules' => array(
				array('not_empty'),
				array('digit'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Rank',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'order' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Order',
			),
			'output' => array(
				'index' => 'order',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','order'),
				'referencevariable' => 'reference',
			),
			'rules' => array(
				array('not_empty'),
				array('digit'),
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Order',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'implicit' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'ImplicitRole',
				'filter' => array(
					'method' => Point::FILTER_COMPARE,
					'arguments' => array(
						'compare' => '1',
					),
				),
			),
			'output' => array(
				'index' => 'implicitchecked',
				'filter' => array(
					'method' => Point::FILTER_CHECKED,
				),
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','implicit'),
				'referencevariable' => 'reference',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'ImplicitRole',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'deletecheckbox' => Point::variable(array(
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','deletecheckbox'),
				'referencevariable' => 'reference',
			),
			'datatype' => Point::DATATYPE_BOOLEAN,
		)),
		'recordstatus' => Point::variable(array(
			'retrieve' => array( // create node for initialization at output
				'method' => Point::DATASOURCE_SELF,
				'self' => NULL,
			),
			'output' => array(
				'index' => 'recordstatus',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','recordstatus'),
				'referencevariable' => 'reference',
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'recordstatusclass' => Point::variable(array(
			'output' => array(
				'index' => 'recordstatusclass',
				'method' => Point::DATASOURCE_CONDITIONAL,
				'blockindex' => 'recordstatus',
				'compare' => array(
					'changed' => 'recordchanged',
					'posted' => 'recordposted',
					'error' => 'recorderror',
				),
			),
			'retrieve' => array( // create node for initialization at output
				'method' => Point::DATASOURCE_SELF,
				'self' => NULL,
			),
			'datatype' => Point::DATATYPE_STRING,
		)),
		'errorindex' => Point::variable(array(
			'input' => array(
				'method' => Point::DATASOURCE_SELF,
				'self' => NULL,
			),
			'output' => array(
				'index' => 'errorindex',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'id' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'ID',
			),
			'output' => array(
				'index' => 'id',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','id'),
				'referencevariable' => 'reference',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'ID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'createdate' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'CreateDate',
			),
			'output' => array(
				'index' => 'createdate',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','createdate'),
				'referencevariable' => 'reference',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'CreateDate',
			),
			'datatype' => Point::DATATYPE_DATE,
		)),
		'createuserid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'CreateUserID',
			),
			'output' => array(
				'index' => 'createuserid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','createuserid'),
				'referencevariable' => 'reference',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'CreateUserID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'editdate' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'EditDate',
			),
			'output' => array(
				'index' => 'editdate',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','editdate'),
				'referencevariable' => 'reference',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'EditDate',
			),
			'datatype' => Point::DATATYPE_DATE,
		)),
		'edituserid' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'EditUserID',
			),
			'output' => array(
				'index' => 'edituserid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','edituserid'),
				'referencevariable' => 'reference',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'EditUserID',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
		'recordversion' => Point::variable(array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'RecordVersion',
			),
			'output' => array(
				'index' => 'recordversion',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'path' => array('roles','recordversion'),
				'referencevariable' => 'reference',
			),
			'store' => array(
				'method' => Point::DATATARGET_RECORD,
				'recordindex' => 'rolerecord',
				'field' => 'RecordVersion',
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)),
	)),
));