<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()	
	->variables(array(
	'base' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'base',
			),
			'output' => array(
				'index' => 'base',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'roletokenmessages' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'roletokenmessages',
			),
			'output' => array(
				'index' => 'roletokenmessages',
			),
			'datatype' => Point::DATATYPE_ARRAY,
		)
	),
	'roletokenerrors' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'roletokenerrors',
			),
			'output' => array(
				'index' => 'roletokenerrors',
			),
			'datatype' => Point::DATATYPE_ARRAY,
		)
	),
	'roleoptions' => Point::optionsection()
	->properties(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'ID',
			),
			'output' => array(
				'index' => 'roleoptions',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'roleoption',
				'constraint' => array(
					'name' => 'changerole',
					'value' => TRUE,
				),
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	)
	->driver(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_LOOKUP_TABLE,
				'name' => 'Access_Group_Roles',
				'index' => 'ID',
				'value' => 'Name',
				'orderby' => array(
					array('Rank'),
					array('Order'),
				),
			),
			'datapoolarray' => array(
				'name' => 'role',
				'index' => 'value',
				'value' => 'caption',
			),
			'selectionvariable' => 'role',
		)
	)
	->variables(
		array(
			'value' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'role',
						'index' => 'value',
						
					),
					'output' => array(
						'index' => 'value',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'selected' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_MATCH,
						'match' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'role',
							'blockindex' => 'value',
						),
					),
					'output' => array(
						'index' => 'selected',
						'filter' => array(
							'method' => Point::FILTER_SELECTED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
				)
			),
			'caption' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'role',
						'index' => 'caption',
					),
					'output' => array(
						'index' => 'caption',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
		)
	),
	'roleid' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'ID',
			),
			'output' => array(
				'index' => 'roleid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'roleid',
				'notconstraint' => array(
					'name' => 'changerole',
					'value' => TRUE,
				),
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	),
	'rolename' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Name',
			),
			'output' => array(
				'index' => 'rolename',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'roledescription' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'Description',
			),
			'output' => array(
				'index' => 'roledescription',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'groupname' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'rolerecord',
				'field' => 'GroupName',
			),
			'output' => array(
				'index' => 'groupname',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'records' => Point::sectionlist()
		->properties(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_TABLEACTIVERECORD,
					'tableindex' => 'roletokentable',
					'indexvariable' => 'index',
					'referencevariable' => 'reference',
					'referenceprefix' => 'roletoken',
					'recordstatusindex' => 'recordstatus',
					'primarykeyfieldname' => 'ID',
					'primarykeyblockindex' => 'id',
					'orderby' => array(
						array('TokenName'),
					),
					'limit' => 300,
					'zebrastripes' => array(
						'zebravariable' => 'zebraclass',
						'zebravalues' => array('zebraeven','zebraodd'),
					),
				),
				'output' => array(
					'index' => 'records',
				),
				'input' => array(
					'notconstraint' => array(
						'name' => 'changerole',
						'value' => TRUE,
					),
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'roletokens',
					'referencevariable' => 'reference',
					'recordstatusindex' => 'recordstatus',
				),
				'store' => array(
					'method' => Point::DATATARGET_RECORDSET,
					'tableindex' => 'roletokenrecords',
					'recordvariable' => 'roletokenrecord',
				),
				'recordstatusindex' => 'recordstatus',
				'errorindexindex' => 'errorindex',
			)		
		)
		->variables(
			array(
				'zebraclass' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'zebraclass',
						),
						'output' => array(
							'index' => 'zebraclass',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'reference' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'reference',
						),
						'output' => array(
							'index' => 'reference',
						),
						'input' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'reference',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'index' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'index',
						),
						'output' => array(
							'index' => 'index',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'id' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'ID',
						),
						'output' => array(
							'index' => 'id',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','id'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'ID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'tokendescription' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'Description',
						),
						'output' => array(
							'index' => 'tokendescription',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'tokenvalue' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'TokenName',
						),
						'output' => array(
							'index' => 'tokenvalue',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','tokenvalue'),
							'referencevariable' => 'reference',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'token' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_BLOCKVALUE,
							'name' => 'tokenvalue',
						),
						'output' => array(
							'index' => 'token',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'create' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Create',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'createchecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','createcheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Create',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'read' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Read',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'readchecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','readcheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Read',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'edit' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Edit',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'editchecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','editcheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Edit',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'delete' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Delete',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'deletechecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','deletecheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Delete',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'deny' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Deny',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'denychecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','denycheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'Deny',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'createdate' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'CreateDate',
						),
						'output' => array(
							'index' => 'createdate',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','createdate'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'CreateDate',
						),
						'datatype' => Point::DATATYPE_DATE,
					)
				),
				'createuserid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'CreateUserID',
						),
						'output' => array(
							'index' => 'createuserid',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','createuserid'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'CreateUserID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'editdate' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'EditDate',
						),
						'output' => array(
							'index' => 'editdate',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','editdate'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'EditDate',
						),
						'datatype' => Point::DATATYPE_DATE,
					)
				),
				'edituserid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'EditUserID',
						),
						'output' => array(
							'index' => 'edituserid',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','edituserid'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'EditUserID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'recordversion' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'RecordVersion',
						),
						'output' => array(
							'index' => 'recordversion',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','recordversion'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'roletokenrecord',
							'field' => 'RecordVersion',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'recordstatus' => Point::variable(
					array(
						'retrieve' => array( // create node for initialization at output
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'output' => array(
							'index' => 'recordstatus',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('roletokens','recordstatus'),
							'referencevariable' => 'reference',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'recordstatusclass' => Point::variable(
					array(
						'output' => array(
							'index' => 'recordstatusclass',
							'method' => Point::DATASOURCE_CONDITIONAL,
							'blockindex' => 'recordstatus',
							'compare' => array(
								'changed' => 'recordchanged',
								'posted' => 'recordposted',
								'error' => 'recorderror',
							),
						),
						'retrieve' => array( // create node for initialization at output
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'errorindex' => Point::variable(
					array(
						'input' => array(
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'output' => array(
							'index' => 'errorindex',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
			)
		),
	));