<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()	
	->variables(array(
	'base' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'base',
			),
			'output' => array(
				'index' => 'base',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'tokenrolemessages' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'tokenrolemessages',
			),
			'output' => array(
				'index' => 'tokenrolemessages',
			),
			'datatype' => Point::DATATYPE_ARRAY,
		)
	),
	'tokenroleerrors' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'tokenroleerrors',
			),
			'output' => array(
				'index' => 'tokenroleerrors',
			),
			'datatype' => Point::DATATYPE_ARRAY,
		)
	),
	'tokenoptions' => Point::optionsection()
	->properties(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'tokenrecord',
				'field' => 'ID',
			),
			'output' => array(
				'index' => 'tokenoptions',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'tokenoption',
				'constraint' => array(
					'name' => 'changetoken',
					'value' => TRUE,
				),
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	)
	->driver(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_LOOKUP_TABLE,
				'name' => 'Access_Tokens',
				'index' => 'ID',
				'value' => 'Name',
				'orderby' => array(
					array('Name'),
				),
			),
			'datapoolarray' => array(
				'name' => 'token',
				'index' => 'value',
				'value' => 'caption',
			),
			'selectionvariable' => 'token',
		)
	)
	->variables(
		array(
			'value' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'token',
						'index' => 'value',
						
					),
					'output' => array(
						'index' => 'value',
					),
					'datatype' => Point::DATATYPE_INTEGER,
				)
			),
			'selected' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_MATCH,
						'match' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'token',
							'blockindex' => 'value',
						),
					),
					'output' => array(
						'index' => 'selected',
						'filter' => array(
							'method' => Point::FILTER_SELECTED,
						),
					),
					'datatype' => Point::DATATYPE_BOOLEAN,
				)
			),
			'caption' => Point::variable(
				array(
					'retrieve' => array(
						'method' => Point::DATASOURCE_ARRAY,
						'name' => 'token',
						'index' => 'caption',
					),
					'output' => array(
						'index' => 'caption',
					),
					'datatype' => Point::DATATYPE_STRING,
				)
			),
		)
	),
	'tokenid' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'tokenrecord',
				'field' => 'ID',
			),
			'output' => array(
				'index' => 'tokenid',
			),
			'input' => array(
				'method' => Point::DATASOURCE_ARRAY,
				'name' => 'post',
				'index' => 'tokenid',
				'notconstraint' => array(
					'name' => 'changetoken',
					'value' => TRUE,
				),
			),
			'datatype' => Point::DATATYPE_INTEGER,
		)
	),
	'tokenname' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'tokenrecord',
				'field' => 'Name',
			),
			'output' => array(
				'index' => 'tokenname',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'tokendescription' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_ACTIVERECORD,
				'recordindex' => 'tokenrecord',
				'field' => 'Description',
			),
			'output' => array(
				'index' => 'tokendescription',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'records' => Point::sectionlist()
		->properties(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_TABLEACTIVERECORD,
					'tableindex' => 'tokenroletable',
					'indexvariable' => 'index',
					'referencevariable' => 'reference',
					'referenceprefix' => 'tokenrole',
					'recordstatusindex' => 'recordstatus',
					'primarykeyfieldname' => 'ID',
					'primarykeyblockindex' => 'id',
					'orderby' => array(
						array('GroupName'),
						array('RoleRank'),
						array('RoleOrder'),
					),
					'zebrastripes' => array(
						'zebravariable' => 'zebraclass',
						'zebravalues' => array('zebraeven','zebraodd'),
					),
				),
				'output' => array(
					'index' => 'records',
				),
				'input' => array(
					'notconstraint' => array(
						'name' => 'changetoken',
						'value' => TRUE,
					),
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'tokenroles',
					'referencevariable' => 'reference',
					'recordstatusindex' => 'recordstatus',
				),
				'store' => array(
					'method' => Point::DATATARGET_RECORDSET,
					'tableindex' => 'tokenrolerecords',
					'recordvariable' => 'tokenrolerecord',
				),
				'recordstatusindex' => 'recordstatus',
				'errorindexindex' => 'errorindex',
			)		
		)
		->variables(
			array(
				'zebraclass' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'zebraclass',
						),
						'output' => array(
							'index' => 'zebraclass',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'reference' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'reference',
						),
						'output' => array(
							'index' => 'reference',
						),
						'input' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'reference',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'index' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'index',
						),
						'output' => array(
							'index' => 'index',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'id' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'ID',
						),
						'output' => array(
							'index' => 'id',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','id'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'ID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'roledescription' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'rolerecord',
							'field' => 'Description',
						),
						'output' => array(
							'index' => 'roledescription',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'rolevalue' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'RoleName',
						),
						'output' => array(
							'index' => 'rolevalue',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','rolevalue'),
							'referencevariable' => 'reference',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'role' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_BLOCKVALUE,
							'name' => 'rolevalue',
						),
						'output' => array(
							'index' => 'role',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'groupname' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'GroupName',
						),
						'output' => array(
							'index' => 'groupname',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'create' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Create',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'createchecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','createcheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Create',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'read' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Read',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'readchecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','readcheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Read',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'edit' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Edit',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'editchecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','editcheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Edit',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'delete' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Delete',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'deletechecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','deletecheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Delete',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'deny' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Deny',
							'filter' => array(
								'method' => Point::FILTER_COMPARE,
								'arguments' => array(
									'compare' => '1',
								),
							),
						),
						'output' => array(
							'index' => 'denychecked',
							'filter' => array(
								'method' => Point::FILTER_CHECKED,
							),
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','denycheckbox'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'Deny',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
				'createdate' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'CreateDate',
						),
						'output' => array(
							'index' => 'createdate',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','createdate'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'CreateDate',
						),
						'datatype' => Point::DATATYPE_DATE,
					)
				),
				'createuserid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'CreateUserID',
						),
						'output' => array(
							'index' => 'createuserid',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','createuserid'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'CreateUserID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'editdate' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'EditDate',
						),
						'output' => array(
							'index' => 'editdate',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','editdate'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'EditDate',
						),
						'datatype' => Point::DATATYPE_DATE,
					)
				),
				'edituserid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'EditUserID',
						),
						'output' => array(
							'index' => 'edituserid',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','edituserid'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'EditUserID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'recordversion' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_ACTIVERECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'RecordVersion',
						),
						'output' => array(
							'index' => 'recordversion',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','recordversion'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrolerecord',
							'field' => 'RecordVersion',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'recordstatus' => Point::variable(
					array(
						'retrieve' => array( // create node for initialization at output
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'output' => array(
							'index' => 'recordstatus',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokenroles','recordstatus'),
							'referencevariable' => 'reference',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'recordstatusclass' => Point::variable(
					array(
						'output' => array(
							'index' => 'recordstatusclass',
							'method' => Point::DATASOURCE_CONDITIONAL,
							'blockindex' => 'recordstatus',
							'compare' => array(
								'changed' => 'recordchanged',
								'posted' => 'recordposted',
								'error' => 'recorderror',
							),
						),
						'retrieve' => array( // create node for initialization at output
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'errorindex' => Point::variable(
					array(
						'input' => array(
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'output' => array(
							'index' => 'errorindex',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
			)
		),
	));