<?php defined('SYSPATH') or die('No direct script access.');
return Point::dictionary()	
	->variables(array(
	'base' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'base',
			),
			'output' => array(
				'index' => 'base',
			),
			'datatype' => Point::DATATYPE_STRING,
		)
	),
	'tokenerrors' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'tokenerrors',
			),
			'output' => array(
				'index' => 'tokenerrors',
			),
			'datatype' => Point::DATATYPE_ARRAY,
		)
	),
	'tokenmessages' => Point::variable(
		array(
			'retrieve' => array(
				'method' => Point::DATASOURCE_VARIABLE,
				'name' => 'tokenmessages',
			),
			'output' => array(
				'index' => 'tokenmessages',
			),
			'datatype' => Point::DATATYPE_ARRAY,
		)
	),
	'records' => Point::sectionlist()
		->properties(
			array(
				'retrieve' => array(
					'method' => Point::DATASOURCE_RECORDSET,
					'tableindex' => 'tokenrecords',
					'recordvariable' => 'tokenrecord',
					'indexvariable' => 'index',
					'referencevariable' => 'reference',
					'referenceprefix' => 'token',
					'recordstatusindex' => 'recordstatus',
					'zebrastripes' => array(
						'zebravariable' => 'zebraclass',
						'zebravalues' => array('zebraeven','zebraodd'),
					),
				),
				'output' => array(
					'index' => 'records',
				),
				'input' => array(
					'method' => Point::DATASOURCE_ARRAY,
					'name' => 'post',
					'index' => 'tokens',
					'referencevariable' => 'reference',
					'recordstatusindex' => 'recordstatus',
				),
				'store' => array(
					'method' => Point::DATATARGET_RECORDSET,
					'tableindex' => 'tokenrecords',
					'recordvariable' => 'tokenrecord',
				),
				'recordstatusindex' => 'recordstatus',
				'errorindexindex' => 'errorindex',
			)		
		)
		->variables(
			array(
				'base' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'base',
						),
						'output' => array(
							'index' => 'base',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'zebraclass' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'zebraclass',
						),
						'output' => array(
							'index' => 'zebraclass',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'reference' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'reference',
						),
						'output' => array(
							'index' => 'reference',
						),
						'input' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'reference',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'index' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_VARIABLE,
							'name' => 'index',
						),
						'output' => array(
							'index' => 'index',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'id' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'ID',
						),
						'output' => array(
							'index' => 'id',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','id'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'ID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'code' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'Code',
						),
						'output' => array(
							'index' => 'code',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','code'),
							'referencevariable' => 'reference',
						),
						'rules' => array(
							array('not_empty'),
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'Code',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'name' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'Name',
						),
						'output' => array(
							'index' => 'name',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','name'),
							'referencevariable' => 'reference',
						),
						'rules' => array(
							array('not_empty'),
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'Name',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'description' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'Description',
						),
						'output' => array(
							'index' => 'description',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','description'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'Description',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'createdate' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'CreateDate',
						),
						'output' => array(
							'index' => 'createdate',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','createdate'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'CreateDate',
						),
						'datatype' => Point::DATATYPE_DATE,
					)
				),
				'createuserid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'CreateUserID',
						),
						'output' => array(
							'index' => 'createuserid',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','createuserid'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'CreateUserID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'editdate' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'EditDate',
						),
						'output' => array(
							'index' => 'editdate',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','editdate'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'EditDate',
						),
						'datatype' => Point::DATATYPE_DATE,
					)
				),
				'edituserid' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'EditUserID',
						),
						'output' => array(
							'index' => 'edituserid',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','edituserid'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'EditUserID',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'recordversion' => Point::variable(
					array(
						'retrieve' => array(
							'method' => Point::DATASOURCE_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'RecordVersion',
						),
						'output' => array(
							'index' => 'recordversion',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','recordversion'),
							'referencevariable' => 'reference',
						),
						'store' => array(
							'method' => Point::DATATARGET_RECORD,
							'recordindex' => 'tokenrecord',
							'field' => 'RecordVersion',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'recordstatus' => Point::variable(
					array(
						'retrieve' => array( // create node for initialization at output
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'output' => array(
							'index' => 'recordstatus',
						),
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','recordstatus'),
							'referencevariable' => 'reference',
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'recordstatusclass' => Point::variable(
					array(
						'output' => array(
							'index' => 'recordstatusclass',
							'method' => Point::DATASOURCE_CONDITIONAL,
							'blockindex' => 'recordstatus',
							'compare' => array(
								'changed' => 'recordchanged',
								'posted' => 'recordposted',
								'error' => 'recorderror',
							),
						),
						'retrieve' => array( // create node for initialization at output
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'datatype' => Point::DATATYPE_STRING,
					)
				),
				'errorindex' => Point::variable(
					array(
						'input' => array(
							'method' => Point::DATASOURCE_SELF,
							'self' => NULL,
						),
						'output' => array(
							'index' => 'errorindex',
						),
						'datatype' => Point::DATATYPE_INTEGER,
					)
				),
				'deletecheckbox' => Point::variable(
					array(
						'input' => array(
							'method' => Point::DATASOURCE_ARRAY,
							'name' => 'post',
							'path' => array('tokens','deletecheckbox'),
							'referencevariable' => 'reference',
						),
						'datatype' => Point::DATATYPE_BOOLEAN,
					)
				),
			)
		),
	));