<?php 
return array (
		'mastertable' => 'users',
		'tables' => array (
			'users' => array
				(
					'tablename' => 'Access_Users',
					'primary_index' => 'id_index',
					'alternate_index' => 'usercode_index',
					'indexes' => array
						(
							'id_index' => array
								(
									'columns' => array('ID'),
									'index_type' => TableModel::UNIQUE
								),
							'usercode_index' => array
								(
									'columns' => array('Code'),
									'index_type' => TableModel::UNIQUE
								)
						),
					'relations' => array
						(
							'user_tokens_relation' => array
								(
									'index' => 'id_index',
									'remote_table' => 'tokens',
									'remote_index' => 'user_id_index',
									'relation_type' => TableModel::ONE_TO_ONE
								),
							'user_roles_relation' => array
								(
									'index' => 'id_index',
									'remote_table' => 'userroles',
									'remote_index' => 'user_id_index',
									'relation_type' => TableModel::ONE_TO_MANY
								),

							'user_pending_relation' => array
								(
									'index' => 'id_index',
									'remote_table' => 'pending',
									'remote_index' => 'user_id_index',
									'relation_type' => TableModel::ONE_TO_ONE
								)

						)
				),
			'userroles' => array
				(
					'tablename' => 'Access_User_Roles',
					'primary_index' => 'id_index',
					'indexes' => array
						(
							'id_index' => array
								(
									'columns' => array('ID'),
									'index_type' => TableModel::UNIQUE
								),
							'user_id_index' => array
								(
									'columns' => array('UserID'),
									'index_type' => TableModel::INDEX
								)
						),
					'relations' => array
						(
							'users_relation' => array
								(
									'index' => 'user_id_index',
									'remote_table' => 'users',
									'remote_index' => 'id_index',
									'relation_type' => TableModel::MANY_TO_ONE
								)
						)
				),
			'tokens' => array
				(
					'tablename' => 'Access_User_Session_Tokens',
					'primary_index' => 'id_index',
					'indexes' => array
						(
							'id_index' => array
								(
									'columns' => array('ID'),
									'index_type' => TableModel::UNIQUE
								),
							'user_id_index' => array
								(
									'columns' => array('UserID'),
									'index_type' => TableModel::UNIQUE
								)
						),
					'relations' => array
						(
							'users_relation' => array
								(
									'index' => 'user_id_index',
									'remote_table' => 'users',
									'remote_index' => 'id_index',
									'relation_type' => TableModel::ONE_TO_ONE
								)
						)
				),

			'pending' => array
				(
					'tablename' => 'Access_Users_Pending',
					'primary_index' => 'id_index',
					'indexes' => array
						(
							'id_index' => array
								(
									'columns' => array('ID'),
									'index_type' => TableModel::UNIQUE
								),
							'user_id_index' => array
								(
									'columns' => array('UserID'),
									'index_type' => TableModel::UNIQUE
								)
						),
					'relations' => array
						(
							'users_relation' => array
								(
									'index' => 'user_id_index',
									'remote_table' => 'users',
									'remote_index' => 'id_index',
									'relation_type' => TableModel::ONE_TO_ONE
								)
						)
				)

			),
	);