<?php 
return array (
	'mastertable' => 'master',
	'tables' => array (
		'master' => array(
			'tablename' => 'Articles_Favourites_View',
			'primary_index' => 'objectid_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('FavouritesID'),
					'index_type' => TableModel::UNIQUE,
				),
				'objectid_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
				'parentid_index' => array(
					'columns' => array('ParentID'),
					'index_type' => TableModel::UNIQUE,
				),
				'pageparentid_index' => array(
					'columns' => array('PageParentID'),
					'index_type' => TableModel::UNIQUE,
				),
				'commentarticleid_index' => array(
					'columns' => array('CommentArticleID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'folders_relation' => array(
					'index' => 'objectid_index',
					'remote_table' => 'containers',
					'remote_index' => 'robjectid_index',
					'relation_type' => TableModel::ONE_TO_MANY,
				),
				'blog_relation' => array(
					'index' => 'parentid_index',
					'remote_table' => 'blog',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
				'page_parent_relation' => array(
					'index' => 'pageparentid_index',
					'remote_table' => 'pageparent',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
				'comment_parent_relation' => array(
					'index' => 'commentarticleid_index',
					'remote_table' => 'commentarticle',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
			),
		),
		'containers' => array(
			'tablename' => 'Nodes_Instances_ParentsAll_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('InstanceID'),
					'index_type' => TableModel::UNIQUE,
				),
				'robjectid_index' => array(
					'columns' => array('NodeID'),
					'index_type' => TableModel::INDEX,
				),
			),
			'relations' => array(
				'content_relation' => array(
					'index' => 'robjectid_index',
					'remote_table' => 'master',
					'remote_index' => 'objectid_index',
					'relation_type' => TableModel::MANY_TO_ONE,
				),
			),
		),
		'blog' => array(
			'tablename' => 'Nodes_Blogs_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'content_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'master',
					'remote_index' => 'parentid_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
			),
		),
		'pageparent' => array(
			'tablename' => 'Nodes_Pages_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'master',
					'remote_index' => 'pageparentid_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
			),
		),
		'commentarticle' => array(
			'tablename' => 'Nodes_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'master',
					'remote_index' => 'commentarticleid_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
			),
		),
	),
);