<?php 
return array (
	'mastertable' => 'master',
	'tables' => array (
		'master' => array
			(
				'tablename' => 'Nodes_Instances_View',
				'primary_index' => 'instanceid_index',
				'indexes' => array
					(
						'instanceid_index' => array
							(
								'columns' => array('InstanceID'),
								'index_type' => TableModel::UNIQUE,
							),
						'nodeid_index' => array
							(
								'columns' => array('ID'),
								'index_type' => TableModel::UNIQUE,
							),
						'blogid_index' => array
							(
								'columns' => array('ParentID'),
								'index_type' => TableModel::UNIQUE,
							),
					),
				'relations' => array
					(
						'containers_relation' => array
							(
								'index' => 'nodeid_index',
								'remote_table' => 'containers',
								'remote_index' => 'nodeid_index',
								'relation_type' => TableModel::ONE_TO_MANY,
							),
						'blog_relation' => array
							(
								'index' => 'blogid_index',
								'remote_table' => 'blog',
								'remote_index' => 'id_index',
								'relation_type' => TableModel::ONE_TO_ONE,
							),
						'collaborators_relation' => array
							(
								'index' => 'nodeid_index',
								'remote_table' => 'collaborators',
								'remote_index' => 'nodeid_index',
								'relation_type' => TableModel::ONE_TO_MANY,
							),
					),
			),
		'containers' => array
			(
				'tablename' => 'Nodes_Instances_ParentsAll_View',
				'primary_index' => 'instanceid_index',
				'indexes' => array
					(
						'instanceid_index' => array
							(
								'columns' => array('InstanceID'),
								'index_type' => TableModel::UNIQUE,
							),
						'nodeid_index' => array
							(
								'columns' => array('NodeID'),
								'index_type' => TableModel::INDEX,
							),
					),
				'relations' => array
					(
						'content_relation' => array
							(
								'index' => 'nodeid_index',
								'remote_table' => 'master',
								'remote_index' => 'nodeid_index',
								'relation_type' => TableModel::MANY_TO_ONE,
							),
					),
			),
		'blog' => array
			(
				'tablename' => 'Nodes_Blogs_View',
				'primary_index' => 'id_index',
				'indexes' => array
					(
						'id_index' => array
							(
								'columns' => array('ID'),
								'index_type' => TableModel::UNIQUE,
							),
					),
				'relations' => array
					(
						'content_relation' => array
							(
								'index' => 'id_index',
								'remote_table' => 'master',
								'remote_index' => 'blogid_index',
								'relation_type' => TableModel::ONE_TO_ONE,
							),
					),
			),
		'collaborators' => array
			(
				'tablename' => 'Articles_Authors_View',
				'primary_index' => 'id_index',
				'audit' => FALSE,
				'concurrency' => FALSE,
				'indexes' => array
					(
						'id_index' => array
							(
								'columns' => array('ID'),
								'index_type' => TableModel::UNIQUE,
							),
						'nodeid_index' => array
							(
								'columns' => array('ArticleID'),
								'index_type' => TableModel::INDEX,
							),
					),
				'relations' => array
					(
						'master_relation' => array
							(
								'index' => 'nodeid_index',
								'remote_table' => 'master',
								'remote_index' => 'nodeid_index',
								'relation_type' => TableModel::MANY_TO_ONE,
							),
					),
			),
	),
);