<?php 
return array(
	'mastertable' => 'master',
	'tables' => array(
		'master' => array(
			'tablename' => 'Nodes_View',
			'basetable' => 'Articles',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
				'blogid_index' => array(
					'columns' => array('ParentID'),
					'index_type' => TableModel::UNIQUE,
				),
				'pageparentid_index' => array(
					'columns' => array('PageParentID'),
					'index_type' => TableModel::UNIQUE,
				),
				'commentarticleid_index' => array(
					'columns' => array('CommentArticleID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'extension_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'extension',
					'remote_index' => 'article_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
				'collaborators_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'collaborators',
					'remote_index' => 'article_index',
					'relation_type' => TableModel::ONE_TO_MANY,
				),
				'containers_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'containers',
					'remote_index' => 'record_id_index',
					'relation_type' => TableModel::ONE_TO_MANY,
				),
				'blog_relation' => array(
					'remote_index' => 'id_index',
					'remote_table' => 'blog',
					'index' => 'blogid_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
				'page_parent_relation' => array(
					'index' => 'pageparentid_index',
					'remote_table' => 'pageparent',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
				'comment_parent_relation' => array(
					'index' => 'commentarticleid_index',
					'remote_table' => 'commentarticle',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
				'page_children_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'pagechildren',
					'remote_index' => 'parentid_index',
					'relation_type' => TableModel::ONE_TO_MANY,
				),
			),
		),
		'extension' => array(
			'tablename' => 'Articles_Extensions',
			'primary_index' => 'id_index',
			'audit' => FALSE,
			'concurrency' => FALSE,
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
				'article_index' => array(
					'columns' => array('ArticleID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'article_index',
					'remote_table' => 'master',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
			),
		),
		'collaborators' => array(
			'tablename' => 'Articles_Authors_View',
			'primary_index' => 'id_index',
			'audit' => FALSE,
			'concurrency' => FALSE,
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
				'article_index' => array(
					'columns' => array('ArticleID'),
					'index_type' => TableModel::INDEX,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'article_index',
					'remote_table' => 'master',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::MANY_TO_ONE,
				),
			),
		),
		'containers' => array(
			'tablename' => 'Nodes_Instances_ParentsAll_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
				'record_id_index' => array(
					'columns' => array('NodeID'),
					'index_type' => TableModel::INDEX,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'record_id_index',
					'remote_table' => 'master',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::MANY_TO_ONE,
				),
			),
		),
		'blog' => array(
			'tablename' => 'Nodes_Blogs_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'master',
					'remote_index' => 'blogid_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
			),
		),
		'pageparent' => array(
			'tablename' => 'Nodes_Pages_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'master',
					'remote_index' => 'pageparentid_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
			),
		),
		'pagechildren' => array(
			'tablename' => 'Nodes_Pages_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'parentid_index' => array(
					'columns' => array('PageParentID'),
					'index_type' => TableModel::INDEX,
				),
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'parentid_index',
					'remote_table' => 'master',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::MANY_TO_ONE,
				),
			),
		),
		'commentarticle' => array(
			'tablename' => 'Nodes_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'master_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'master',
					'remote_index' => 'commentarticleid_index',
					'relation_type' => TableModel::ONE_TO_ONE,
				),
			),
		),
	),
);