<?php 
return array (
	'mastertable' => 'tokens',
	'tables' => array(
		'groups' => array(
			'tablename' => 'Access_Groups',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'groups_roles_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'roles',
					'remote_index' => 'groupid_index',
					'relation_type' => TableModel::ONE_TO_MANY,
				),
			),
		),
		'roles' => array(
			'tablename' => 'Access_Group_Roles_View',
			'basetable' => 'Access_Group_Roles',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
				'groupid_index' => array(
					'columns' => array('GroupID'),
					'index_type' => TableModel::INDEX,
				),
			),
			'relations' => array(
				'roles_roletokens_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'roletokens',
					'remote_index' => 'roleid_index',
					'relation_type' => TableModel::ONE_TO_MANY,
				),
				'roles_groups_relation' => array(
					'index' => 'groupid_index',
					'remote_table' => 'groups',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::MANY_TO_ONE,
				),
			),
		),
		'tokens' => array(
			'tablename' => 'Access_Tokens',
			'primary_index' => 'id_index',
			'alternate_index' => 'tokencode_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
				'tokencode_index' => array(
					'columns' => array('Code'),
					'index_type' => TableModel::UNIQUE,
				),
			),
			'relations' => array(
				'tokens_roletokens_relation' => array(
					'index' => 'id_index',
					'remote_table' => 'roletokens',
					'remote_index' => 'tokenid_index',
					'relation_type' => TableModel::ONE_TO_MANY,
				),
			),
		),
		'roletokens' => array(
			'tablename' => 'Access_Role_Tokens_View',
			'primary_index' => 'id_index',
			'indexes' => array(
				'id_index' => array(
					'columns' => array('ID'),
					'index_type' => TableModel::UNIQUE,
				),
				'roleid_index' => array(
					'columns' => array('RoleID'),
					'index_type' => TableModel::INDEX,
				),
				'tokenid_index' => array(
					'columns' => array('TokenID'),
					'index_type' => TableModel::INDEX,
				),
			),
			'relations' => array(
				'roletokens_tokens_relation' => array(
					'index' => 'tokenid_index',
					'remote_table' => 'tokens',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::MANY_TO_ONE,
				),
				'roletokens_roles_relation' => array(
					'index' => 'roleid_index',
					'remote_table' => 'roles',
					'remote_index' => 'id_index',
					'relation_type' => TableModel::MANY_TO_ONE,
				),
			),
		),
	),
);
